/* eslint-disable strict,new-cap*/
/**
 * 
 */

var ThirdScanAuth = function () { },
    KEY_GLOBAL_WECHAT_STATE = 'GLOBAL_SCAN_STATE';

ThirdScanAuth.prototype = {
    create: function (name) {
        if (typeof (ThirdScanAuth[name]) !== 'function') {
            return;
        }
        return new ThirdScanAuth[name]();
    }

};

function setScanData (data) {
    return localStorage.setItem(data.key, data.value);
}

function getScanData (key) {
    return localStorage.getItem(key);
}

// 钉钉扫码认证
ThirdScanAuth.dingtalk = function () { // eslint-disable-line new-cap
    this.name = _('钉钉');
    this.apiUrl = 'https://g.alicdn.com/dingding/dinglogin/0.0.5/ddLogin.js?portal_rnd=' + SF_VERSION;
    this.checkApi = function () {
        return typeof DDLogin !== 'undefined';
    },
    this.getConfig = function (options, events) {
        return top.getScanAuthConfig(options, events);
    },
    this.createQrcode = function (containerId, loadId, data) {
        var config = data.dingTalkQrcodeConf,
            url = encodeURIComponent(config.redirect_uri),
            goto = config.require_url + '?appid=' + config.appid +
                    '&response_type=' + config.response_type + '&scope=' + config.scope + '&state=' + config.state + '&redirect_uri=' + url,
            obj = null,
            handleMessage = null;
        obj = DDLogin({ // eslint-disable-line no-undef
            id: containerId,
            goto: encodeURIComponent(goto),
            style: 'background-color:#fff;border:0;margin-top:-40px;margin-left:-145px;'
        });
        window.getId(loadId).style.display = 'none';

        // 用户扫描之后将获取的loginTmpCode通过window.parent.postMessage(loginTmpCode,'*');返回网站。采用以下方法可获取loginTmpCode
        handleMessage = function (event) {
            var origin = event.origin,
                loginTmpCode = event.data,
                qrcodeIframe = top.document.getElementById('scan_qrcode_iframe');

            //判断是否来自ddLogin扫码事件
            if (origin === 'https://login.dingtalk.com') {

               
                // 兼容AIO客户端钉钉认证
                qrcodeIframe.src = goto + '&loginTmpCode=' + loginTmpCode;

                // 清除定时器
                window.clearTimeoutCheck && window.clearTimeoutCheck(); // eslint-disable-line no-undef
            }
        };
        if (typeof window.addEventListener !== 'undefined') {
            window.addEventListener('message', handleMessage, false);
        } else if (typeof window.attachEvent !== 'undefined') {
            window.attachEvent('onmessage', handleMessage);
        }
    },
    this.scanAuth = function (options, events) {
        return true;
    };
};

// 企业微信扫码认证
ThirdScanAuth.qywechat = function () {
    this.name = _('企业微信');
    this.apiUrl = 'https://rescdn.qqmail.com/node/ww/wwopenmng/js/sso/wwLogin-1.0.0.js?portal_rnd=' + SF_VERSION;
    this.customApiUrlPath = 'qyWechatQrcodeConf.qrCodeApiUrl'; // 自定义apiUrl获取路径
    var qrcodeContainer = document.getElementById('qrcodeContainer');
    if (qrcodeContainer) {
        qrcodeContainer.style.marginTop = '-35px'; // 将企业微信自己渲染的标题推上去
    }
    this.checkApi = function () {
        return typeof WwLogin !== 'undefined';
    },
    this.getConfig = function (options, events) {
        return top.getScanAuthConfig(options, events);
    },
    this.createQrcode = function (containerId, loadId, data) {
        var config = data.qyWechatQrcodeConf;
        var sdpcAddress = top.getSdpcAddress();
        var obj = window.WwLogin({
            id: containerId,
            appid: config.appid,
            agentid: config.agentid,
            redirect_uri: encodeURIComponent(config.redirect_uri),
            state: config.state,
            href: sdpcAddress + '/portal/wechat_qrcode.css?portal_rnd=' + SF_VERSION // 注意目前企业微信第三方接口样式修改，只支持https协议
        });
        window.getId(loadId).style.display = 'none';
    },
    this.scanAuth = function (options, events) {
        return top.getScanAuthConfig(options, events);
    };
    this.scanType = 'qywechat'; // 定义扫码类型
};

// 口袋助理扫码认证
ThirdScanAuth.moa = function () {
    this.name = _('口袋助理');
    this.getConfig = function (options, events) {
        return top.getScanAuthConfig(options, events);
    },
    this.createQrcode = function (containerId, loadId, data) {
        var iframe = document.createElement('iframe');
        iframe.src = 'https://web.kd77.cn/clogin?did=5777214&session=3e2758000000000033ad005e0100a12b&portal_rnd=' + SF_VERSION;
        //iframe.classList = 'moa-box';
        window.getId(containerId).appendChild(iframe);
        window.getId(loadId).style.display = 'none';
    },
    this.scanAuth = function (options, events) {
        return top.getScanAuthConfig(options, events);
    };
};
