#!/bin/bash

# 1. 初始化日志,日志只保留最近一次执行的信息
log_file="/root/.aTrust/logs/RepairDataseShell.log"
echo "repair shell log init" &> "${log_file}" 

# 2. 停止服务和进程
echo "[info] prepare to repair database, stop service and processes"
systemctl stop aTrustDaemon.service &>> "${log_file}"
killall aTrustTray &>> "${log_file}"

# 3. 执行修复
echo "[info] start to repair database ..."
"/usr/share/sangfor/aTrust/resources/bin/ConfigUpgrade" &>> "${log_file}"
if [ $? -eq 0 ]; then
    systemctl restart aTrustDaemon.service &>> "${log_file}"
    echo "[info] repair database successed, please restart client"
    exit 0
else
    echo "[error] repair database failed, please collect and check log"
    exit 1
fi