#!/bin/bash

### BEGIN INIT INFO
# Provides:          aTrust
# Required-Start:    $all
# Required-Stop:     $all
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Start or stop the aTrustDaemon.
### END INIT INFO

# Starts the at daemon
# Source function library.
RETVAL=0
APPHOME="/usr/share/sangfor/aTrust/resources"
PROG="${APPHOME}/bin/aTrustAgent"
ARGS="--plugin plugin-daemon --plugin-cmd |"
STOP_TRAY_ARGS="-- -s stop"
TRAY_SH_PATH="${APPHOME}/shell/aTrustTrayStart.sh"
start() {
        ${PROG} ${ARGS} 1>/dev/null 2>&1 &
        RETVAL=$?
        return $RETVAL
}

stop() {
        ${TRAY_SH_PATH} ${STOP_TRAY_ARGS}
        #先kill，杀不死的时候直接强制杀死
        if killall ${PROG} ;then
                killall -9 ${PROG}
        fi
        RETVAL=$?
        return $RETVAL
}

restart() {
        stop
        start
}

reload() {
        restart
}

case "$1" in
start)
        start
        ;;
stop)
        stop
        ;;
reload|restart)
        restart
        ;;
*)
        echo $"Usage: $0 {start|stop|restart}"
        exit 1
esac

exit $?
exit $RETVAL
