#!/bin/bash

#atrust的东西都安装在/usr/share/aTrust目录下
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/X11/bin:$PATH
export PATH
LOGFILE="/tmp/com.sangfor.aTrustTray.script.start.log"

#导入托盘语言环境变量，现在先固定使用中文，后续适配国际化之后再找动态获取系统环境变量的方法。
#export LANG=zh_CN.UTF-8
#export LANGUAGE=zh_CN
touch $LOGFILE
chmod 777 $LOGFILE
echo "start...." >$LOGFILE
date >>$LOGFILE
export CLUTTER_IM_MODULE=fcitx
export GTK_IM_MODULE=fcitx
export QT_IM_MODULE=fcitx
export XMODIFIERS=@im=fcitx
export QT4_IM_MODULE=fcitx
LANG=""
LANGUAGE=""
SYSTEM_TYPE=""
SYSTEM_VERSION_ID=''=''
languagefile="/etc/default/locale"

username=""
userUid=""
#osArch=$(uname -m)

#系统判断,lsb_release适应所有linux系统
detect_distro() {
  RELEASE_ID=$(lsb_release -i | cut -f2)
  SYSTEM_VERSION_ID=$(lsb_release -r | cut -f2)

  case $RELEASE_ID in
  ubuntu | Ubuntu | UBUNTU)
    SYSTEM_TYPE=ubuntu
    ;;
  *)
    SYSTEM_TYPE=unkown
    ;;
  esac
  if [ "${SYSTEM_TYPE}" == "ubuntu" ]; then
    echo "set xcb path" >>$LOGFILE
    export QT_QPA_PLATFORM_PLUGIN_PATH=/usr/share/sangfor/aTrust/resources/lib
  fi
}

#通过fcitx获取系统语言
getcurrentlanguage()
{
  oldIFS=$IFS
  #先通过fcitx获取
  for fcitxpid in $(ps -aux | grep fcitx | grep -v "grep" |  awk '{print $2}'); do
    echo "get fcitx pid:$fcitxpid" >>$LOGFILE
    #获取用户名和显示位置
    declare -A propertys
    while IFS="=" read key value ; do
      propertys[${key}]="${value}"
    done < <(cat /proc/$fcitxpid/environ | tr "\0" "\n" | grep LANG)
    echo "get current LANG:${propertys[LANG]}, LANGUAGE:${propertys[LANGUAGE]}" >>$LOGFILE
    if [ ${propertys[LANG]} != "" ] && [ ${propertys[LANGUAGE]} != "" ]; then
      LANG=${propertys[LANG]}
      LANGUAGE=${propertys[LANGUAGE]}
      export LANG=${propertys[LANG]}
      export LANGUAGE=${propertys[LANGUAGE]}
      break
    fi
  done
  #为空通过文件获取
  if [ "${LANG}" == "" ] || [ "${LANGUAGE}" == "" ]; then
    while IFS="=" read key value ; do
      if [[ "${key}" == \#* ]]; then
        continue
      fi
      propertys[${key}]="${value}"
      propertys[${key}]="$(echo "${value}" | sed 's/\"//g')"
      echo "get ${languagefile}:${key}=${propertys[${key}]}" >>$LOGFILE
    done < ${languagefile}
      LANG=${propertys[LANG]}
      LANGUAGE=${propertys[LANGUAGE]}
      export LANG=${propertys[LANG]}
      export LANGUAGE=${propertys[LANGUAGE]}
  fi

  #为空通过文件获取
  if [ "${LANG}" == "" ] || [ "${LANGUAGE}" == "" ]; then
    while IFS="=" read key value ; do
      if [[ "${key}" == \#* ]]; then
        continue
      fi
      propertys[${key}]="${value}"
      propertys[${key}]="$(echo "${value}" | sed 's/\"//g')"
      echo "get ${HOME}/.config/locale.conf:${key}=${propertys[${key}]}" >>$LOGFILE
    done < ${HOME}/.config/locale.conf
      LANG=${propertys[LANG]}
      LANGUAGE=${propertys[LANGUAGE]}
      export LANG=${propertys[LANG]}
      export LANGUAGE=${propertys[LANGUAGE]}
  fi

  #最后设置为默认中文
  IFS=${oldIFS}
  if [ "${LANG}" == "" ] || [ "${LANGUAGE}" == "" ]; then
    export LANGUAGE=zh_CN
    export LANG=zh_CN.UTF-8
  fi
}


#是否是可登陆的用户
can_login_user()
{
  if [ $# -lt 1 ]; then
    echo "can_login_user params error" >>$LOGFILE
    return 1
  fi
  local username_in=$1
  #检测用户名是否为空，以及是否是不可登录用户（当图形化界面没有用户登录时，上面可能会获取到图形管理用户，而该用户时不可登录的）
  if [ -z "${username_in}" ] || (getent passwd | awk -F ':' 'match($7,/[(nologin)|(false)]$/){print $1}' | grep -qE "^${username_in}$"); then
    echo "username_in:${username_in} is empty or belongs to nologin users, will not start the tray" >>$LOGFILE
    return 1
  fi
  return 0
}

getcurrentuser()
{
   oldIFS=$IFS
   #获取用户名和显示位置
   declare -A property
   for session in $(loginctl --no-legend list-sessions | awk '{ print $1 }' ); do

   while IFS="=" read key value ; do
     property[${key}]="${value}"
   done < <(loginctl show-session "${session}")

   if [ "${property[Type]}" = "x11" ] || [ "${property[Type]}" = "wayland" ]; then
     display=${property[Display]}
     userUid=${property[User]}
     tmp_user=$(id -nu "${userUid}")
     echo "get userUid:${userUid} and tmp_user:${tmp_user}" >>$LOGFILE
     if [ "${property[Active]}" = "yes" ] && can_login_user "${tmp_user}";then
       #通过了才给赋值，否则后面的判空会没有意义
       username=${tmp_user}
       break;
     fi
   fi
   done

   if [ "${username}" == "" ] || [ "${username}" == "root" ]; then
     echo "install can't get pc login name:${username}, can't install..." >>$LOGFILE
     exit 1
   fi

   #还原原始分割符
   IFS=${oldIFS}
   echo "current get username:<${username}> and display:<${display}>" >>$LOGFILE
   if [ "$DISPLAY" == "" ]; then
     if [ "${display}" == "" ]; then
       #前面没有获取到，尝试使用w -h来获取，如果获取也失败，则使用默认的
       if (w -h |awk 'match($3,/^:[0-9]+/){print $1}' |grep -qw "${username}"); then
         display=$(w -h |grep ${username} |awk 'match($3,/^:[0-9]+/){print $3}' |head -n 1);
       else
         display=":0"
       fi
     fi
    	echo "no DISPLAY set, so get display:${display}" >>$LOGFILE
   	export DISPLAY=${display}
   fi

   home_dir=$(getent passwd ${userUid} | awk -F ":" '{print $6}')
   if [ "$HOME" == "" ] || [ "$HOME" == "/root" ]; then
    	echo "no HOME set, so get login user:${username} and home_dir:${home_dir}" >>$LOGFILE
     if [ -d "${home_dir}" ]; then
       export HOME=${home_dir}
     else
       echo "${home_dir} not exist can not be continue" >>$LOGFILE
       exit 1
     fi
   fi

   #以sudo -u user执行该脚本时，需要给DBUS_SESSION_BUS_ADDRESS环境变量添加值,否则就是默认的disabled:,将无法打开目录
   #DBUS_SESSION_BUS_ADDRESS环境变量使能够找到session bus进行注册和通讯
     dbus_user_path="/run/user/$(id -u ${username})/bus"
     if [ -e "${dbus_user_path}" ]; then
       DBUS_SESSION_BUS_ADDRESS="unix:path=/run/user/$(id -u ${username})/bus"
       export DBUS_SESSION_BUS_ADDRESS
       XDG_RUNTIME_DIR="/run/user/$(id -u ${username})"
       export XDG_RUNTIME_DIR
     else
       current_dbus_address=$(grep "DBUS_SESSION_BUS_ADDRESS=" ${home_dir}/.dbus/session-bus/* |head -n1 |cut -d= -f2- |tr -d "\'")
       if [ "${current_dbus_address}" != "" ]; then
         export DBUS_SESSION_BUS_ADDRESS="${current_dbus_address}"
       fi
     fi

     if [ ${SYSTEM_TYPE} == "ubuntu" ] && [[ ${SYSTEM_VERSION_ID} == 16* ]] ; then
       if [ -e "${XDG_RUNTIME_DIR}/dbus-session" ]; then
        dbus_session_file="${XDG_RUNTIME_DIR}/dbus-session"
        DBUS_SESSION_BUS_ADDRESS=$(cat "${dbus_session_file}")
        # shellcheck disable=SC2163
        export "${DBUS_SESSION_BUS_ADDRESS}"
       else
         dbus_session_file="/run/user/1000/dbus-session"
         DBUS_SESSION_BUS_ADDRESS=$(cat "${dbus_session_file}")
         # shellcheck disable=SC2163
         export "${DBUS_SESSION_BUS_ADDRESS}"
       fi
     fi
}
detect_distro
getcurrentuser
getcurrentlanguage

printenv >>$LOGFILE
#程序所在目录
#cd $(dirname $0)
#aTrust客户端的安装目录
ATRUST_HOME=/usr/share/sangfor/aTrust
#aTrustTray文件所在位置
ATRUSTTARY=$ATRUST_HOME/aTrustTray

umask u=rwx,g=rwx,o=rwx
#所有启动场景都需要--no-sandbox参数，aTrustCore中也会通过调用此脚本启动linux托盘，外面不带此参数，所以此处需要加。
arr_parameter[0]="--no-sandbox"

# shellcheck disable=SC2048
for i in $* ; do
    if [ "$i" != "--" ] ; then
        arr_parameter[${#arr_parameter[@]}]="$i" ;
    fi
done

#启动ATRUSTTARY程序
params="${arr_parameter[*]}"
echo "start args:$params" >>$LOGFILE

#杀死之前浏览器拉起的ATRUSTTARY进程
killall -9 ${ATRUSTTARY} >>$LOGFILE 2>&1

$ATRUSTTARY $params >>$LOGFILE &

start_ret=$?
if [ ${start_ret} -ne 0 ]
then
  echo "start error:${start_ret} !" >>$LOGFILE
  exit 1
fi
echo "start over!" >>$LOGFILE
date >>$LOGFILE

exit 0
