#!/bin/bash

input_display=$1

# 适配vnc场景，获取对应的leader pid
proc_id=$(vncserver --list 2>/dev/null | awk -v display="$input_display" '$1~display{print $NF}')
if [ -n "$proc_id" ]; then
    leader_proc_id=$(ps -o ppid= -p "$(ps -o sess= -p "$proc_id")")
fi

# 获取所有合法用户的会话标识符
session_ids=$(loginctl list-sessions | awk '$2 ~ /^[0-9]+$/ {print $1}')

# 循环遍历所有会话标识符
for session_id in $session_ids
do
# 获取当前会话的 DISPLAY 环境变量
    display=$(loginctl show-session -p Display $session_id | awk -F= '{print $2}')

# 比对 DISPLAY 环境变量是否与输入的一致
    if [ "$display" = "$input_display" ]; then
    # 输出匹配的会话标识符
        echo "$session_id"
        exit 0
    fi
    if [ -n "$proc_id" ]; then
  # 获取当前会话的 DISPLAY 环境变量
        session_leader=$(loginctl show-session -p Leader $session_id | awk -F= '{print $2}')
# 比对 Leader是否与输入display对应的session leader的一致
        if [ "$session_leader" = "$leader_proc_id" ]; then
    # 输出匹配的会话标识符
            echo "$session_id"
            exit 0
    fi
    fi

done
exit 1
