const Log=require("../service/util/logger");const WindowManager=require("../controller/window_manager");const Common=require("../service/common");const Util=require("../service/util/util");const Language=require("../service/language");const ErrorCode=require("../common/errorcode");const LOG_TAG="[NotifyMsgManager]";class NotifyMsgManager{constructor(){this.trayController=null;this.winListMap=new Map;this.eventConfigure={"^[a-zA-Z]+\\|notifymsg$":{winID:Common.WIN_MESSAGE_ID,dispatch:this.addMsgtoWindow},"^[a-zA-Z]+\\|logout$":{winID:Common.WIN_NOTIFY_ID,dispatch:this.dealEvLogout},"^[a-zA-Z]+\\|tunnelAccess$":{winID:Common.WIN_MESSAGE_ID,dispatch:this.addMsgtoWindow},"^updateEvent\\|[a-zA-Z]+$":{winID:Common.WIN_UPDATE_ID,dispatch:this.addMsgtoWindow},"^[a-zA-Z]+\\|login$":{winID:Common.WIN_MESSAGE_ID,dispatch:this.dealEvLogin},"^[a-zA-Z]+\\|online$":{winID:Common.WIN_MESSAGE_ID,dispatch:this.dealEvLogin},"^[a-zA-Z]+\\|MITMCheckMsg$":{winID:Common.WIN_MESSAGE_ID,dispatch:this.dealMIMTCheckMsg},"^[a-zA-Z]+\\|commonMsg$":{winID:Common.WIN_MESSAGE_ID,dispatch:this.dealCommonMsg},"^[a-zA-Z]+\\|currVirtualNetChanged$":{winID:Common.WIN_VIRTUALNET_MESSAGE_ID,dispatch:this.dealVirtualNetChangeMessage}}}setTrayController(e){this.trayController=e}dealEventMsg(o,n){Log.info(LOG_TAG,"dealEventMsg recv message: topic -> ",o,"; content -> ",n);for(var e in this.eventConfigure){if(o.match(e)&&this.eventConfigure[e].dispatch){var t=this.eventConfigure[e].winID;try{var a=JSON.parse(n);a.trayBounds=this.trayController.getTrayBounds();this.eventConfigure[e].dispatch(this,t,o.split("|")[1],JSON.stringify(a))}catch(e){Log.warn(LOG_TAG,"notify_manager dealEventMsg error message: topic-> ",o,"; content ->",n)}return}}Log.warn(LOG_TAG,"notify_manager dealEventMsg unsupport message: topic-> ",o,"; content ->",n)}createWindow(e,o){Log.info(LOG_TAG,"[createWindow] winID[%s]",o);var n=WindowManager.createWindow(o);e.winListMap.set(o,n)}addMsgtoWindow(e,o,n,t){Log.info(LOG_TAG,"[addMsgtoWindow] winID[%s], event[%s], message[%s]",o,n,t);if(o==null)return;if(!e.winListMap.has(o)){if(o==Common.WIN_UPDATE_ID&&(n==Common.UPDATE_EVENT_BEGIN_CONSULT||n==Common.UPDATE_EVENT_END_CONSULT)){return}Log.info(LOG_TAG,"[addMsgtoWindow] winID[%s] is not exist, will create",o);e.createWindow(e,o)}var a=e.winListMap.get(o);if(a._isDestroyed||!a.window.window){Log.info(LOG_TAG,"[addMsgtoWindow] winID[%s] is destroyed, will recreate",o);if(n==Common.UPDATE_STATUS_DOWNLOADING)return;e.winListMap.delete(o);e.createWindow(e,o);a=e.winListMap.get(o)}if(a._isDestroyed||!a.window.window){Log.error(LOG_TAG,"event %s addMsgtoWindow failed, message:%s",n,t,"Reason","target window is not exist");return}a.addMessage(n,t)}dealEvLogin(e,o,n,t){Log.info(LOG_TAG,"[dealEvLogin] winID[%s], event[%s], message[%s]",o,n,t);var a=e.winListMap.get(Common.WIN_NOTIFY_ID);var i=null;try{i=JSON.parse(t)}catch(e){Log.warn(LOG_TAG,"%s josn parse in %s failed.",t,n);return}if(a!=null&&!a.isDestroyed()){Log.info(LOG_TAG,"[dealEvLogin] winID[%s] is exist, hide",o);a.hide()}Log.info(LOG_TAG,"[dealEvLogin] type[%s]",i.data.type);if(typeof i.data.type!="undefined"&&i.data.type!="passportTokenOnline"&&i.data.type!="recoverLogin"){Log.info(LOG_TAG,"[dealEvLogin] addMsgtoWindow winID[%s]",o);e.addMsgtoWindow(e,o,n,t)}else{Log.info(LOG_TAG,"[dealEvLogin] type[%s], not need addMsgtoWindow",i.data.type)}}dealEvLogout(e,o,n,t){Log.info(LOG_TAG,"[dealEvLogout] winID[%s], event[%s], message[%s]",o,n,t);var a=null;try{a=JSON.parse(t)}catch(e){Log.warn(LOG_TAG,"%s josn parse in %s failed.",t,n);return}Log.info(LOG_TAG,"[dealEvLogout] type[%s]",a.data.type);if(typeof a.data.type!="undefined"&&(a.data.type!="self"&&a.data.type!="passportTokenLogout")&&a.data.type!="force"){Log.info(LOG_TAG,"[dealEvLogout] addMsgtoWindow winID[%s]",o);e.addMsgtoWindow(e,o,n,t)}else{Log.info(LOG_TAG,"[dealEvLogout] type[%s], not need addMsgtoWindow",a.data.type)}}dealMIMTCheckMsg(e,o,n,t){Log.info(LOG_TAG,"[dealMIMTCheckMsg] winID[%s], event[%s], message[%s]",o,n,t);var a=null;var i=Util.deepClone(Common.WIN_OPTION_TEMPLATE);i.winName=Common.WIN_MIMTCHECKMSG_NAME;try{a=JSON.parse(t);i.url=Common.WIN_URL_ADD_PARAM_GENERAL_MESSAGE_WND(Common.WIN_COMMON_MESSAGE_URL,a.data);Log.info(LOG_TAG,"[dealMIMTCheckMsg] createMIMTCheckMsgWindow winOptions[%s]",i);WindowManager.createMIMTCheckMsgWindow(i)}catch(e){Log.warn(LOG_TAG,"dealMIMTCheckMsg error message: ",t)}}dealVirtualNetChangeMessage(e,o,n,t){try{Log.info(LOG_TAG,"[dealVirtualNetChangeMessage] winID[%s], event[%s], message[%s]",o,n,t);var a=JSON.parse(t);if(a.data.status==0){Log.info(LOG_TAG,"Virtual net change start: ",a.data.domainId);return}Log.info(LOG_TAG,"Virtual net change finish: ",a.data.domainId);e.addMsgtoWindow(e,o,n,JSON.stringify({event:"virtualNetChange",data:{code:a.data.status,message:a.data.message,subtitle:a.data.title}}))}catch(e){Log.warn(LOG_TAG,"dealVirtualNetChangeMessage error message: ",t)}}createForceCommonWindow(e,o){Log.info(LOG_TAG,"createForceCommonWindow start");var n=Util.deepClone(Common.WIN_OPTION_TEMPLATE);n.winName=e;try{n.url=o;WindowManager.createForceCommonWindow(n)}catch(e){Log.warn(LOG_TAG,"createForceCommonWindow error")}}resetClient(e){Log.warn(LOG_TAG,"resetClient");this.createForceCommonWindow(Common.WIN_FORCERESET_NAME,Language.Config.get(Language.Lib.WIN_FORCERESET_URL));Common.responseSendResult(e,{code:ErrorCode.ERROR_SUCCESS,message:"ok",data:{}})}}module.exports=new NotifyMsgManager;