const child_process=require("child_process");const Path=require("path");const fs=require("fs");const Language=require("../service/language");const Log=require("../service/util/logger");const Common=require("../service/common");const Assert=require("assert");const LOG_TAG="[qttray_controller]";const NORMAL_LAUNCH_TIME_INTERVAL=5*1e3;const ABNORMAL_LAUNCH_TIME_INTERVAL=2*1e3;const ABNORMAL_LAUNCH_MAX_COUNT=3;const ABNORMAL_LAUNCH_DELAY_TIME=5*1e3;class QtTrayController{constructor(){this.trayDelegate=null;this.procHandleOfQtTray=null;this.timeoutID=null;this.abnormalLaunchTimes=0;this.launchDelay=10;this.launchTimes=[];this.needRelaunch=true}reset(){if(this.timeoutID!=null){clearTimeout(this.timeoutID);this.timeoutID=null}this.launchTimes=[];this.launchDelay=10;this.abnormalLaunchTimes=0}setDelegate(e){Assert(e,"AdapterQTTray setDelegate:delegate is null");this.trayDelegate=e}destroy(){Log.info(LOG_TAG,"Kill the Qt tray process");this.killProcess()}launchTray(e=true){if(e){this.reset()}Log.info(LOG_TAG,`WorkSpace will pulling up the QT tray isNormalLaunch:${e}`);let t=Language.Config.getCurrentLanguage();t=["-l",`${t}`];let s=Path.join(Common.DEFAULT_AGENT_DIR,"../../../aTrust/aTrustTray2");if(!fs.existsSync(s)){Log.error(LOG_TAG,`WorkSpace launch tray failed`,`file(${s}) not exist`);return}this.procHandleOfQtTray=null;this.procHandleOfQtTray=child_process.spawn(s,[...t],{stdio:"ignore"});const i=this;let a=false;this.procHandleOfQtTray.on("close",(t,s)=>{if(a)return;a=true;Log.info(LOG_TAG,`WorkSpace child process exit code:${t} signal:${s}`);if(t!==0){let e=Error();e.code=t;e.signal=s;i.abnormalLaunchHandle(e)}});this.procHandleOfQtTray.on("error",e=>{if(a)return;a=true;Log.info(LOG_TAG,`WorkSpace child process err:${e}`);i.abnormalLaunchHandle(e)})}moveElement(e,t){if(Math.abs(t)>e.length)t=t%e.length;return e.slice(-t).concat(e.slice(0,-t))}abnormalLaunchHandle(e){if(!this.needRelaunch){return}let t=(new Date).getTime();if(this.launchTimes.length<ABNORMAL_LAUNCH_MAX_COUNT){this.launchTimes.push(t)}else{this.launchTimes=this.moveElement(this.launchTimes,-1);this.launchTimes[this.launchTimes.length-1]=t}++this.abnormalLaunchTimes;const s=this.launchTimes.length;if(s>=2){let e=t-this.launchTimes[s-2];if(e>=NORMAL_LAUNCH_TIME_INTERVAL+this.launchDelay){this.reset();this.launchTimes.push(t);++this.abnormalLaunchTimes}const i=this.launchTimes[s-1]-this.launchTimes[0];if(i<=ABNORMAL_LAUNCH_TIME_INTERVAL&&s===ABNORMAL_LAUNCH_MAX_COUNT){this.launchDelay=ABNORMAL_LAUNCH_DELAY_TIME}}Log.warn(LOG_TAG,"Failed to start the QT Tray program",e);Log.info(LOG_TAG,"Try pulling up the QT tray again. times=%d",this.abnormalLaunchTimes);this.timeoutID=setTimeout(()=>{this.launchTray(false)},this.launchDelay)}killProcess(){if(this.procHandleOfQtTray!=null){this.needRelaunch=false;this.procHandleOfQtTray.kill();this.procHandleOfQtTray=null}}}module.exports=QtTrayController;