const Assert=require("assert");const Log=require(".././service/util/logger");const Common=require(".././service/common");const Util=require(".././service/util/util");const AppConfig=require("../model/app_config");const Protocal=require(".././service/protocal.js");const NotifyMsgManager=require("../controller/notifymsg_manager");const ErrorCode=require(".././common/errorcode");const os=require("os");const fs=require("fs");const util=require("util");const CommonEvent=require("../service/protocal");const Language=require("../service/language");const HistoryAddr=require("../service/history_addr");const SettingController=require("./setting_controller");const MainWinController=require("./mainwin_controller");const EaioController=require("./eaio_controller");const checker=require("../service/util/checker");const to=require("await-to-js").default;const Is=require("is");const SWITCH_SDPC_URL_INTERVAL=200;const LOG_TAG="[tray_controller]";const LOG_PORTAL_TAG="[portal]";const RETRY_ONLINE_TIME_FACTOR=2;const RETRY_ONLINE_TIME_BASE=1e3;const RETRY_ONLINE_MAX_TIMES=5;class TrayController{constructor(){this.trayView=null;this.trayStatus=null;this.uemStatus=null;this.uemInfo=null;this.panelWindow=null;this.firstLogin=true;this.agentCheckerTimer=null;this.recheckStaIntervalId=null;this.bClientLogin=false;this.bClientLogout=false;this.shouldShowPanel=os.platform()===Common.SYS_WIN32||os.platform()===Common.SYS_MAC;this.onlineCurrentRetryTimes=0;this.onlineRetryTimeout=RETRY_ONLINE_TIME_BASE;this.initFlag=true;Log.info(LOG_TAG,"trayController init success")}onAppSuspend(){Log.info(LOG_TAG,"[PowerEvent] system sleep start");this.monitorAgentCancel();this.recheckStatusStop();this.stopAgentChecker()}onAppResume(){Log.info(LOG_TAG,"[PowerEvent] system sleep end");this.startService(true);this.monitorAgent();this.onGetUserStatus();MainWinController.sendEventMsgToMainWindow({event:CommonEvent.EVENT_APP_RESUME,data:{}})}setShouldShowPanel(e){this.shouldShowPanel=e}setPanelWindowUrl(e){if(!this.panelWindow){Log.info(LOG_TAG,"panelWindow not exsit");return}this.panelWindow.url=e;this.panelWindow.window.url=e;this.panelWindow.window.window.loadURL(e)}startTray(){Log.info(LOG_TAG,"startTray");if(!this.trayView){if(os.platform()===Common.SYS_LINUX){const e=require("../view/qttray_view");this.trayView=new e;this.trayView.setDelegate(this);this.trayView.launchTray()}else{const t=require("../view/tray_view");this.trayView=new t}}this.trayView.setDelegate(this)}eaioStartUemVirtualNetRpcService(){if(os.platform()!==Common.SYS_LINUX){return}if(this.wsRpcServer!=null){return}Log.info(LOG_TAG,"[eaioStartUemVirtualNetRpcService]");const e=require("../service/util/rpc_SdpWorkSpaceServer");this.wsRpcServer=new e.RpcWorkSpaceServer;this.wsRpcServer.setEventHandler(CommonEvent.MENU,(e,t,o)=>{let n=JSON.parse(t);if(checker.isObject(n)&&n.menuEvent==="virtualNet"){const{moduleData:r}=n.menuData;if(checker.isString(r)&&""!==r){const i=JSON.parse(r);this.handleTrayEvent(n.menuData.moduleName,i)}else{this.handleTrayEvent(n.menuData.moduleName,null)}}if(checker.isFunction(o)){let e={code:0,message:"success",data:""};Log.info(LOG_TAG,"[checker is a function]");o(null,JSON.stringify(e))}})}createPanel(){Log.info(LOG_TAG,"[createPanel]");const e=require("../controller/window_manager");if(!this.panelWindow||this.panelWindow.isDestroyed()){this.panelWindow=e.createWindow(Common.WIN_PANEL_ID)}this.panelWindow.setController(this)}async startPanel(){try{Log.info(LOG_TAG,"[startPanel]");MainWinController.setTrayDelegate(this);if(Common.currentMode===Common.RUNMODE_NORMAL){this.startTray();this.createPanel()}else{Log.info(LOG_TAG,"[startEaioController]");this.eaioStartUemVirtualNetRpcService();EaioController.start()}const e=require("../controller/window_manager");e.broadcastMessage(Protocal.BROADCAST_ALL_WINDOW_MSG,"");NotifyMsgManager.setTrayController(this);this.initUserStatus();this.monitorAgent();this.startService(true,true);this.uemStatus=null;this.uemInfo=null;this.acquireUEMStatus();this.acquireUEMInfo()}catch(e){Log.warn(LOG_TAG,"[startPanel] start failed , reason:",e)}}destroyPanelWindow(){Log.info(LOG_TAG,"[destroyPanelWindow]");if(this.panelWindow){this.panelWindow.destroy();this.panelWindow=null}}async checkTrayRunMode(){Log.info(LOG_TAG,"[checkTrayRunMode]");let[e]=await to(Common.initTrayRunMode());if(e){Log.warn(LOG_TAG,"initTrayRunMode failed","reason:",e)}if(Common.currentMode===Common.RUNMODE_AIO){this.switchToAioTray({event:"eaioSwitchToAioTray",data:{}})}}switchToAioTray(e){Log.info(LOG_TAG,"[switchToAioTray]");this.closeTray();this.destroyPanelWindow();Common.currentMode=Common.RUNMODE_AIO;MainWinController.sendEventMsgToMainWindow(e)}destroy(){Log.info(LOG_TAG,"[destroy]");this.closeTray();if(this.agentCheckerTimer){clearInterval(this.agentCheckerTimer);this.agentCheckerTimer=null}if(this.timer){clearInterval(this.timer);this.timer=null}}closeTray(){Log.info(LOG_TAG,"[closeTray]");if(this.trayView){this.trayView.destroy();this.trayView=null}}monitorAgent(){if(os.platform()===Common.SYS_LINUX){return}Log.info(LOG_TAG,"[start monitor agent service]");this.timer=setInterval(()=>{this.startService(true)},Common.MONITOR_SERV_TIME_MS)}monitorAgentCancel(){if(os.platform()===Common.SYS_LINUX){return}Log.info(LOG_TAG,"[Stop monitor agent service]");if(this.timer){clearInterval(this.timer);this.timer=null}}initUserOnlineProcess(e,o){Log.info(LOG_TAG,"[initUserOnlineProcess] status[%s], addr[%s]",e,o);if(e===Common.OFFLINE){let e=AppConfig.getStartType();let t=HistoryAddr.getHistoryServiceType(o);Log.info(LOG_TAG,"[initUserOnlineProcess] startType[%s], serviceType",e,t);if(e===Common.TRAY_AUTOSTART||e===Common.TRAY_BROWSERSTART){Log.info(LOG_TAG,"[initUserOnlineProcess] online by tray");this.onUserOnline(null,this.retryOnline)}else if(t===Common.SERVICE_VERSION_PLAT){Log.info(LOG_TAG,"[initUserOnlineProcess] online by mainwindow portal")}else{Log.info(LOG_TAG,"[initUserOnlineProcess] online by tray");this.onUserOnline(null,this.retryOnline)}}else{Log.info(LOG_TAG,"[initUserOnlineProcess] status not offline do nothing")}}acquireUEMStatus(){Log.info(LOG_TAG,"[acquireUEMStatus]");if(os.platform()!=Common.SYS_LINUX){Log.info(LOG_TAG,"[acquireUEMStatus] platform[%s] not need acquire, return",os.platform());return}let e=AppConfig.initRequestData({});Util.requestAgent("/v1/aUem/status",e,e=>{Log.info(LOG_TAG,"acquire uem status:",e);if(!Common.isFieldValid(e.data.uemStatus)||!Common.isFieldValid(e.data.uemStatus.runStatus)||!Common.isFieldValid(e.data.uemStatus.workModeStatus)||!Common.isFieldValid(e.data.uemStatus.installStatus)||!Common.isFieldValid(e.data.uemStatus.rebootStatus)){return}this.uemStatus=e.data.uemStatus;this.judgeUEMIsRunning(false)})}acquireUEMInfo(){Log.info(LOG_TAG,"[acquireUEMInfo]");if(os.platform()!=Common.SYS_LINUX){Log.info(LOG_TAG,"[acquireUEMInfo] platform[%s] not need acquire, return",os.platform());return}let e=AppConfig.initRequestData({});Util.requestAgent("/v1/aUem/uemInfo",e,e=>{Log.info(LOG_TAG,"acquire uem info:",e);if(!Common.isFieldValid(e.data)||!Common.isFieldValid(e.data.supportWorkspaceIDList)){return}this.uemInfo=e.data;this.judgeUEMIsRunning(false)})}initUserStatus(){Log.info(LOG_TAG,"Initializes the user login information");var n=AppConfig.initRequestData({});Util.requestAgent("/v1/service/status",n,async e=>{Log.info(LOG_TAG,'Agent request https get, url: "/v1/service/status" result:',JSON.stringify(e));this.initFlag=false;if(e.code==ErrorCode.ERROR_SUCCESS){if(e.data.status===Common.LOGOUT){await Util.clearCookies(n.addr);e.data.data.addr=HistoryAddr.getLastHistoryAddr().addr}AppConfig.setUserStatus(e.data);this.setTrayStatusV2(e,true);this.initUserOnlineProcess(e.data.status,e.data.data.addr);if(AppConfig.getStartType()==Common.TRAY_LOGINSTART&&e.data.data.loginTime!=""){Log.info(LOG_TAG,"loginstart initUserStauts success notify login success",e);this.firstLogin=false;var t=JSON.stringify({event:Common.LOGIN,data:{address:e.data.data.clientIp,username:e.data.data.username,logintime:e.data.data.loginTime,type:"firstLogin"}});NotifyMsgManager.dealEventMsg("messageEvent|login",t);this.dealforceUpgradeStatus()}else{Log.info(LOG_TAG,"loginstart initUserStatus getLoginTime is null")}}else{Log.info(LOG_TAG,"request /service/status fail, setTrayStatus LOGOUT");this.setTrayStatus(Common.LOGOUT);var o=Util.deepClone(Common.USER_STATUS);o.data.addr=HistoryAddr.getLastHistoryAddr().addr;o.status=Common.LOGOUT;AppConfig.setUserStatus(o)}})}onGetUserStatus(o){Log.info(LOG_TAG,"get User Status");if(AppConfig.getExitFlag()){Log.info(LOG_TAG,"app will exit, not need onGetUserStatus, return ");Common.responseSendResult(o,{code:Protocal.ERROR_SUCCESS,message:"ok",data:AppConfig.getUserStatus()});return}var e=AppConfig.initRequestData({});Util.requestAgent("/v1/service/status",e,e=>{try{Log.info(LOG_TAG,'Agent request https get, url: "/v1/service/status" result:',JSON.stringify(e));var t={};if(e.code==ErrorCode.ERROR_SUCCESS){if(e.data.status===Common.LOGOUT){e.data.data.addr=HistoryAddr.getLastHistoryAddr().addr}AppConfig.setUserStatus(e.data);HistoryAddr.addHistoryAddr(e.data.data.addr);this.setTrayStatusV2(e);if(this.bClientLogout&&e.data.status===Common.LOGOUT){this.showLoginPagePreCheck(e.data.data.addr,false,false);this.bClientLogout=false}t.code=Protocal.ERROR_SUCCESS;t.message="";t.data=e.data}else{Log.warn(LOG_TAG,"getUserStatus fail");t.code=Protocal.ERROR_SUCCESS;t.message="";t.data=AppConfig.getUserStatus()}if(!o)return;t.data.data.addr=t.data.data.addr==""?HistoryAddr.getLastHistoryAddr().addr:t.data.data.addr;Common.responseSendResult(o,t)}catch(e){Log.warn(LOG_TAG,"[onGetUserStatus] process service status result failed, reason:",e);Common.responseSendResult(o,{code:Protocal.ERROR_SUCCESS,message:Language.Config.get(Language.Lib.UNKNOWN_ERROR),data:AppConfig.getUserStatus()})}})}openAppCenter(e,t){Log.info(LOG_TAG,"[openAppCenter] openSafeBrowser[%s]",t);var o=AppConfig.getUserStatus();Log.info(LOG_TAG,"[openAppCenter] addr[%s]",o.data.addr);if(o.data.addr!=""){var n;Log.info(LOG_TAG,"[openAppCenter] status[%s]",o.status);if(o.status==Common.ONLINE){var r=AppConfig.getAgentPort();n=o.data.addr+"/portal/shortcut.html?source=client&dest="+encodeURIComponent("#!/")+"service&lang=Zh_CN&port="+r;Log.info(LOG_TAG,"[openAppCenter] online, serverPage[%s]",n)}else{n=o.data.addr;Log.info(LOG_TAG,"[openAppCenter] not online, serverPage[%s]",n)}if(t&&o.status==Common.ONLINE){const i=require("../controller/uem_controller");if(os.platform()===Common.SYS_LINUX){n+="&uem=1";Log.info(LOG_TAG,"[openAppCenter] openSafeBrowser[%s] and user online, pullWorkSpace, serverPage[%s]",t,n);i.pullWorkSpace(false,true,n)}else{n+="&uem=1";Log.info(LOG_TAG,"[openAppCenter] openSafeBrowser[%s] and user online, openSafeBrowser, serverPage[%s]",t,n);i.openSafeBrowser(e,n)}return}else{Log.info(LOG_TAG,"[openAppCenter] openSafeBrowser[%s] and user not online, OpenDefaultBrowser, serverPage[%s]",t,n);Util.OpenDefaultBrowser(n)}}else{Log.info(LOG_TAG,"[openAppCenter] addr is null, open failed")}Common.responseSendResult(e,{code:Protocal.ERROR_SUCCESS,message:"",data:{}})}onOpenAppCenterByBrowser(t){Log.info(LOG_TAG,"[onOpenAppCenterByBrowser]");let e=AppConfig.initRequestData("");let o=false;if(os.platform()===Common.SYS_LINUX){Util.requestAgent("/v1/aUem/status",e,e=>{try{Log.info(LOG_TAG,'Agent request https get, url: "/v1/aUem/status" result:',e);if(typeof e.data.uemStatus=="object"&&typeof e.data.uemStatus.workModeStatus=="string"){if(e.data.uemStatus.workModeStatus!=="aTrustMode")o=true}Log.info(LOG_TAG,"[onOpenAppCenterByBrowser] will openAppCenter, openSafeBrowser[%s]",o);this.openAppCenter(t,o)}catch(e){Log.warn(LOG_TAG,"[onOpenAppCenterByBrowser] process aUem/status(Linux) result failed, reason:",e);Common.responseSendResult(t,{code:Protocal.ERROR_FAILED,message:Language.Config.get(Language.Lib.UNKNOWN_ERROR),data:{}})}})}else if(os.platform()===Common.SYS_WIN32){Util.requestAgent("/v1/aUem/status",e,e=>{try{Log.info(LOG_TAG,'Agent request https get, url: "/v1/aUem/status" result:',e);if(typeof e.data.uemStatus=="object"&&typeof e.data.uemStatus.openBrowserAction=="string"){if(e.data.uemStatus.openBrowserAction==="openSafeBrowser"){o=true}}Log.info(LOG_TAG,"[onOpenAppCenterByBrowser] will openAppCenter, openSafeBrowser[%s]",o);this.openAppCenter(t,o)}catch(e){Log.warn(LOG_TAG,"[onOpenAppCenterByBrowser] process aUem/status(win32) result failed, reason:",e);Common.responseSendResult(t,{code:Protocal.ERROR_FAILED,message:Language.Config.get(Language.Lib.UNKNOWN_ERROR),data:{}})}})}else{Log.info(LOG_TAG,"[onOpenAppCenterByBrowser] platform[%s], openAppCenter(openSafeBrowser[%s])",os.platform(),o);this.openAppCenter(t,o)}}onOpenAppCenter(t){Log.info(LOG_TAG,"[onOpenAppCenter]");let o=AppConfig.getSdpcAddr();let e=HistoryAddr.getHistoryServiceType(o);if(e===Common.SERVICE_VERSION_PLAT){Log.info(LOG_TAG,"[onOpenAppCenter] serviceType[%s] => showMainWindow",e);MainWinController.showMainWindow(o,Common.SERVICE_VERSION_PLAT);Common.responseSendResult(t,{code:Protocal.ERROR_SUCCESS,message:"ok",data:{}});Log.info(LOG_TAG,"[onOpenAppCenter] => updateMainWindowInBackground");MainWinController.updateMainWindowInBackground();return}if(e===Common.SERVICE_VERSION_NONE){Log.info(LOG_TAG,"[onOpenAppCenter] serviceType[%s] => updateServiceSettingInBackground",e);if(MainWinController.updateServiceSettingInBackground(o,e=>{try{Log.info(LOG_TAG,"[onOpenAppCenter] updateServiceSettingInBackground retData[%s]",e);if(e.code===0&&e.serviceType===Common.SERVICE_VERSION_PLAT){Log.info(LOG_TAG,"[onOpenAppCenter] will showMainWindow(addr[%s], serviceType[%s])",o,e.serviceType);MainWinController.showMainWindow(o,Common.SERVICE_VERSION_PLAT);Common.responseSendResult(t,{code:Protocal.ERROR_SUCCESS,message:"ok",data:{}})}else{Log.info(LOG_TAG,"[onOpenAppCenter] will onOpenAppCenterByBrowser");this.onOpenAppCenterByBrowser(t)}}catch(e){Log.warn(LOG_TAG,"[onOpenAppCenter] process update service setting result failed, reason:",e);Common.responseSendResult(t,{code:Protocal.ERROR_FAILED,message:Language.Config.get(Language.Lib.UNKNOWN_ERROR),data:{}})}}));}else{Log.info(LOG_TAG,"[onOpenAppCenter] serviceType[%s] => onOpenAppCenterByBrowser",e);this.onOpenAppCenterByBrowser(t)}}onOpenLoginAddr(e){Log.info(LOG_TAG,"[onOpenLoginAddr] addr[%s]",e);Util.OpenDefaultBrowser(e)}requestAgentFail(e){var t={code:Protocal.ERROR_SUCCESS,message:"",data:{}};Log.warn(LOG_TAG,"connect SdpAgent Fail");NotifyMsgManager.dealEventMsg("messageEvent|notifymsg",JSON.stringify({event:"notifymsg",data:{message:Language.Config.get(Language.Lib.ENVI_OPER_FAILED),messagelevel:"error"}}));t.code=ErrorCode.ERROR_AGENTFAIL;t.message=Language.Config.get(Language.Lib.ENVI_OPER_FAILED);t.data=AppConfig.getUserStatus();Common.responseSendResult(e,t)}disconnectLogout(e){Log.warn(LOG_TAG,"disconnectLogout ");NotifyMsgManager.createForceCommonWindow(Common.WIN_DISCONNECTLOGOUT_NAME,Language.Config.get(Language.Lib.WIN_DISCONNECTLOGOUT_URL));Common.responseSendResult(e,{code:Protocal.ERROR_SUCCESS,message:"ok",data:{}})}downloadExit(e,t){Log.warn(LOG_TAG,"downloadExit ");NotifyMsgManager.createForceCommonWindow(Common.WIN_DOWNLOADEXIT_NAME,Language.Config.get(e));Common.responseSendResult(t,{code:Protocal.ERROR_SUCCESS,message:"ok",data:{}})}requestUpdateing(e){var t={code:Protocal.ERROR_SUCCESS,message:"",data:{}};Log.warn(LOG_TAG,"connect SdpAgent Fail");NotifyMsgManager.dealEventMsg("messageEvent|notifymsg",JSON.stringify({event:"notifymsg",data:{message:Language.Config.get(Language.Lib.UPDATING_STATE_MSG),messagelevel:"error"}}));t.code=ErrorCode.ERROR_UPDATEING;t.code=Language.Config.get(Language.Lib.UPDATING_STATE_MSG);t.data=AppConfig.getUserStatus();Common.responseSendResult(e,t)}requestServerFail(e,t){var o={code:Protocal.ERROR_SUCCESS,message:"",data:{}};Log.warn(LOG_TAG,"requestServerFail code:",e.code);NotifyMsgManager.dealEventMsg("messageEvent|notifymsg",JSON.stringify({event:"notifymsg",data:{message:e.message,messagelevel:"error"}}));o.code=e.code;o.message=e.message;o.data=AppConfig.getUserStatus();if(e.code==ErrorCode.RESTCORE_USER_LOGOUT){o.data.status=Common.LOGOUT;this.setTrayStatus(Common.LOGOUT)}Common.responseSendResult(t,o);return}onUpdateCheck(){Log.info(LOG_TAG,"[onUpdateCheck]");var t=AppConfig.initRequestData("");Util.requestAgent("/v1/update/status",t,e=>{if(e.code==ErrorCode.ERROR_AGENTFAIL){Log.info(LOG_TAG,"[onUpdateCheck], request update/status failed, code[ERROR_AGENTFAIL], return");return}Log.info(LOG_TAG,"update/check status:",e.data.status);if(e.code!=ErrorCode.ERROR_SUCCESS){Log.info(LOG_TAG,"[onUpdateCheck], update/status failed, code[%s], return",e.code);return}if(e.data.status!=Common.UPDATE_STATUS_IDLE&&e.data.status!=Common.UPDATE_STATUS_WAITING){Log.info(LOG_TAG,"[onUpdateCheck], update/status, status[%s], return",e.data.status);return}Log.info(LOG_TAG,"[onUpdateCheck], will request /update/check");t=AppConfig.initRequestData({addr:AppConfig.getSdpcAddr()});Util.requestAgent("/v1/update/check",t,e=>{Log.info(LOG_TAG,"request update/check result:",e);if(e.code==ErrorCode.ERROR_AGENTFAIL){Log.info(LOG_TAG,"[onUpdateCheck], request update/check failed, code[ERROR_AGENTFAIL], return");return}if(e.code!=ErrorCode.ERROR_SUCCESS){Log.info(LOG_TAG,"[onUpdateCheck], update/checks failed, code[%s], return",e.code);return}if(e.data.type=="forceUpdate"){Log.info(LOG_TAG,"request update/check need forceUpdate")}})})}checkUpdate(t){Log.info(LOG_TAG,"[checkUpdate]");var e=AppConfig.initRequestData(t.data());Util.requestAgent("/v1/update/check",e,e=>{try{Log.info(LOG_TAG,"result: ",e);if(e.code==ErrorCode.ERROR_AGENTFAIL){Log.info(LOG_TAG,"[checkUpdate], request update/check failed, code[ERROR_AGENTFAIL], return");return this.requestAgentFail(t)}if(e.code!=ErrorCode.ERROR_SUCCESS){Log.warn(LOG_TAG,"requestServerFail code:",e.code);NotifyMsgManager.dealEventMsg("messageEvent|notifymsg",JSON.stringify({event:"notifymsg",data:{message:e.message,messagelevel:"error"}}))}Common.responseSendResult(t,e)}catch(e){Log.warn(LOG_TAG,"[checkUpdate] process /update/check result failed, reason:",e);Common.responseSendResult(t,{code:ErrorCode.ERROR_FAILED,message:Language.Config.get(Language.Lib.UNKNOWN_ERROR)})}})}onUserOnline(t,o){var e=AppConfig.initRequestData({});var n={code:Protocal.ERROR_SUCCESS,message:"",data:{}};Log.info(LOG_TAG,"[onUserOnline]");Util.requestAgent("/v1/service/online",e,e=>{try{Log.info(LOG_TAG,"[onUserOnline] /service/online result:",e);n.code=e.code;n.message=e.message;if(e.data){n.data=e.data}if(o&&o(e)){return}if(e.code==ErrorCode.ERROR_AGENTFAIL){Log.warn(LOG_TAG,"[onUserOnline] connect SdpAgent Fail");if(os.platform()===Common.SYS_WIN32||os.platform()===Common.SYS_MAC){Log.info(LOG_TAG,"[onUserOnline] will create resetClient window");return NotifyMsgManager.resetClient(t)}return this.requestAgentFail(t)}if(e.code!=ErrorCode.ERROR_SUCCESS){Log.warn(LOG_TAG,"onUserOnline request fail:",e.code);if(!this.onlineFail(e.code)){return this.requestServerFail(e,t)}n.data=AppConfig.getUserStatus()}Common.responseSendResult(t,n);return this.onUpdateCheck()}catch(e){Log.warn(LOG_TAG,"[onUserOnline] process service/online result failed, reason:",e);Common.responseSendResult(t,{code:Protocal.ERROR_SUCCESS,message:"ok",data:AppConfig.getUserStatus()})}})}onlineFail(e){if(e==ErrorCode.PASSPORT_UNENABLE||e==ErrorCode.PASSPORT_SANGFOR_ID_EXPIRED||e==ErrorCode.PASSPORT_SANGFOR_ID_INVALID||e==ErrorCode.PASSPORT_SESSION_INVALID||e==ErrorCode.PASSPORT_FAILED||e==ErrorCode.PASSPORT_UNMATCHED_DEVICEID||e==ErrorCode.ACL_RESCUE||e==ErrorCode.ACL_HANDLE||e==ErrorCode.PASSPORT_DEVICE_NOT_TRUSTED||e==ErrorCode.PASSPORT_TOKEN_PERMISSION_DENIED)return true;return false}onUserOffline(r){Log.info(LOG_TAG,"[onUserOffline]");var e=new Promise((t,o)=>{var e=AppConfig.initRequestData({});var n={code:Protocal.ERROR_SUCCESS,message:"",data:{}};Util.requestAgent("/v1/service/offline",e,e=>{try{Log.info(LOG_TAG,"[onUserOffline] /service/offline result:",e);n.code=e.code;n.message=e.message;if(e.data){n.data=e.data}if(e.code==ErrorCode.ERROR_AGENTFAIL){Log.warn(LOG_TAG,"[onUserOffline] connect SdpAgent Fail");if(os.platform()===Common.SYS_WIN32||os.platform()===Common.SYS_MAC){Log.info(LOG_TAG,"[onUserOffline] will create resetClient window");return NotifyMsgManager.resetClient(r)}this.requestAgentFail(r);o(e);return}else if(!e.code==ErrorCode.ERROR_SUCCESS){Log.warn(LOG_TAG,"onUserOffline request fail:",e.code);this.requestServerFail(e,r);o(e);return}Common.responseSendResult(r,{code:Protocal.ERROR_SUCCESS,message:"ok",data:{status:Common.OFFLINE}});t()}catch(e){Log.warn(LOG_TAG,"[onUserOffline] process service/offline result failed, reason:",e);Common.responseSendResult(r,{code:Protocal.ERROR_SUCCESS,message:Language.Config.get(Language.Lib.UNKNOWN_ERROR),data:AppConfig.getUserStatus()})}})});return e}onLogoutAction(t){Log.info(LOG_TAG,"[onLogoutAction]");var o=AppConfig.initRequestData({type:"force"});var n={code:Protocal.ERROR_SUCCESS,message:"",data:{}};Util.requestAgent("/v1/service/logout",o,e=>{try{Log.info(LOG_TAG,"[onLogoutAction] /service/logout result:",e);n.code=e.code;n.message=e.message;if(e.data){n.data=e.data}if(e.code==ErrorCode.ERROR_AGENTFAIL){Log.warn(LOG_TAG,"[onLogoutAction] connect SdpAgent Fail");if(os.platform()===Common.SYS_WIN32||os.platform()===Common.SYS_MAC){Log.info(LOG_TAG,"[onUserOffline] will create resetClient window");return NotifyMsgManager.resetClient(t)}return this.requestAgentFail(t)}if(e.code!=ErrorCode.ERROR_SUCCESS){return this.requestServerFail(e,t)}Util.clearCookies(o.addr);Common.responseSendResult(t,{code:Protocal.ERROR_SUCCESS,message:"ok",data:{status:Common.LOGOUT}})}catch(e){Log.warn(LOG_TAG,"[onLogoutAction] process logout result failed, reason:",e);Common.responseSendResult(t,{code:ErrorCode.ERROR_FAILED,message:Language.Config.get(Language.Lib.UNKNOWN_ERROR)})}})}onLogout(e){Log.info(LOG_TAG,"[onLogout]");this.onLogoutAction(e,"")}onUpdateQuery(t){Log.info(LOG_TAG,"[onUpdateQuery]");var e=AppConfig.initRequestData({});Util.requestAgent("/v1/update/status",e,e=>{Log.info(LOG_TAG,"[onUpdateQuery] /update/status result:",e);Common.responseSendResult(t,e)})}onExitAction(t,o){Log.info(LOG_TAG,"[onExitAction] exitType[%s]",o);const e=AppConfig.initRequestData({type:"clientexit"});Util.requestAgent("/v1/service/logout",e,e=>{try{Log.info(LOG_TAG,"[onExitAction] /service/logout result:",e);if(e.code==ErrorCode.ERROR_AGENTFAIL){if(os.platform()===Common.SYS_WIN32||os.platform()===Common.SYS_MAC){Log.info(LOG_TAG,"[onExitAction] will create resetClient window");return NotifyMsgManager.resetClient(t)}return this.requestAgentFail(t)}this._unregist();this.handleExitActionType(o);Common.responseSendResult(t,{code:ErrorCode.ERROR_SUCCESS,message:"ok"})}catch(e){Log.warn(LOG_TAG,"[onExitAction] process service/logout result failed, reason:",e);Common.responseSendResult(t,{code:ErrorCode.ERROR_FAILED,message:Language.Config.get(Language.Lib.UNKNOWN_ERROR)})}})}resetMac13AllowBackgroundFlag(){Log.info(LOG_TAG,"[resetMac13AllowBackgroundFlag]");if(os.platform()===Common.SYS_MAC){try{if(fs.existsSync(Common.CLIENT_MAC13_NOT_ALLOW)){Log.info(LOG_TAG,"[startService] clean CLIENT_MAC13_NOT_ALLOW file","path:",Common.CLIENT_MAC13_NOT_ALLOW);fs.unlinkSync(Common.CLIENT_MAC13_NOT_ALLOW)}else{Log.info(LOG_TAG,"[startService] clean CLIENT_MAC13_NOT_ALLOW file alreay delete")}}catch(e){Log.warn(LOG_TAG,"[startService] clean CLIENT_MAC13_NOT_ALLOW file error : %s",e)}}}resetFullExit(){Log.info(LOG_TAG,"[resetFullExit]");if(os.platform()===Common.SYS_MAC){try{if(fs.existsSync(Common.CLIENT_FULLEXIT_FLAG_FILE)){Log.info(LOG_TAG,"[resetFullExit] clean full exit file","path:",Common.CLIENT_FULLEXIT_FLAG_FILE);fs.unlinkSync(Common.CLIENT_FULLEXIT_FLAG_FILE)}else{Log.info(LOG_TAG,"[resetFullExit] full exit file not exist")}}catch(e){Log.info(LOG_TAG,"[resetFullExit] clean full exit file error : %s",e)}}else if(os.platform()===Common.SYS_WIN32){try{if(fs.existsSync(Common.CLIENT_FULLEXIT_FLAG_FILE)){fs.unlinkSync(Common.CLIENT_FULLEXIT_FLAG_FILE);Log.info(LOG_TAG,"[resetFullExit] remove TrayFullyExit file success!","path:",Common.CLIENT_FULLEXIT_FLAG_FILE);SettingController.setTrayAutoStatus(Common.VALUE_ENABLE,e=>{if(e){Log.warn(LOG_TAG,"[resetFullExit] The tray auto function fails to be enabled")}})}}catch(e){Log.warn(LOG_TAG,"[resetFullExit] exception occurs while delete TrayFullyExit file","reason:",e)}}}afterFullExit(){Log.info(LOG_TAG,"[afterFullExit]");if(os.platform()==Common.SYS_MAC){try{if(!fs.existsSync(Common.CLIENT_FULLEXIT_FLAG_FILE)){fs.writeFileSync(Common.CLIENT_FULLEXIT_FLAG_FILE,"fully exit");fs.chmodSync(Common.CLIENT_FULLEXIT_FLAG_FILE,511);Log.info(LOG_TAG,"create fullexit file success!","path:",Common.CLIENT_FULLEXIT_FLAG_FILE)}}catch(e){Log.warn(LOG_TAG,"Failed to create file CLIENT_FULLEXIT_FLAG_FILE","reason:",e);return false}return true}if(os.platform()!=Common.SYS_WIN32)return true;SettingController.getTrayAutoStatus(async(e,t)=>{if(t){SettingController.setTrayAutoStatus(Common.VALUE_DISABLE,e=>{if(e){Log.warn(LOG_TAG,"Failed to turn off the tray startup function");return false}});try{await fs.promises.writeFile(Common.CLIENT_FULLEXIT_FLAG_FILE,"fully exit");Log.info(LOG_TAG,"create ResetAutoStartFlag file success!","path:",Common.CLIENT_FULLEXIT_FLAG_FILE)}catch(e){Log.warn(LOG_TAG,"Failed to create file ResetAutoStartFlag","reason:",e);return false}}});return true}resetStatusOperation(e,t){Log.info(LOG_TAG,"[resetStatusOperation] isOfflineExit[%s]",e);if(!e){this._unregist();AppConfig.setExitFlag(true);this.setTrayStatus(Common.LOGOUT)}const o=require(".././service/util/event_emitter");o.emit(Protocal.EVENT_MAIN_APP_EXIT,t)}handleFullExit(o){const e=require("../service/util/Servrepair_tool");if(e.exitClientCompletelyPlugin()){let e=encodeURI(Language.Config.get(Language.Lib.WIN_STORTSERV_URL));if(!this.afterFullExit()){Log.info(LOG_TAG,"The tray process exited with plugin failed, due to afterFullExit exec failed");NotifyMsgManager.createForceCommonWindow(Common.WIN_STOPTSERV_NAME,e);EaioController.start();return}Log.info(LOG_TAG,"The tray process exited successfully");this.resetStatusOperation(o,Common.EXIT_FULL);return}e.exitClientCompletely(e=>{let t=encodeURI(Language.Config.get(Language.Lib.WIN_STORTSERV_URL));if(e!=""){Log.warn(LOG_TAG,"The atrusttray.exe process failed to exit. The reason is that %s",e);NotifyMsgManager.createForceCommonWindow(Common.WIN_STOPTSERV_NAME,t);EaioController.start();return}if(!this.afterFullExit()){Log.info(LOG_TAG,"The tray process exited with failed, due to afterFullExit exec failed");NotifyMsgManager.createForceCommonWindow(Common.WIN_STOPTSERV_NAME,t);EaioController.start();return}Log.info(LOG_TAG,"The tray process exited successfully");this.resetStatusOperation(o,Common.EXIT_FULL)})}handleExitActionType(e,t="false"){Log.info(LOG_TAG,"Stop the atrustService service and atrustagent processes");if(e!="full"){Log.info(LOG_TAG,"The tray process exited successfully");this.resetStatusOperation(t);return}if(Common.currentMode===Common.RUNMODE_NORMAL){this.handleFullExit(t);return}EaioController.stop().then(()=>{this.handleFullExit(t)})}onExit(t,o){Log.info(LOG_TAG,"[onExit], exitType:%s",o);var e=AppConfig.getUserStatus();if(e.status==Common.LOGOUT){Log.info(LOG_TAG,"current userStatus is logout, perform the exit step directly");Common.responseSendResult(t,{code:ErrorCode.ERROR_SUCCESS,message:"ok"});this.handleExitActionType(o);return}try{this.onExitAction(t,o)}catch(e){Log.warn(LOG_TAG,"[onExit] process updat/status result failed, reason:",e);Common.responseSendResult(t,{code:ErrorCode.ERROR_FAILED,message:Language.Config.get(Language.Lib.UNKNOWN_ERROR)});this.handleExitActionType(o)}}processAutoStartSetting(){if(SettingController.authConfig.isGetAuthConfig===false){SettingController.getSettingFromRPC({key:Common.KEY_ENABLE_ALL_SETTING,defaultValue:Common.VALUE_DISABLE},(e,t)=>{if(e||t===undefined){return}SettingController.setTrayAutoStatusPromise(Common.KEY_MANU_SETAUTO_FLAG,SettingController.authConfig.enableClientAutoStart,false)})}}setTrayStatus(e,t){if(this.trayView){this.trayView.setTrayStatus(e)}if(e!=this.trayStatus&&e===Common.ONLINE){MainWinController.mainWindowOnlineProcess(HistoryAddr.getLastHistoryAddr().addr);if(t!=true){MainWinController.mainWindowOnlineProcess(AppConfig.getSdpcAddr())}Log.info(LOG_TAG,"setTrayStatus status:",e);this._regist()}if(e===Common.ONLINE){this.processAutoStartSetting()}this.trayStatus=e;this.recheckStatus(e);if(e===Common.LOGOUT){this.firstLogin=true;SettingController.resetAuthConfigSetting()}}setTrayStatusV2(e,t){Assert(typeof e.data==="object",e.data);if(e.data.status===Common.ONLINE&&this.trayView){if(e.data.tunnelLineStatus!==undefined&&e.data.tunnelLineStatus.importNotification!==undefined&&e.data.tunnelLineStatus.importNotification.tip!==undefined){this.trayView.setOnlineTip(e.data.tunnelLineStatus.importNotification.tip)}}this.setTrayStatus(e.data.status,t)}notifyTrayEvent(e,t){if(os.platform()!==Common.SYS_LINUX){return}if(this.trayView){Log.info(LOG_TAG,`tray will notify event topic: ${e}, message: ${t}`);this.trayView.setTrayVirtualNetStatus(e,t)}}handleTrayEvent(e,t){if(os.platform()!==Common.SYS_LINUX){return}const o=require("../controller/uem_controller");Log.info(LOG_TAG,`tray will notify event topic: ${e}, message: ${t}`);if(e===CommonEvent.EVENT_QUERY_VIRTUAL_NET_INFO){o.queryVirtualNetInfo(null)}else if(e===CommonEvent.EVENT_CHANGE_VIRTUAL_NET){o.changeVirtualNet(null,t)}else if(e===CommonEvent.EVENT_QUERY_UEM_CONFIG){o.queryUemConfig(null)}else if(e===CommonEvent.EVENT_VIEW_NETWORK_INTERCEPT_LOG){o.viewNetworkInterceptLog(null)}else if(e===CommonEvent.EVENT_QUERY_FLOAT_BALL_CFG){o.queryFloatBallCfg(null)}else if(e===CommonEvent.EVENT_UPDATE_FLOAT_BALL_CFG){o.updateFloatBallCfg(null,t)}else{Log.warn(LOG_TAG,`tray controller not handle event: ${e}`)}}stopAgentChecker(){if(this.agentCheckerTimer){clearInterval(this.agentCheckerTimer);this.agentCheckerTimer=null}}startAgentChecker(){if(os.platform()===Common.SYS_MAC){Log.info(LOG_TAG,"[startAgentChecker] service not running, agent checker timer start");clearInterval(this.agentCheckerTimer);this.agentCheckerTimer=setInterval(()=>{try{const e=require("../controller/window_manager");if(e.getWindowByName(Common.WIN_STARTSERV_NAME)==null){Log.info(LOG_TAG,"[startAgentChecker] user close window, stop timer");clearInterval(this.agentCheckerTimer);return}const t=require("../service/util/Servrepair_tool");if(t.isServiceRunning(Common.ATRUSTSERVNAME)){Log.info(LOG_TAG,"[startAgentChecker] service is running, close window");this.resetFullExit();this.resetMac13AllowBackgroundFlag();e.closeNormalWindowByName(Common.WIN_STARTSERV_NAME);clearInterval(this.agentCheckerTimer)}else{Log.info(LOG_TAG,"[startAgentChecker] service not running, try next interval %d ms",Common.AGENT_CHECKER_TIME_MS)}}catch(e){Log.warn(LOG_TAG,"[startAgentChecker] agent timer error: ",e);clearInterval(this.agentCheckerTimer)}},Common.AGENT_CHECKER_TIME_MS)}}showStartSeviceWindow(){if(os.platform()===Common.SYS_MAC){try{if(fs.existsSync(Common.CLIENT_MAC13_NOT_ALLOW)){Log.info(LOG_TAG,"[startService] mac13 not allowed background");let e=encodeURI(Language.Config.get(Language.Lib.WIN_OPENSYSTEM_LOGINITEMS_URL));NotifyMsgManager.createForceCommonWindow(Common.WIN_STARTSERV_NAME,e)}else{let e;const o=require("process");let t=o.getSystemVersion().split(".");if(parseInt(t[0])>=13){Log.info(LOG_TAG,"[startService] mac13 service abnormal");e=encodeURI(Common.WIN_STARTSERV_URL_V2)}else{Log.info(LOG_TAG,"[startService] mac service abnormal");e=encodeURI(Common.WIN_STARTSERV_URL)}NotifyMsgManager.createForceCommonWindow(Common.WIN_STARTSERV_NAME,e)}this.startAgentChecker()}catch(e){Log.warn(LOG_TAG,"[startService] mac open startserv window catch error: ",e)}return}if(os.platform()===Common.SYS_WIN32){let e=encodeURI(Common.WIN_STARTSERV_URL);NotifyMsgManager.createForceCommonWindow(Common.WIN_STARTSERV_NAME,e);return}}startService(e=false,t=false){Log.info(LOG_TAG,"[startService] isforce:",e);const o=require("../service/util/Servrepair_tool");if(os.platform()===Common.SYS_MAC){if(o.isServiceRunning(Common.ATRUSTSERVNAME)){Log.info(LOG_TAG,"[startService] service is running");this.resetFullExit();this.resetMac13AllowBackgroundFlag()}else if(e||fs.existsSync(Common.CLIENT_FULLEXIT_FLAG_FILE)){if(!o.startServicePlugin(Common.ATRUSTSERVNAME)&&!t){Log.info(LOG_TAG,"[startService] startServicePlugin failed, apply for admin permissions");this.shouldShowPanel=false;this.showStartSeviceWindow()}}return}else if(os.platform()===Common.SYS_WIN32){if(o.isServiceRunning(Common.ATRUSTSERVNAME)){Log.info(LOG_TAG,"[startService] service is running");return}if(!o.startServicePlugin(Common.ATRUSTSERVNAME)&&!t){this.shouldShowPanel=false;Log.info(LOG_TAG,"[startService] startServicePlugin failed, apply for admin permissions");this.showStartSeviceWindow()}}}async processunInstall(){await EaioController.stop();const e=require(".././service/util/event_emitter");e.emit(Protocal.EVENT_MAIN_APP_EXIT)}onSecondInstanc(e){let t=e.join(" ");Log.info(LOG_TAG,`[onSecondInstanc] second instance argv: ${t}`);if(Is.boolean(global.debug)&&global.debug){if(this._handlePhishingRiskArguments(e)){Log.info(LOG_TAG,`[onSecondInstanc] Phishing risk parameters have been processed`);return}}if(e.includes(Common.TRAY_STOP)){this.processunInstall();Log.info(LOG_TAG,`[onSecondInstanc] TrayEventEmitter.emit ${Common.TRAY_STOP}`);const o=require(".././service/util/event_emitter");o.emit(Protocal.EVENT_MAIN_APP_EXIT);return}if(e.includes(Common.TRAY_BROWSERSTART)){Log.info(LOG_TAG,`[onSecondInstanc] startService ${Common.TRAY_BROWSERSTART}`);this.startService(true)}else if(e.includes(Common.TRAY_AIOSTART)){this.startService(true);this.showLoginPagePreCheck("",false,true)}else if(!e.includes(Common.TRAY_AUTOSTART)&&!e.includes(Common.TRAY_RECOVERSTART)&&!e.includes(Common.TRAY_LOGINSTART)&&!e.includes(Common.TRAY_ONLINESTART)&&!e.includes(Common.TRAY_INITSTART)&&!e.includes(Common.TRAY_UPDATESTART)){this.startService();this.showLoginPagePreCheck("",true,false)}}_tidyCmdline(e){const t="--";let o=JSON.parse(JSON.stringify(e));let n=o.indexOf(t);if(n==-1||n==0){return o}else{o=e.splice(o.indexOf(t));o.unshift(e[0]);return o}}_handlePhishingRiskArguments(e){let t=true;let o=this._tidyCmdline(e);Log.info(LOG_TAG,`[onSecondInstanc] second instance tidy argv: ${o}`);let n=Common.globalCommander();n.parse(o);if(n.starttype===Common.TRAY_POPUP_PHISHING_RISK){Log.info(LOG_TAG,`[onSecondInstanc] showPhishingRiskWarningPage ${Common.TRAY_POPUP_PHISHING_RISK}`);MainWinController.showPhishingRiskWarningPage({urlparam:{query:{origin:n.origin,target:n.target,riskType:n.riskType}}})}else if(n.starttype===Common.TRAY_POPUP_PHISHING_RISK_CONFIRM){Log.info(LOG_TAG,`[onSecondInstanc] showPhishingRiskWarningConfirmationPage ${Common.TRAY_POPUP_PHISHING_RISK}`);MainWinController.showPhishingRiskWarningConfirmationPage(n.origin)}else{t=false}return t}onHidePanelWindow(){if(this.panelWindow===null){Log.info(LOG_TAG,"[onHidePanelWindow] panelwindow is destroyed, return");return}if(os.platform()===Common.SYS_LINUX)return;this.panelWindow.hide()}onShowPanelWindow(){if(!this.shouldShowPanel){return}if(this.panelWindow===null){Log.info(LOG_TAG,"[onHidePanelWindow] panelwindow is destroyed, return");return}if(this.panelWindow.isDestroyed()){this.createPanel();this.sendEventMsgTray({event:CommonEvent.SHOW_PANEL},true);return}if(os.platform!=Common.SYS_LINUX){var e=this.getTrayBounds();var t={event:CommonEvent.SHOW_PANEL,trayBounds:e,data:{}};this.sendEventMsgTray(t,true)}}onAppActivate(){Log.info(LOG_TAG,"onAppActivate");this.startService();this.showLoginPagePreCheck("",true,false)}onDoubleClick(){var e=AppConfig.getUserStatus();Log.info(LOG_TAG,"onOpenAppCenter: %s",e.data.addr);if(e.data.addr!=""){this.onOpenAppCenter();if(this.panelWindow){this.panelWindow.hide()}}else{this.onShowPanelWindow()}}onDownload(t){const e=AppConfig.initRequestData({});Util.requestAgent("/v1/update/start",e,e=>{Common.responseSendResult(t,e)})}onPrintLog(e){if(Common.isFieldValid(e)){Log.info(LOG_PORTAL_TAG,"%s",e)}}getTrayBounds(){try{var e={x:0,y:0};if(this.trayView===null){Log.info(LOG_TAG,"trayView is destroyed, return valid Bounds!");return e}e=this.trayView.getBounds()}catch(e){Log.warn(LOG_TAG,"trayView.getBounds() return failed!")}return e}dealMainWindowLogin(t){try{var e=JSON.parse(t);if(e.data&&e.data.type&&e.data.type===Common.REQUEST_TYPE_CLIENT){this.bClientLogin=true}}catch(e){Log.warn(LOG_TAG,"dealMainWindowLogin error message:%s",t)}}dealSelectUpdateModelEvent(e){Log.info("into dealSelectUpdateModelEvent");var t=null;try{t=JSON.parse(e);if(t.data&&t.data.type&&t.data.type==Common.UPDATETYPE_FORCEUPGRADE){this.dealforceUpgradeStatus()}}catch(e){Log.warn(LOG_TAG,"dealSelectUpdateModelEvent catch error")}}dealforceUpgradeStatus(){try{Log.info(LOG_TAG,"[dealforceUpgradeStatus] begin");var e=AppConfig.initRequestData({});Util.requestAgent("/v1/update/status",e,e=>{Log.info(LOG_TAG,"[dealforceUpgradeStatus] /update/status result:",e);if(e.code==ErrorCode.ERROR_AGENTFAIL){Log.info(LOG_TAG,"[dealforceUpgradeStatus], request update/status failed, code[ERROR_AGENTFAIL], return");return}Log.info(LOG_TAG,"[dealforceUpgradeStatus] update/status status:",e.data.status);if(e.code!=ErrorCode.ERROR_SUCCESS){Log.info(LOG_TAG,"[dealforceUpgradeStatus], update/status failed, code[%s], return",e.code);return}if(e.data.status&&e.data.status==Common.UPDATE_STATUS_WAITING){Log.info(LOG_TAG,"[dealforceUpgradeStatus], update/status, status[%s], return",e.data.waitUpdate.type);if(e.data.waitUpdate&&e.data.waitUpdate.type&&e.data.waitUpdate.type==Common.UPDATETYPE_FORCEUPGRADE){this.showLoginPagePreCheck("",true,false)}}})}catch(e){Log.warn(LOG_TAG,"dealforceUpgradeStatus catch error")}}dealMainWindowLogout(t){try{var e=JSON.parse(t);if(e.data){if(e.data.selfType&&e.data.selfType===Common.LOGOUT_SELF_TYPE){Log.info(LOG_TAG,"[dealMainWindowLogout] requestClientType",e.data.requestClientType);this.bClientLogout=true;this.onHidePanelWindow();return}if(e.data.type==="self"||e.data.type==="force"||e.data.type==="timeoutOffline"){return}this.bClientLogout=true;this.onHidePanelWindow()}}catch(e){Log.warn(LOG_TAG,"dealMainWindowLogout error message:%s",t)}}dealStatusLogin(e,t){Assert(typeof e=="string"&&typeof t=="string");this._regist();if(this.firstLogin==true){this.firstLogin=false;NotifyMsgManager.dealEventMsg(e,t)}this.sendEventMsgTray(t);this.dealMainWindowLogin(t)}dealStatusLogout(e,t){Assert(typeof e=="string"&&typeof t=="string");this._unregist();NotifyMsgManager.dealEventMsg(e,t);this.sendEventMsgTray(t);this.dealMainWindowLogout(t)}dealStatusOffline(e){Assert(typeof e=="string");this._unregist();this.sendEventMsgTray(e)}dealTunnelLineStatus(e){Assert(typeof e=="object",e);if(this.trayView){this.trayView.setOnlineTip(e.importantNotification.tip)}}dealUemStatus(e){if(os.platform!=Common.SYS_LINUX){return}let t=JSON.parse(e);Log.info(LOG_TAG,"The status message of the UEM is %s",e);if(!Common.isFieldValid(t.data)||!Common.isFieldValid(t.data.runStatus)||!Common.isFieldValid(t.data.workModeStatus)||!Common.isFieldValid(t.data.installStatus)||!Common.isFieldValid(t.data.rebootStatus)){return}this.uemStatus=t.data;this.judgeUEMIsRunning(true)}dealUemInfo(e){if(os.platform!=Common.SYS_LINUX){return}let t=JSON.parse(e);Log.info(LOG_TAG,"The status message of the uem info is %s",e);if(!Common.isFieldValid(t.data)||!Common.isFieldValid(t.data.supportWorkspaceIDList)){return}this.uemInfo=t.data;this.judgeUEMIsRunning(false)}dealRouterChanged(e){var t=AppConfig.getSdpcAddr();var o=t+Common.WEB_LOCATION_SUBPATH;var n=JSON.parse(e);o=o+"&"+"tab="+n.data.tab;o=o+"&"+"workspaceID="+n.data.workspaceID;o+="#/";o+=n.data.path;if(HistoryAddr.getHistoryServiceType(o)===Common.SERVICE_VERSION_PLAT){MainWinController.showMainWindow(o,Common.SERVICE_VERSION_PLAT);MainWinController.updateMainWindowInBackground()}MainWinController.sendEventMsgToMainWindow(e)}judgeUEMIsRunning(t){let e=this.uemStatus;let o=this.uemInfo;if(!e||!o){return}let n=true;if(e.workModeStatus==="aTrustMode"||e.startStatus!=="uemStartSuccess"||e.installStatus==="uemInstalled"&&e.rebootStatus==="needReboot"){n=false}let r=AppConfig.getUserStatus();if(e.runStatus==="uemIsRunning"&&(r.status===Common.ONLINE&&n)&&!!o.supportWorkspaceIDList.length){this.trayView.uemRunning();if(!t){return}let e=HistoryAddr.getHistoryServiceType(AppConfig.getSdpcAddr());if(e===Common.SERVICE_VERSION_LOW){this.onOpenAppCenterByBrowser(null)}}}dealTunnelLineStatusMsg(t,o){Assert(typeof t=="string"&&typeof o=="string");var e=null;try{e=JSON.parse(o);this.dealTunnelLineStatus(e.data.tunnelLineStatus)}catch(e){Log.warn(LOG_TAG,"%s json parse in %s failed!",o,t)}}dealStatusTunnelFlow(t,o){Assert(typeof t=="string"&&typeof o=="string");var e=null;try{e=JSON.parse(o)}catch(e){Log.warn(LOG_TAG,"%s json parse in %s failed!",o,t)}if(!e.data)return;if(this.trayView&&this.trayView.trayTip&&this.trayView.trayTip.length>0){this.trayView.trayTip[1]=util.format("%s: [%s]%s [%s]%s",Language.Config.get(Language.Lib.TUNNELFLOW_TITLE),Language.Config.get(Language.Lib.TUNNELFLOW_UP),e.data.flowUpSpeedStr,Language.Config.get(Language.Lib.TUNNELFLOW_DOWN),e.data.flowDownSpeedStr);this.trayView.setTrayToolTipSafe(this.trayView.trayTip.join(os.EOL))}const n=require("../controller/window_manager");var r=n.getWindowByName("FlowWindow");if(r){r.sendEventMsg(CommonEvent.IPC_CHANGE_PANEL_WINDOW,o)}const i=require("../service/flow_monitor");i.tunnel.update(o)}recheckStatusStop(){if(this.recheckStaIntervalId){clearInterval(this.recheckStaIntervalId);this.recheckStaIntervalId=null}}recheckStatus(e){if(e==Common.LOGIN||e==Common.LOGOUT||e==Common.ONLINE||e==Common.OFFLINE||e==Common.CONNECT){if(this.recheckStaIntervalId){clearInterval(this.recheckStaIntervalId);this.recheckStaIntervalId=null;Log.info(LOG_TAG,"user status(%s) is not disconnect, stop the repeated detection of user status",e)}}if(e==Common.DISCONNECT||e==Common.NETWORK_UNAVAIABLE){if(this.recheckStaIntervalId){clearInterval(this.recheckStaIntervalId);this.recheckStaIntervalId=null}this.recheckStaIntervalId=setInterval(()=>{this.onGetUserStatus()},3e3);Log.info(LOG_TAG,"user status is %s, start the repeated detection of user status",e)}}dealEventMsg(e,t){if(e!="statusEvent|tunnelFlow"){Log.info(LOG_TAG,"Process bus message, dealEventMsg topic: %s; message: %s",e,t)}var o=e.split("|");if(o[1]!=null){o=o[1]}if(o===Common.LOGIN||o===Common.ONLINE){if(Common.currentMode===Common.RUNMODE_AIO){this.onGetUserStatus()}}if(o===Common.LOGIN){this.dealStatusLogin(e,t)}else if(o===Common.LOGOUT){Util.clearCookies(AppConfig.getSdpcAddr());this.dealStatusLogout(e,t);resetUdpKnockRecords()}else if(o==Common.OFFLINE){this.dealStatusOffline(t);resetUdpKnockRecords()}else if(o==Common.DISCONNECT||o==Common.NETWORK_UNAVAIABLE){this.setTrayStatus(Common.DISCONNECT);this.sendEventMsgTray({event:Common.DISCONNECT});resetUdpKnockRecords()}else if(o==Common.CONNECT){this.setTrayStatus(Common.CONNECT);this.sendEventMsgTray({event:Common.CONNECT})}else if(o==Common.TUNNELAVAILABLE||o==Common.TUNNELUNAVAILABLE||o==Common.RESOURCECHANGED){Log.info(LOG_TAG,"Event message not in the detection range, ingore event:%s ",o)}else if(o==Protocal.EVENT_TUNNEL_FLOW){this.dealStatusTunnelFlow(e,t)}else if(o==Protocal.EVENT_TUNNEL_LINE_STATUS_CHANGED){this.dealTunnelLineStatusMsg(e,t)}else if(o==Common.ONLINE){this.sendEventMsgTray(t);NotifyMsgManager.dealEventMsg(e,t);this.bClientLogin=true}else if(o==Common.UEM_SUPPORT_WORKSPACE||o==Common.RESOURCE_READY){MainWinController.sendEventMsgToMainWindow(t)}else if(o==Common.SETTER_CHANGED){MainWinController.dealSetterChanged(t);if(this.trayView&&this.trayView.dealSetterChanged){this.trayView.dealSetterChanged(t)}}else if(o==Common.UEM_STATUS){this.dealUemStatus(t)}else if(o==Common.UEM_INFO){this.dealUemInfo(t)}else if(o==Common.UEM_VIRTUAL_NET_INFO){const n=require("../controller/window_manager");n.broadcastMessage(CommonEvent.IPC_CHANNEL_VIRTUALNET_INFO,JSON.parse(t));this.notifyTrayEvent(Common.UEM_VIRTUAL_NET_INFO,t)}else if(o==Common.UEM_VIRTUAL_NET_CHANGE){const n=require("../controller/window_manager");n.broadcastMessage(CommonEvent.IPC_CHANNEL_VIRTUALNET_CHANGE,JSON.parse(t));this.notifyTrayEvent(Common.UEM_VIRTUAL_NET_CHANGE,t)}else if(o==Common.UEM_CONFIG_CHANGE||o==Common.UEM_APP_FILTER_CHANGED){const n=require("../controller/window_manager");n.broadcastMessage(CommonEvent.IPC_CHANNEL_UEM_CONFIG_CHANGE,JSON.parse(t));this.notifyTrayEvent(o,t)}else if(o==Common.UEM_FLOAT_BALL_CHANGE){const n=require("../controller/window_manager");n.broadcastMessage(CommonEvent.IPC_CHANNEL_FLOAT_BALL_CHANGE,JSON.parse(t));this.notifyTrayEvent(Common.UEM_FLOAT_BALL_CHANGE,t)}else if(o==Common.UEM_ROUTER_CHANGED){this.dealRouterChanged(t)}else if(o==Common.EVENTBUS_READY){const r=require("../service/util/notifier");r.broadcast("messageEvent|aTrustTrayStart","launchTray");EaioController.start();this.checkTrayRunMode()}else if(o==Common.SDPC_HISTORY_ADDR_CHANGED){this.processSdpcHistoryAddChanged(t)}else if(o==Common.PHISING_RISK||o==Common.PHISING_RISK_CONFIRM){this.processPishingRiskEvent(o,t)}else if(o==Common.SELECTUPDATEMODEL){this.dealSelectUpdateModelEvent(t)}else{this.sendEventMsgTray(t)}}dealApprovalEventMsg(e,t){var o=e.split("|");if(o[1]!=null){o=o[1]}if(o===Common.APPROVAL_ROLE_CHANGED){this.sendEventMsgTray(t,false);if(this.trayView){this.trayView.updateApprovalRole(t)}}else if(o===Common.APPROVAL_NUMBER_CHANGED){this.sendEventMsgTray(t,true);if(this.trayView){this.trayView.updateApprovalNum(t)}}}sendEventMsgTray(e,t){if(this.panelWindow){this.panelWindow.sendEventMsg(e)}if(t!=true){MainWinController.sendEventMsgToMainWindow(e)}}showLoginPagePreCheck(e,t,o){if(!this.initFlag){MainWinController.setTrayDelegate(this);MainWinController.showLoginPagePreCheck(e,t,o)}}showPanelOrBrowser(e,t,o){Log.info(LOG_TAG,"[showPanelOrBrowser] addr[%s], bShowPanel[%s], bOpenBrowser[%s]",e,t,o);if(os.platform()===Common.SYS_LINUX){this.onOpenAppCenterByBrowser(null)}else{if(t){Log.info(LOG_TAG,"[showPanelOrBrowser] onShowPanelWindow");this.setShouldShowPanel(true);this.onShowPanelWindow()}else if(o){Log.info(LOG_TAG,"[showPanelOrBrowser] OpenDefaultBrowser, addr[%s]",e);Util.OpenDefaultBrowser(e)}}}updateSdpcUrl(e,t,o){Log.info(LOG_TAG,"[updateSdpcUrl] url[%s]",e);var n=Util.deepClone(Common.USER_STATUS);n.data.addr=e;AppConfig.setUserStatus(n);this.sendEventMsgTray({event:Common.NETWORK_UNAVAIABLE},true);this.shouldShowPanel=false;HistoryAddr.addHistoryAddr(e,t,o);MainWinController.getCopyWriting(e,t)}switchSdpcUrl(t){Log.info(LOG_TAG,"switch sdpc url with url: ",t);if(!t){return}const o=require("../service/util/notifier");setTimeout(()=>{const e=HistoryAddr.getHistoryAddr();o.broadcast("messageEvent|switchSdpcUrl",{addr:t,hisAddr:e})},SWITCH_SDPC_URL_INTERVAL)}restoreRetryOnlineConfig=()=>{if(this.onlineCurrentRetryTimes!=0){this.onlineCurrentRetryTimes=0;this.onlineRetryTimeout=RETRY_ONLINE_TIME_BASE}};retryOnline=e=>{if(!e||!e.data){Log.warn(LOG_TAG,"retry online params invalid.");this.restoreRetryOnlineConfig();return false}if(e.code==ErrorCode.ERROR_SUCCESS){Log.info(LOG_TAG,"user goes online successfully.");this.restoreRetryOnlineConfig();return false}if(this.onlineCurrentRetryTimes>=RETRY_ONLINE_MAX_TIMES){Log.info(LOG_TAG,"the user has reached the maximum number of retries when trying to go online.");this.restoreRetryOnlineConfig();return false}this.onlineCurrentRetryTimes+=1;this.onlineRetryTimeout*=RETRY_ONLINE_TIME_FACTOR;Log.info(LOG_TAG,"onUserOnline request fail: ",e.code,"try to get back online for",this.onlineCurrentRetryTimes,"time, retry timeout:",this.onlineRetryTimeout,"ms");setTimeout(()=>{var e=AppConfig.initRequestData({});Util.requestAgent("/v1/service/status",e,e=>{if(!e){Log.warn(LOG_TAG,"query user status fail. the response is empty.");this.restoreRetryOnlineConfig();return}if(e.code==ErrorCode.ERROR_SUCCESS&&e.data.status===Common.OFFLINE){Log.info(LOG_TAG,"retry to online with",this.onlineCurrentRetryTimes,"time");this.onUserOnline(null,this.retryOnline);return}Log.info(LOG_TAG,"the user status is no longer offline, query status code: ",e.code,"user status:",e.data.status);this.restoreRetryOnlineConfig()})},this.onlineRetryTimeout);return true};_regist(){const e=require(".././service/util/rpc_SdpDaemonService.js");var t=new e;Log.info(LOG_TAG,"Register the tray process to the daemon start");t.startPromise().then(function(e){checker.ignore_unuse(e);return t.registerMonitorPromise()}).then(function(){Log.info(LOG_TAG,"Register the tray process to the daemon success")}).catch(function(e){Log.error(LOG_TAG,"Register the tray process to the daemon failure",e)}).finally(function(){t.destroy();Log.info(LOG_TAG,"Register the tray process to the daemon finish")})}_unregist(){const e=require(".././service/util/rpc_SdpDaemonService.js");var t=new e;Log.info(LOG_TAG,"RpcDaemonClient.unRegisterMonitor start");t.startPromise().then(function(e){checker.ignore_unuse(e);return t.unRegisterMonitorPromise()}).then(function(){Log.info(LOG_TAG,"RpcDaemonClient.unRegisterMonitor success")}).catch(function(e){Log.error(LOG_TAG,"RpcDaemonClient.unRegisterMonitor throw error",e)}).finally(function(){t.destroy();Log.info(LOG_TAG,"RpcDaemonClient.unRegisterMonitor finish")})}async processSdpcHistoryAddChanged(e){try{await HistoryAddr.reloadHistoryRecords();this.sendEventMsgTray(e)}catch(e){Log.warn(LOG_TAG,"[processSdpcHistoryAddChanged] failed, reason:",e)}}processPishingRiskEvent(t,o){try{let e=JSON.parse(o);Log.info(LOG_TAG,`[processPishingRiskEvent] event ${t}`);if(t===Common.PHISING_RISK){Log.info(LOG_TAG,`[processPishingRiskEvent] showPhishingRiskWarningPage ${Common.PHISING_RISK}`);MainWinController.showPhishingRiskWarningPage({urlparam:{query:{origin:e.data.origin,target:e.data.target,riskType:e.data.riskType}}})}else if(t===Common.PHISING_RISK_CONFIRM){Log.info(LOG_TAG,`[processPishingRiskEvent] showPhishingRiskWarningConfirmationPage ${Common.PHISING_RISK_CONFIRM}`);MainWinController.showPhishingRiskWarningConfirmationPage(e.data.origin)}}catch(e){Log.warn(LOG_TAG,"[processPishingRiskEvent] error",e)}}}module.exports=new TrayController;