const BrowserWindow=require("electron").BrowserWindow;const Assert=require("assert");const Log=require("../service/util/logger");const Common=require("../service/common");const AppConfig=require("../model/app_config");const CommonEvent=require("../service/protocal");const os=require("os");const LOG_TAG="[WinManager]";const CREATING_FLAG="Creating";class WinManager{constructor(){this.mWinListMap=new Map;this.mNormalWinListMap=new Map;this.mRemoteWinListMap=new Map;this._isDestroyed=false}dealEventMsg(e,i){Assert(typeof e=="string","topic should be a string.");Assert(typeof i=="string","topic should be a string.");var n=e.split("|");if(n[1]!=null){n=n[1]}if(n=="logout"||n=="offline"){Log.info(LOG_TAG,"recv event[%s], will close [%s] and [%s]",n,Common.WIN_OFFILE_EXIT_TIP_NAME,Common.WIN_MIMTCHECKMSG_NAME);this.closeNormalWindowByName(Common.WIN_OFFILE_EXIT_TIP_NAME);this.closeNormalWindowByName(Common.WIN_MIMTCHECKMSG_NAME)}}getWindowByName(i){if(i!="FlowWindow"){Log.info(LOG_TAG,"[getWindowByName], name[%s]",i)}if(this.mNormalWinListMap.has(i)){if(i!="FlowWindow"){Log.info(LOG_TAG,"[getWindowByName], found")}return this.mNormalWinListMap.get(i)}if(this.mWinListMap.has(i)){let e=this.mWinListMap.get(i);if(e._isDestroyed===false){return e}}if(i!="FlowWindow"){Log.info(LOG_TAG,"[getWindowByName], not found return null")}return null}createWindow(e){Assert(e>0,"param id error:"+e);let i=null;Log.info(LOG_TAG,"[createWindow], id[%s]",e);if(this.mWinListMap.has(e)){i=this.mWinListMap.get(e);if(i._isDestroyed===false){Log.info(LOG_TAG,"[createWincdow], winName[%s] is exist, return window",i.winName);return i}Log.info(LOG_TAG,"[createWindow], winName[%s] is destroyed, will recreate",i.winName);this.mWinListMap.delete(e);i=null}switch(e){case Common.WIN_MESSAGE_ID:{i=this.createMessageWindow();break}case Common.WIN_NOTIFY_ID:{i=this.createNoitfyWindow();break}case Common.WIN_VIRTUALNET_MESSAGE_ID:{i=this.createVirtualNetMessageWindow();break}case Common.WIN_PANEL_ID:{i=this.createPanelWindow();break}case Common.WIN_UPDATE_ID:{i=this.createUpdateWindow();break}default:Assert(false,"WinManager invalid param winID");break}if(i!=null){this.mWinListMap.set(e,i)}return i}createMessageWindow(){Log.info(LOG_TAG,"createMessageWindow");const e=require("../view/message_window");var i=new e(this).init();return i}createNoitfyWindow(){Log.info(LOG_TAG,"createNoitfyWindow");const e=require("../view/notify_window");var i=new e(this).init();return i}createVirtualNetMessageWindow(){Log.info(LOG_TAG,"createVirtualNetMessageWindow");const e=require("../view/virtual_net_message_window");var i=new e(this).init();return i}createPanelWindow(){Log.info(LOG_TAG,"createPanelWindow");const e=require("../view/panel_window");var i=new e(this).init();return i}createUpdateWindow(){Log.info(LOG_TAG,"createUpdateWindow");const e=require("../view/update_window");var i=new e(this).init();return i}createPhishingRiskWarningWindow(i){Log.info(LOG_TAG,"[createPhishingRiskWarningWindow] create Phishing risk warning window");i=i||{};i=Object.assign({delegate:this},Common.WIN_OPTION_TEMPLATE,i);i.url=Common.WIN_PHISHING_RISK_WARNING_WINDOW_URL;i.winName=Common.WIN_PHISHING_RISK_WARNING_WINDOW_NAME;i.winID=Common.WIN_PHISHING_RISK_WARNING_ID;i.urlparam=i.urlparam||{};i.urlparam.fragment="!/anti_fishing_local";i.urlparam.query=i.urlparam.query||{};i.urlparam.query.page="anti_fishing_local";i.baseWinOptions={skipTaskbar:false,alwaysOnTop:true};if(null==i.winName){Log.warn(LOG_TAG,"[createPhishingRiskWarningWindow] winName is null");return null}Log.info(LOG_TAG,"[createPhishingRiskWarningWindow] start");if(this.mNormalWinListMap.has(i.winName)){Log.info(LOG_TAG,i.winName+" already create!");let e=this.mNormalWinListMap.get(i.winName);e.window.flashFrame(true);return e}const e=require("../view/normal_window");let n=new e(i).init();if(null==n){Log.warn(LOG_TAG,i.winName+" create fail!");return null}Log.info(LOG_TAG,i.winName+" create success!");this.mNormalWinListMap.set(i.winName,n);return n}createMainWindow(e){Log.info(LOG_TAG,"[createMainWindow] createParam[%s]",e);var i=null;if(this.mWinListMap.has(Common.WIN_MAIN_ID)){i=this.mWinListMap.get(Common.WIN_MAIN_ID);if(i===CREATING_FLAG){Log.info(LOG_TAG,"[createMainWindow] is beging creating, this time return, wait last create result");return null}if(i._isDestroyed===false){Log.info(LOG_TAG,"[createMainWindow] not switchWindow, main window already exist, show");i.show();return i}else{Log.info(LOG_TAG,"[createMainWindow] not switchWindow, main window is destroyed, will recreate");this.mWinListMap.delete(i.winID);i=null}}this.mWinListMap.set(Common.WIN_MAIN_ID,CREATING_FLAG);e.delegate=this;const n=require("../view/main_window");i=new n(e).init();if(i!=null){this.mWinListMap.set(Common.WIN_MAIN_ID,i)}else{this.mWinListMap.delete(Common.WIN_MAIN_ID)}return i}createUemSandboxWindow(i,n){if(null==i.winName){Log.warn(LOG_TAG,"[createUemSandboxWindow] winName is null");return null}Log.info(LOG_TAG,"[createUemSandboxWindow] start");if(this.mNormalWinListMap.has(i.winName)){Log.info(LOG_TAG,i.winName+" already create!");let e=this.mNormalWinListMap.get(i.winName);if(e&&e._isDestroyed===false){Log.info(LOG_TAG,"[createUemSandboxWindow], winName[%s] is exist, sendmessage, return window",e.winName);e.sendEventMsg(CommonEvent.IPC_UEM_SANDBOX_MESSAGE,n);return e}else{Log.info(LOG_TAG,"[createUemSandboxWindow], winName[%s] is destroyed, will recreate",e.winName);this.mNormalWinListMap.delete(e.winName);e=null}}i.delegate=this;const e=require("../view/normal_window");let o=new e(i).init();if(null==o){Log.warn(LOG_TAG,i.winName+" create fail!");return null}Log.info(LOG_TAG,i.winName+" create success!");this.mNormalWinListMap.set(i.winName,o);if(typeof o.show=="function"){o.show();o.sendEventMsg(CommonEvent.IPC_UEM_SANDBOX_MESSAGE,n)}return o}createUemApprovalWindow(i,n){Log.info(LOG_TAG,"[createUemApprovalWindow] ... start");i.delegate=this;if(this.mWinListMap.has(i.winID)){Log.info(LOG_TAG,i.winName+" already create!");let e=this.mWinListMap.get(i.winID);if(e._isDestroyed===false){Log.warn(LOG_TAG,i.winName+" is not destroyed!");if(typeof e.show=="function"){e.show();e.addMessage(n)}return e}else{Log.info(LOG_TAG,"[createUemApprovalWindow], winName[%s] is destroyed, will recreate",e.winName);this.mWinListMap.delete(i.winID);e=null}Log.warn(LOG_TAG,i.winName+" is destroyed!")}const e=require("../view/approval_window");let o=new e(i).init();if(null==o){Log.warn(LOG_TAG,i.winName+" create fail!");return null}this.mWinListMap.set(i.winID,o);if(typeof o.show=="function"){}Log.info(LOG_TAG,"[createUemApprovalWindow] ... end");return o}createUemApprovalNotifyWindow(i,n){if(null==i.winID){Log.warn(LOG_TAG,"[createUemApprovalNotifyWindow] winId is null");return null}Log.info(LOG_TAG,"[createUemApprovalNotifyWindow] start");if(this.mNormalWinListMap.has(i.winID)){Log.info(LOG_TAG,i.winName+" already create!");let e=this.mNormalWinListMap.get(i.winName);if(e&&e._isDestroyed===false){Log.info(LOG_TAG,"[createUemApprovalNotifyWindow], winName[%s] is exist, sendmessage, return window",e.winName);if(typeof e.show=="function"){e.sendEventMsg(CommonEvent.IPC_CHANNEL_APPROVAL_INFO_CHANGED,JSON.stringify(n));e.show()}return e}else{Log.info(LOG_TAG,"[createUemApprovalNotifyWindow], winName[%s] is destroyed, will recreate",e.winName);this.mNormalWinListMap.delete(e.winName);e=null}}i.delegate=this;const e=require("../view/normal_window");let o=new e(i).init();if(null==o){Log.warn(LOG_TAG,i.winName+" create fail!");return null}Log.info(LOG_TAG,i.winName+" create success!");this.mNormalWinListMap.set(i.winName,o);if(typeof o.show=="function"){o.show();o.sendEventMsg(CommonEvent.IPC_CHANNEL_APPROVAL_INFO_CHANGED,JSON.stringify(n))}return o}createMIMTCheckMsgWindow(i){if(null==i.winName){Log.warn(LOG_TAG,"[createMIMTCheckMsgWindow] winName is null");return null}Log.info(LOG_TAG,"[createMIMTCheckMsgWindow] start");if(this.mNormalWinListMap.has(i.winName)){Log.info(LOG_TAG,i.winName+" already create!");let e=this.mNormalWinListMap.get(i.winName);if(e&&e._isDestroyed===false){Log.info(LOG_TAG,"[createMIMTCheckMsgWindow], winName[%s] is exist, will show",e.winName);if(typeof e.show=="function"){e.show()}return e}else{Log.info(LOG_TAG,"[createMIMTCheckMsgWindow], winName[%s] is destroyed, will recreate",e.winName);this.mNormalWinListMap.delete(e.winName);e=null}}i.delegate=this;const e=require("../view/normal_window");let n=new e(i).init();if(null==n){Log.warn(LOG_TAG,i.winName+" create fail!");return null}Log.info(LOG_TAG,i.winName+" create success!");this.mNormalWinListMap.set(i.winName,n);if(typeof n.show=="function"){n.show()}return n}createCommonMsgWindow(i){if(null==i.winName){Log.warn(LOG_TAG,"createCommonMsgWindow winName is null");return null}Log.info(LOG_TAG,"createCommonMsgWindow start, window name: "+i.winName);if(this.mNormalWinListMap.has(i.winName)){Log.info(LOG_TAG,i.winName+" already create!");let e=this.mNormalWinListMap.get(i.winName);if(e){if(typeof e.show=="function"){e.show()}}return e}i.delegate=this;const e=require("../view/normal_window");let n=new e(i).init();if(null==n){Log.warn(LOG_TAG,i.winName+" create fail!");return null}Log.info(LOG_TAG,i.winName+" create success!");this.mNormalWinListMap.set(i.winName,n);if(typeof n.show=="function"){n.show()}return n}createForceCommonWindow(i){if(null==i.winName){Log.warn(LOG_TAG,"[createForceCommonWindow] winName is null");return null}Log.info(LOG_TAG,"[createForceCommonWindow] start");if(this.mNormalWinListMap.has(i.winName)){Log.info(LOG_TAG,i.winName+" already create!");let e=this.mNormalWinListMap.get(i.winName);if(e&&e._isDestroyed===false){Log.info(LOG_TAG,"[createForceCommonWindow], winName[%s] is exist, will show",e.winName);if(typeof e.show=="function"){e.show()}return e}else{Log.info(LOG_TAG,"[createForceCommonWindow], winName[%s] is destroyed, will recreate",e.winName);this.mNormalWinListMap.delete(e.winName);e=null}}i.delegate=this;const e=require("../view/normal_window");let n=new e(i).init();if(null==n){Log.warn(LOG_TAG,i.winName+" create fail!");return null}Log.info(LOG_TAG,i.winName+" create success!");this.mNormalWinListMap.set(i.winName,n);if(typeof n.show=="function"){n.show()}return n}createNormalWindow(i){var n={winName:null,url:null,winID:null,delegate:this,parent:null,modal:false,baseWinOptions:null};Log.info(LOG_TAG,"[createNormalWindow], data[%s]",i);if(i){if(i.name){n.winName=i.name}if(i.url){n.url=Common.WIN_URL_ADD_PARAM(i.url,{name:Common.CLIENT_NAME,data:AppConfig.trayTheme.cusName})}if(i.option){n.baseWinOptions=i.option}}Log.info(LOG_TAG,"create "+n.winName);if(this.mNormalWinListMap.has(n.winName)){Log.info(LOG_TAG,n.winName+" already create!");let e=this.mNormalWinListMap.get(n.winName);if(e&&e._isDestroyed===false){Log.info(LOG_TAG,"[createNormalWindow], winName[%s] is exist, will show",e.winName);if(typeof e.show=="function"){e.show()}if(typeof i.optType=="string"){i.optType="openWin"}return e}else{Log.info(LOG_TAG,"[createNormalWindow], winName[%s] is destroyed, will recreate",e.winName);this.mNormalWinListMap.delete(e.winName);e=null}}Log.info(LOG_TAG,"[createNormalWindow], platform[%s]",os.platform());if(os.platform()===Common.SYS_MAC||os.platform()===Common.SYS_WIN32){if(n.baseWinOptions&&typeof n.baseWinOptions.parentId=="number"){Log.info(LOG_TAG,"[createNormalWindow], parentId is valid");let e=BrowserWindow.fromId(n.baseWinOptions.parentId);if(e){Log.info(LOG_TAG,"[createNormalWindow], parentWin is valid");n.parent=e;if(typeof n.baseWinOptions.modal=="boolean"){Log.info(LOG_TAG,"[createNormalWindow], window is modal");n.modal=n.baseWinOptions.modal}}}}else if(os.platform()===Common.SYS_LINUX){if(n.baseWinOptions&&n.baseWinOptions.modal&&typeof n.baseWinOptions.modal=="boolean"){Log.info(LOG_TAG,"[createNormalWindow], window is modal");n.modal=n.baseWinOptions.modal;if(typeof n.baseWinOptions.parentId=="number"){Log.info(LOG_TAG,"[createNormalWindow], parentId is valid");let e=BrowserWindow.fromId(n.baseWinOptions.parentId);n.parent=e?e:null}}}Log.info(LOG_TAG,"[createNormalWindow], winOptions[%s]",n);const e=require("../view/normal_window");let o=new e(n).init();if(o){this.mNormalWinListMap.set(n.winName,o)}return o}createRemoteWindow(i){Log.info(LOG_TAG,"[createRemoteWindow], init winOptions[%s]",i);i.delegate=this;if(this.mRemoteWinListMap.has(i.winName)){Log.info(LOG_TAG,i.winName+" already create!");let e=this.mRemoteWinListMap.get(i.winName);if(e&&e._isDestroyed===false){Log.info(LOG_TAG,"[createRemoteWindow], winName[%s] is exist, will showInactive",e.winName);if(typeof e.show=="function"){e.window.showInactive()}return e}else{Log.info(LOG_TAG,"[createRemoteWindow], winName[%s] is destroyed, will recreate",e.winName);this.mRemoteWinListMap.delete(e.winName);e=null}}i.url=Common.WIN_URL_ADD_PARAM(i.url,{name:Common.CLIENT_NAME,data:AppConfig.trayTheme.cusName});Log.info(LOG_TAG,"[createRemoteWindow], last winOptions[%s]",i);const e=require("../view/remote_window");let n=new e(i).init();if(n){if(typeof i.type=="string"){n["type"]=i.type}this.mRemoteWinListMap.set(i.winName,n)}return n}closeRemoteWindowByType(i){Assert(i,"type shout be a string");Log.info(LOG_TAG,"[closeRemoteWindowByType], type[%s]",i);if(i=="all"){this.mRemoteWinListMap.forEach(e=>{if(typeof e.window.close=="function"){e.window.close();Log.info(LOG_TAG,e.winName,"window close.")}});Log.info(LOG_TAG,"[closeRemoteWindowByType], clear remote window map");this.mRemoteWinListMap.clear();return}this.mRemoteWinListMap.forEach(e=>{if(typeof e.window.close!="function"){return}if(typeof e.type=="string"&&e.type==i){e.window.close();this.mRemoteWinListMap.delete(e.winName);Log.info(LOG_TAG,e.winName,"window close.")}})}closeRemoteWindowByName(i){Assert(i,"winName shout be a string");Log.info(LOG_TAG,"[closeRemoteWindowByName], winName[%s]",i);this.mRemoteWinListMap.forEach(e=>{if(typeof e.window.close!="function"){return}if(typeof e.winName=="string"&&e.winName==i){e.window.close();this.mRemoteWinListMap.delete(e.winName);Log.info(LOG_TAG,e.winName,"window close.");return}});Log.info(LOG_TAG,"[closeRemoteWindowByName], not found winName[%s]",i)}closeNormalWindowByName(i){Assert(typeof i=="string");Log.info(LOG_TAG,"[closeNormalWindowByName], winName[%s]",i);this.mNormalWinListMap.forEach(e=>{if(!e.window||typeof e.window.close!="function"){return}if(e.winName==i){e.window.close();this.mNormalWinListMap.delete(e.winName);Log.info(LOG_TAG,e.winName,"window close.");return}});Log.info(LOG_TAG,"[closeNormalWindowByName], not found winName[%s]",i)}closeWinListWindowByName(i){Log.info(LOG_TAG,"[closeWinListWindowByName], winName[%s]",i);this.mWinListMap.forEach(e=>{if(!e.window||typeof e.window.destroy!="function"){return}if(e.winName==i){e.window.destroy();this.mWinListMap.delete(e.winName);Log.info(LOG_TAG,e.winName,"window close.");return}});Log.info(LOG_TAG,"[closeWinListWindowByName], not found winName[%s]",i)}windowNextTimeNoRemind(e){Log.info(LOG_TAG,"An IPC(enhancedAuthNextTimeNoRemind) event was received, data:%s",e);const i=require("jsonschema");let n=i.validate(e,Common.schemaNTNoRemind);if(n.valid){const o=require("./acl_win_remind_manager");o.saveNoRemindAclWin(e)}else{Log.warn(LOG_TAG,"IPC(enhancedAuthNextTimeNoRemind) event processing failed. reason: Parameter(%s) type verification failed",e)}return{code:Number(!n.valid),message:n.toString(),data:{}}}destroy(){Log.info(LOG_TAG,"destroy all window");this.mWinListMap.forEach(function(e){if(e!=null&&!e.isDestroyed()){e.destroy()}});this.mWinListMap.clear();this._isDestroyed=true}hide(){Log.info(LOG_TAG,"hide window");this.mWinListMap.forEach(function(e){e.hide()})}isDestroyed(){return this._isDestroyed}winWillCloseEvent(e,i=true){Assert(e,"winWillCloseEvent window is null");Log.info(LOG_TAG,"winWillCloseEvent winName:",e.winName);if(!this.mWinListMap.has(e.winID)){Log.info(LOG_TAG,"winWillCloseEvent not has this win or win object null");return}var n=this.mWinListMap.get(e.winID);if(!n){Log.warn(LOG_TAG,"close win fail","may be win is close or exception can not find win id");return}this.mWinListMap.delete(n.winID);if(i){n.destroy();n=null}}normalwinWillCloseEvent(e,i=true){Assert(e,"normalwinWillCloseEvent window is null");Log.info(LOG_TAG,"normalwinWillCloseEvent winName:",e.winName);if(!this.mNormalWinListMap.has(e.winName)){Log.info(LOG_TAG,"normalwinWillCloseEvent not has this win or win object null");return}var n=this.mNormalWinListMap.get(e.winName);if(!n){Log.warn(LOG_TAG,"close win fail","may be win is close or exception can not find win id");return}this.mNormalWinListMap.delete(e.winName);if(i){n.destroy();n=null}}remotewinWillCloseEvent(e,i=true){Assert(e,"remotewinWillCloseEvent window is null");Log.info(LOG_TAG,"remotewinWillCloseEvent winName:",e.winName);if(!this.mRemoteWinListMap.has(e.winName)){Log.info(LOG_TAG,"remotewinWillCloseEvent not has this win or win object null");return}var n=this.mRemoteWinListMap.get(e.winName);if(!n){Log.warn(LOG_TAG,"close win fail","may be win is close or exception can not find win id");return}this.mRemoteWinListMap.delete(e.winName);if(i){n.destroy();n=null}}getWndInfoByName(i){Log.info(LOG_TAG,"[getWndInfoByName] winName[%s]",i);let n={code:0,message:"ok",data:{x:0,y:0,width:0,height:0}};for(var e of this.mWinListMap.values()){if(e.winName===i){n.data=e.window.window.getBounds();Log.info(LOG_TAG,"[getWndInfoByName] winName[%s], bounds[%s]",i,n.data);return n}}if(this.mNormalWinListMap.has(i)){let e=this.mNormalWinListMap.get(i);Log.info(LOG_TAG,"[getWndInfoByName] winName[%s], bounds[%s]",i,n.data);n.data=e.window.getBounds();return n}if(this.mRemoteWinListMap.has(i)){let e=this.mRemoteWinListMap.get(i);Log.info(LOG_TAG,"[getWndInfoByName] winName[%s], bounds[%s]",i,n.data);n.data=e.window.getBounds();return n}n.code=1;n.message="not found window";return n}broadcastMessage(i,n){try{Log.info(LOG_TAG,"[broadcastMessage] ipcchannelkey[%s], param[%s]",i,n);for(let e of this.mWinListMap.values()){if(e.window&&typeof e.window.sendEventMsg=="function"){e.window.sendEventMsg(i,n)}}for(let e of this.mNormalWinListMap.values()){if(e&&typeof e.sendEventMsg=="function"){e.sendEventMsg(i,n)}}for(let e of this.mRemoteWinListMap.values()){if(e&&typeof e.sendEventMsg=="function"){e.sendEventMsg(i,n)}}}catch(e){Log.warn(LOG_TAG,`broadcastMessage throw exception, key[${i}], param[${n}], reason:`,e.toString())}}winSwitchHandle(e){if(!Common.isFieldValid(e)){Log.info(LOG_TAG,"winSwitchHandle failed :window is invalid");return}this.winWillCloseEvent(e,false);this.mWinListMap.set(e.winID,e)}normalwinwitchHandle(e){if(!Common.isFieldValid(e)){Log.info(LOG_TAG,"normalwinwitchHandle failed :window is invalid");return}this.normalwinWillCloseEvent(e,false);this.mNormalWinListMap.set(e.winName,e)}remotewinSwitchHandle(e){if(!Common.isFieldValid(e)){Log.info(LOG_TAG,"remotewinSwitchHandle failed :window is invalid");return}this.remotewinWillCloseEvent(e,false);this.mRemoteWinListMap.set(e.winName,e)}}module.exports=new WinManager;