const util=require("util");const os=require("os");const net=require("net");const fs=require("fs");const assert=require("assert");const path=require("path");const sd=require("silly-datetime");const electron=require("electron");const Language=require("./language");const Util=require("./util/util");const WinManager=require("../controller/window_manager");const Common=require("./common");const Log=require(".././service/util/logger");const exec=require("child_process").exec;const Rpc=require("./util/rpc_client");const to=require("await-to-js").default;const TCP_DETECT_TIMEOUT=500;const LOG_TAG="[diagnosis]";const ERROR_CODE_MAP=new Map([["ECONNREFUSED",{code:10010001,msg:"connection refused"}],["ETIMEOUT",{code:10010002,msg:"connection time out"}],["ENORESPONSE",{code:10010003,msg:"rpc no response"}],["ECORENOTRUNNING",{code:10010004,msg:"core process is not running"}],["ETUNNELNOTRUNNING",{code:10010005,msg:"tunnel process is not running"}],["EUNKOWNERROR",{code:10019999,msg:"unkown error"}]]);class Diagnosis{constructor(){this.m_reqData={url:"",traceid:""};this.m_diagResultMsg=null;this.m_winName=null;this.m_ipcChannelKey=null}createRpcDiagnosisClient(){return new Rpc.RpcClient(Rpc.SdpDiagnosisService)}isRunningForProcess(r,s){let e=new Promise((n,i)=>{let e=process.platform;if(e==="win32"){n();return}let t="";switch(e){case"win32":t=`wmic process where caption=${r}.exe get caption,commandline /value`;break;case"darwin":t=`ps -ax | grep ${r}`;break;case"linux":t=`ps -ax | grep ${r}`;break;default:break}exec(t,(e,t)=>{console.log("process: ",t);if(e){i(e)}else{if(t.toLowerCase().indexOf(s.toLowerCase())>-1){n()}else{i()}}})});return e}isRunningForCoreProcess(){let e=new Promise((e,t)=>{Log.info(LOG_TAG,"begin to check core process running status");this.isRunningForProcess("aTrustAgent","plugins/aTrustCore").then(()=>{Log.info(LOG_TAG,"core process is running");e({service:"core_process"})}).catch(e=>{Log.warn(LOG_TAG,"check core process occur error, error: "+e);if(e){t({service:"core_process",error:e})}else{t({service:"core_process",error:{code:"ECORENOTRUNNING"}})}})});return e}isRunningForTunnelProcess(){let e=new Promise((e,t)=>{Log.info(LOG_TAG,"begin to check tunnel process running status");this.isRunningForProcess("aTrustXtunnel","aTrustXtunnel").then(()=>{Log.info(LOG_TAG,"tunnel process is running");e({service:"tunnel_process"})}).catch(e=>{Log.warn(LOG_TAG,"check tunnel process occur error, error: "+e);if(e){t({service:"tunnel_process",error:e})}else{t({service:"tunnel_process",error:{code:"ETUNNELNOTRUNNING"}})}})});return e}detectTcpConnectivity(s,o){let e=new Promise((e,t)=>{if(!s||!o){var n=new Error(`call detectTcpConnectivity function with error argument, host:${s}, port:${o} `);n.code="ETYPEERROR";n.errno="ETYPEERROR";t(n);return}let i=net.createConnection({port:o,host:s});i.setTimeout(TCP_DETECT_TIMEOUT);var r=false;i.on("connect",()=>{if(!r){e();i.end();r=true}});i.on("timeout",()=>{if(!r){var e=new Error(`Connect to the target(${s}:${o}) timeout through TCP `);e.code="ETIMEOUT";e.errno="ETIMEOUT";t(e);i.end();r=true}});i.on("error",e=>{if(!r){t(e);i.end();r=true}})});return e}testCoreRpcConnectivity(){var e=new Rpc.RpcClient(Rpc.aTrustCoerService);Log.info(LOG_TAG,"Detection aTrustCore RPC legitimacy start");return e.startPromise().then(e=>{return e.IsRpcStatusNormalPromise()}).then(e=>{Log.info(LOG_TAG,`Detection aTrustCore RPC legitimacy success, the response is ${e}`);return e}).catch(e=>{Log.error(LOG_TAG,"Detection aTrustCore RPC legitimacy failure",e);throw e}).finally(()=>{e.destroy();Log.info(LOG_TAG,"Detection aTrustCore RPC legitimacy finish")})}testTunnelRpcConnectivity(){let e=new Rpc.RpcClient(Rpc.SdpDiagnosisService);Log.info(LOG_TAG,"Detection aTrustTunnel RPC legitimacy start");return e.startPromise().then(e=>{return e.IsRpcStatusNormalPromise()}).then(e=>{Log.info(LOG_TAG,`Detection aTrustTunnel RPC legitimacy success, the response is ${e}`);return e}).catch(e=>{Log.error(LOG_TAG,"Detection aTrustTunnel RPC legitimacy failure",e);throw e}).finally(()=>{e.destroy();Log.info(LOG_TAG,"Detection aTrustTunnel RPC legitimacy finish")})}detectCoreRpcService(){return this.testCoreRpcConnectivity()}detectTunnelRpcService(){return this.testTunnelRpcConnectivity()}detectEvnetbusService(){let e=new Promise((e,t)=>{let n=Util.getServicePort(Common.EVENTBUS_NAME,Common.EVENTBUS_DEFAULT_PORT);Log.info(LOG_TAG,util.format("begin to detect eventbus service [port: %d]",n));this.detectTcpConnectivity("127.0.0.1",n).then(()=>{Log.info(LOG_TAG,util.format("detect eventbus service [port: %d] normal",n));e()}).catch(e=>{Log.error(LOG_TAG,util.format("detect eventbus service [port: %d] failure",n),e);e.service="event_bus";t(e)})});return e}sendDiagResultToWeb(e,t,n,i,r=true){let s="";let o="";let a="";let c="";let g=Language.Config.get(Language.Lib.RESDIAG_DETECT_TUNNEL_PROCESS);let u=false;let l=false;switch(e){case"ready":{break}case"running":{break}case"finished":{if(n===0){s="not";let e=Language.Config.get(Language.Lib.RESDIAG_HOWTO_TUNNEL);if(!r){e=Language.Config.get(Language.Lib.RESDIAG_HOWTO_TUNNEL_2)}else{if(os.platform()===Common.SYS_MAC){e=Language.Config.get(Language.Lib.RESDIAG_HOWTO_TUNNEL_MAC_LINUX)}else if(os.platform()===Common.SYS_WIN32){e=Language.Config.get(Language.Lib.RESDIAG_HOWTO_TUNNEL_WINDOWS)}else if(os.platform()===Common.SYS_LINUX){e=Language.Config.get(Language.Lib.RESDIAG_HOWTO_TUNNEL_MAC_LINUX)}}o=Language.Config.get(Language.Lib.RESDIAG_DETECT_TUNNEL_RESULT_ERR);a=e;c=[i];u=true}else{s="all";o=Language.Config.get(Language.Lib.RESDIAG_DETECT_TUNNEL_RESULT_OK);if(i instanceof Array){c=[...i]}else{c=[Language.Config.get(Language.Lib.RESDIAG_DETECT_TUNNEL_RESULT_OK)]}u=true}break}default:{break}}let _={result:o,available:s,details:c,item:g,status:e,howTo:a};let T={event:"diagnosisResult",data:{dianosisItems:[_],finish:u,accessible:l,timeout:1500,traceid:t.data.traceid,url:t.data.url}};if(e=="finished"&&!n){this.sendWebContents(this.m_ipcChannelKey,T)}return _}start(o){let e=new Promise((t,r)=>{if(!(o&&o.event&&o.data&&o.data.url&&o.data.traceid)){var e=util.format("parameter verification is not valid! the format of requset should be {event:'',data:{url:'',traceid:''}}, real data:%s",JSON.stringify(o));Log.warn(LOG_TAG,e);this.sendDiagResultToWeb("finished",o,0,e);return}this.m_reqData.url=o.data.url;this.m_reqData.traceid=o.data.traceid;this.m_isShowFailedLog=false;if(os.platform()===Common.SYS_MAC||os.platform()===Common.SYS_WIN32||os.platform()===Common.SYS_LINUX){const s=new Map([["core_process",Language.Config.get(Language.Lib.RESDIAG_DETECT_CORE_PROCESS_RESULT_ERR)],["tunnel_process",Language.Config.get(Language.Lib.RESDIAG_DETECT_TUNNEL_PROCESS_RESULT_ERR)],["core_rpc",Language.Config.get(Language.Lib.RESDIAG_DETECT_CORE_RPC_RESULT_ERR)],["tunnel_rpc",Language.Config.get(Language.Lib.RESDIAG_DETECT_TUNNEL_RPC_RESULT_ERR)],["event_bus",Language.Config.get(Language.Lib.RESDIAG_DETECT_EVENT_BUS_RESULT_ERR)]]);Promise.all([this.isRunningForCoreProcess(),this.isRunningForTunnelProcess()]).then(()=>{return Promise.all([this.detectCoreRpcService(),this.detectTunnelRpcService()])}).then(()=>{const e=[Language.Config.get(Language.Lib.RESDIAG_DETECT_CORE_PROCESS_RESULT_OK),Language.Config.get(Language.Lib.RESDIAG_DETECT_TUNNEL_PROCESS_RESULT_OK),Language.Config.get(Language.Lib.RESDIAG_DETECT_CORE_RPC_RESULT_OK),Language.Config.get(Language.Lib.RESDIAG_DETECT_TUNNEL_RPC_RESULT_OK),Language.Config.get(Language.Lib.RESDIAG_DETECT_EVENT_BUS_RESULT_OK)];const t=this.sendDiagResultToWeb("finished",o,1,e);console.log("detect basic finished..",e);return this.reqToTunnel(o.data.url,o.data.traceid,[JSON.stringify(t)])}).then(e=>{t(e)}).catch(e=>{let t="";let n=true;if(e&&e.service){n=!["core_process","tunnel_process"].includes(e.service);t=s.get(e.service);if(ERROR_CODE_MAP.has(e.code.toString())){const i=ERROR_CODE_MAP.get(e.code.toString());t=util.format(t,i.code.toString(),i.msg)}else{t=util.format(t,e.code.toString(),e.error.message||"")}}else{t=e}this.sendDiagResultToWeb("finished",o,0,t.toString(),n);r(e)})}else{this.reqToTunnel(o.data.url,o.data.traceid).then(e=>{t(e)}).catch(e=>{this.sendDiagResultToWeb("finished",o,0,e.toString());r(e)})}});return e}diagMsgTransport(t){if(this.winIsDestroyed())return;try{let e=JSON.parse(t);if(e.data.traceid!==this.m_reqData.traceid)return;this.m_diagResultMsg=e;this.sendWebContents(this.m_ipcChannelKey,JSON.stringify(e))}catch(e){var n=util.format("message transport to web failed! %s",e.toString());Log.warn(LOG_TAG,n);let t={event:"diagnosisResult",data:{dianosisItems:[{available:"",details:[n],item:Language.Config.get(Language.Lib.UNKNOWN_ERROR),status:"finished"}],finish:true,accessible:false,timeout:1,traceid:this.m_reqData.traceid,url:this.m_reqData.url}};this.sendWebContents(this.m_ipcChannelKey,t)}}getDiagWindow(){let e=WinManager.getWindowByName(this.m_winName);if(!e||!e.window)return null;return e.window}winIsDestroyed(){let e=this.getDiagWindow();if(!e)return true;return e.isDestroyed()}closeWindow(){WinManager.closeNormalWindowByName(this.m_winName)}dealUserStatus(e){assert(typeof e=="string");let t=e.split(Common.EVENT_DIV_SYMBOL);if(t.length<2)return;let n=t[1];if(n==Common.OFFLINE||n==Common.LOGOUT){this.closeWindow()}}sendWebContents(e,t){if(this.winIsDestroyed()){Log.warn(LOG_TAG,"send web contents failed! diagnoseResWindow windows was not created or destroyed.");return}let n=this.getDiagWindow();try{n.webContents.send(e,t)}catch(e){Log.warn(LOG_TAG,"res diag send web message failed!",e.toString())}}async logExportFile(s,o){try{if(this.winIsDestroyed()){throw new Error("diagnoseResWindow windows was not created or destroyed")}let e=path.join(Common.DEFAULT_LOGS_DIR,"../DiagLogs");let[t]=await to(fs.promises.access(e));if(t){await fs.promises.mkdir(e)}let n=sd.format(new Date,"_YYYYMMDD_HHmmss");e=path.join(e,"diag_result"+n);if(s&&s!="")e=s;let i=this.getDiagWindow();let r=await electron.dialog.showSaveDialog(i,{title:Language.Config.get(Language.Lib.RESDIAG_LOG_EXPORT),defaultPath:e,filters:[{name:"Text",extensions:["txt","log"]}]});if(r.canceled){return r}await fs.promises.writeFile(r.filePath,o);return r}catch(e){Log.warn(LOG_TAG,"[logExportFile] process failed, reason:",e);throw e}}}module.exports={ctor:function(){return new Diagnosis},Diagnosis:Diagnosis};