const Log=require(".././service/util/logger");const Common=require("./common");const os=require("os");const notifier=require("../service/util/notifier");const Is=require("is");const util=require("util");const execFile=util.promisify(require("child_process").execFile);const to=require("await-to-js").default;const LOG_TAG="[history_sdpc]";const ADDR_MAX_NUM=5;class HistorySdpc{constructor(){this.historyArr=[]}tidyUrl(r){const i=Common.parseAddr(r);if(Common.isFieldValid(i)){return i.toLowerCase()}else{return""}}_addAddrFromReadArr(r){if(r.length===0){return}r.forEach(r=>{if(Common.isURLlegal(r.addr)){if(Common.isFieldValid(r.standalone)){this.historyArr.push({addr:r.addr,serviceType:Common.SERVICE_VERSION_NONE})}else if(r.serviceType===Common.SERVICE_VERSION_NONE||r.serviceType===Common.SERVICE_VERSION_LOW){this.historyArr.push(r)}else{r.serviceType=Common.SERVICE_VERSION_PLAT;this.historyArr.push(r)}}else{Log.info(LOG_TAG,"[addAddrFromReadArr] addr[%s] is illegal, ignore",r.addr)}})}async _visitHistory(r,i){let e={timeout:15e3};let t=await execFile(r,i,e);Log.info(LOG_TAG,`[_visitHistory] visit history finish, result is ${t.stdout}`);let s=JSON.parse(t.stdout);if(s.code!=0){throw new Error(`[_visitHistory] visit history failed, result is ${s.code}`)}if(s.error.value!=0){throw new Error(`[_visitHistory] visit history failed, result is ${s.error}`)}Log.info(LOG_TAG,`[_visitHistory] visit history success`);return s.data}async _addHistoryVisit(i,r,e){let t=JSON.stringify(r);Log.info(LOG_TAG,`[_addHistoryVisit] begin, the url is ${i}, record is ${t}`);let s=[];s.push("-a");if(Common.isFieldValid(r.addr)){s.push("--addr");s.push(`${r.addr}`)}if(Common.isFieldValid(r.lastVisitSuccessTime)){s.push("--lastVisitSuccessTime");s.push(`${r.lastVisitSuccessTime}`)}if(Common.isFieldValid(r.serviceType)){s.push("--serviceType");s.push(`${r.serviceType}`)}if(Common.isFieldValid(r.simplifyWorkspace)){s.push("--simplifyWorkspace",r.simplifyWorkspace?"1":"0")}if(Common.isFieldValid(r.workbenchLabel)){s.push("--workbenchLabel");s.push(`${r.workbenchLabel}`)}if(Common.isFieldValid(r.uemEnterLabel)){s.push("--uemEnterLabel");s.push(`${r.uemEnterLabel}`)}let[o]=await to(this._visitHistory(Common.VISITHISORY_PATH,s));if(o){Log.info(LOG_TAG,`[_addHistoryVisit] error, error is ${o}`);return}if(e){let r=JSON.stringify({event:Common.SDPC_HISTORY_ADDR_ADD,data:{addr:i}});notifier.broadcast(Common.SDPC_HISTORY_ADDR_ADD_EVENT,r)}Log.info(LOG_TAG,`[_addHistoryVisit] end`)}_addHistory(i,e,r){let t=JSON.stringify(e);Log.info(LOG_TAG,`[addHistory] begin, the url is ${i}, record is ${t}`);if(Is.object(e)&&Is.string(e.addr)){e.addr=this.tidyUrl(e.addr)}if(os.platform()===Common.SYS_LINUX&&(Common.getOsName()===Common.OS_KYLIN_V10||Common.getOsName().indexOf(Common.OS_UBUNTU_16)!=-1)){Log.info(LOG_TAG,`[addHistory] current os mame is ${Common.getOsName()}, will _addHistoryVisit add record ${t}`);this._addHistoryVisit(i,e,r);return true}else{const s=require("../plugins/aTrustAddonUtils");let r=s.addHistory(this.tidyUrl(i),e);Log.info(LOG_TAG,`[addHistory] end, the url is ${i}`);return r}}async _removeHistoryVisit(r){Log.info(LOG_TAG,`[_removeHistoryVisit] begin, the url is ${r}`);let i=[];i.push("-r");i.push("--addr");if(Common.isFieldValid(r)){i.push(`${r}`)}let[e]=await to(this._visitHistory(Common.VISITHISORY_PATH,i));if(e){Log.info(LOG_TAG,`[_removeHistoryVisit] error, error is ${e}`);return}Log.info(LOG_TAG,`[_removeHistoryVisit] end`)}_removeHistory(i){Log.info(LOG_TAG,`[removeHistory] begin, the url is ${i}`);if(os.platform()===Common.SYS_LINUX&&(Common.getOsName()===Common.OS_KYLIN_V10||Common.getOsName().indexOf(Common.OS_UBUNTU_16)!=-1)){Log.info(LOG_TAG,`[removeHistory] current os mame is ${Common.getOsName()}, will _removeHistoryVisit`);this._removeHistoryVisit(i);return true}else{const e=require("../plugins/aTrustAddonUtils");let r=e.removeHistory(this.tidyUrl(i));Log.info(LOG_TAG,`[removeHistory] end, the url is ${i}`);return r}}async _queryHistoryVisit(){let r=[];r.push("-q");let i=await this._visitHistory(Common.VISITHISORY_PATH,r);return i}async _queryHistory(){Log.info(LOG_TAG,"[queryHistory] begin");if(os.platform()===Common.SYS_LINUX&&(Common.getOsName()===Common.OS_KYLIN_V10||Common.getOsName().indexOf(Common.OS_UBUNTU_16)!=-1)){Log.info(LOG_TAG,`[removeHistory] current os mame is ${Common.getOsName()}, will _queryHistoryVisit`);return this._queryHistoryVisit()}else{const e=require("../plugins/aTrustAddonUtils");let r=e.queryHistory();let i=JSON.stringify(r);Log.info(LOG_TAG,`[queryHistory] end, the result is ${i}`);return r}}async reloadHistoryRecords(){let r=await this._queryHistory();this.historyArr=[];this._addAddrFromReadArr(r)}async initHistoryAddr(){try{await this.reloadHistoryRecords()}catch(r){Log.warn(LOG_TAG,"[initHistoryAddr] failed to read history addr file , reason:",r)}}getHistoryServiceType(r){Log.info(LOG_TAG,"[getHistoryServiceType] addr[%s]",r);for(var i=0;i<this.historyArr.length;i++){if(this.tidyUrl(r)===this.tidyUrl(this.historyArr[i].addr)){var e=this.historyArr[i].serviceType!=undefined?this.historyArr[i].serviceType:Common.SERVICE_VERSION_NONE;Log.info(LOG_TAG,"[getHistoryServiceType] find by addr[%s], return serviceType[%s]",r,e);return e}}Log.info(LOG_TAG,"[getHistoryServiceType] not find by addr:[%s], return default serviceType:[%s]",r,Common.SERVICE_VERSION_NONE);return Common.SERVICE_VERSION_NONE}getSimplifyWorkspaceFlag(r){Log.info(LOG_TAG,"[getSimplifyWorkspaceFlag] addr[%s]",r);for(var i=0;i<this.historyArr.length;i++){if(this.tidyUrl(r)===this.tidyUrl(this.historyArr[i].addr)){Log.info(LOG_TAG,"[getSimplifyWorkspaceFlag] find by addr[%s], return simplifyWorkspaceFlag:[%s]",r,this.historyArr[i].simplifyWorkspace);return this.historyArr[i].simplifyWorkspace}}Log.info(LOG_TAG,"[getSimplifyWorkspaceFlag] not find by addr:[%s], return default SimplifyWorkspaceFlag:false",r);return false}getCurrentTime(){let r=new Date;let i=r.toUTCString();return Date.parse(i)}async addHistoryAddr(i,r,e){Log.info(LOG_TAG,"[addHistoryAddr] addr[%s]",i);if(i===""){Log.info(LOG_TAG,"[addHistoryAddr] addr[%s] is empty, return",i);return}if(!Common.isFieldValid(r)){r=this.getHistoryServiceType(i)}if(r===""){r=Common.SERVICE_VERSION_NONE}if(!Common.isFieldValid(e)){e=this.getSimplifyWorkspaceFlag(i)}Common.setSimplifyWorkspaceFlag(e);let t={addr:i,serviceType:r,simplifyWorkspace:e,workbenchLabel:this.getWorkWriting(i),uemEnterLabel:this.getUemEnterWriting(i)};if(this.historyArr.length>0){if(this.tidyUrl(i)===this.tidyUrl(this.historyArr[0].addr)&&r===this.historyArr[0].serviceType&&e===this.historyArr[0].simplifyWorkspace){Log.info(LOG_TAG,"[addHistoryAddr] No changes have occurred, do not save");return}if(this.tidyUrl(i)!=this.tidyUrl(this.historyArr[0].addr)){t.lastVisitSuccessTime=this.getCurrentTime()}}else{t.lastVisitSuccessTime=this.getCurrentTime()}let s=!this.isAddressExist(i);if(os.platform()===Common.SYS_LINUX&&(Common.getOsName()===Common.OS_KYLIN_V10||Common.getOsName().indexOf(Common.OS_UBUNTU_16)!=-1)){this.delHistoryAddr(i,true);this.historyArr.unshift(t);if(this.historyArr.length>ADDR_MAX_NUM){this.historyArr.pop()}this._addHistory(i,t,s)}else{this._addHistory(i,t);await this.reloadHistoryRecords();if(s&&this.isAddressExist(i)){let r=JSON.stringify({event:Common.SDPC_HISTORY_ADDR_ADD,data:{addr:i}});notifier.broadcast(Common.SDPC_HISTORY_ADDR_ADD_EVENT,r)}}}async delHistoryAddr(r,i){Log.info(LOG_TAG,"[delHistoryAddr] addr[%s]",r);for(var e=0;e<this.historyArr.length;e++){if(this.tidyUrl(r)===this.tidyUrl(this.historyArr[e].addr)){if(os.platform()===Common.SYS_LINUX&&(Common.getOsName()===Common.OS_KYLIN_V10||Common.getOsName().indexOf(Common.OS_UBUNTU_16)!=-1)){this.historyArr.splice(e,1);if(!i){this._removeHistory(r)}}else{this._removeHistory(r);await this.reloadHistoryRecords()}break}}}isFirstHistoryAddr(r){if(this.historyArr.length===0){return false}if(this.tidyUrl(r.addr)===this.tidyUrl(this.historyArr[0].addr)&&r.serviceType===this.historyArr[0].serviceType){return true}return false}getHistoryAddr(){var r=this.historyArr.map(function(r){return r.addr});Log.info(LOG_TAG,"[getHistoryAddr] histroy arr[%s]",r);return r}getLastHistoryAddr(){if(this.historyArr.length>0){if(Common.isURLlegal(this.historyArr[0].addr))return this.historyArr[0]}const r=require("./language");return{addr:"",serviceType:Common.SERVICE_VERSION_NONE,workbenchLabel:r.Config.get(r.Lib.WORKWRITING_DEFAULT)}}isAddressExist(r){var i=this.historyArr.length;for(var e=0;e<i;e++){if(this.tidyUrl(r)===this.tidyUrl(this.historyArr[e].addr)){return true}}return false}async saveWorkWriting(r){var i=this.historyArr.length;for(var e=0;e<i;e++){if(this.tidyUrl(r.addr)===this.tidyUrl(this.historyArr[e].addr)){if(os.platform()===Common.SYS_LINUX&&(Common.getOsName()===Common.OS_KYLIN_V10||Common.getOsName().indexOf(Common.OS_UBUNTU_16)!=-1)){this.historyArr[e].workbenchLabel=r.workbenchLabel;this.historyArr[e].uemEnterLabel=r.uemEnterLabel;this._addHistory(r.addr,r)}else{this._addHistory(r.addr,r);await this.reloadHistoryRecords()}return}}}getWorkWriting(r){var i=this.historyArr.length;var e="";var t="";var s=false;for(var o=0;o<i;o++){if(this.tidyUrl(r)===this.tidyUrl(this.historyArr[o].addr)){if(Common.isFieldValid(this.historyArr[o].workbenchLabel)){t=this.historyArr[o].workbenchLabel}if(Common.isFieldValid(this.historyArr[o].serviceType)){e=this.historyArr[o].serviceType}s=true;break}}const d=require("./language");var n=os.platform();if(t===""){if(n===Common.SYS_LINUX){t=d.Config.get(d.Lib.WORKWRITING_DEFAULT_PLAT)}else if(s){t=d.Config.get(d.Lib.WORKWRITING_DEFAULT_PLAT)}else{t=d.Config.get(d.Lib.WORKWRITING_DEFAULT)}}else{if(n===Common.SYS_LINUX&&e!=Common.SERVICE_VERSION_PLAT){t=d.Config.get(d.Lib.WORKWRITING_DEFAULT_PLAT)}}return t}getUemEnterWriting(r){var i=this.historyArr.length;for(var e=0;e<i;e++){if(this.tidyUrl(r)===this.tidyUrl(this.historyArr[e].addr)){if(Common.isFieldValid(this.historyArr[e].uemEnterLabel)){return this.historyArr[e].uemEnterLabel}}}const t=require("./language");return t.Config.get(t.Lib.UEM_ENTER_DEFAULT)}isServiceTypeChanged(r,i){var e=this.historyArr.length;for(var t=0;t<e;t++){if(this.tidyUrl(r)===this.tidyUrl(this.historyArr[t].addr)){if(i!=this.historyArr[t].serviceType){Log.info(LOG_TAG,"[isServiceTypeChanged] serviceType changed, serviceType[%s], last serviceType[%s]",i,this.historyArr[t].serviceType);return true}return false}}return false}}module.exports=new HistorySdpc;