const http=require("http");const https=require("https");const os=require("os");const net=require("net");const Language=require("./language");const Protocal=require("./protocal");const Common=require("./common");const Log=require(".././service/util/logger");const{Diagnosis}=require("./diagnosis");const assert=require("assert");const checker=require("./util/checker");const LOG_TAG="[resource_diagnosis]";const TCP_CONNECT_TIMEOUT=1e4;class ResDiagnosis extends Diagnosis{constructor(){super();this.m_isShowFailedLog=false;this.m_diagResultMsg=null;this.m_tunnelErrLogs=[];this.resConnErrLog=null;this.m_winName=Common.WIN_RESDIAG_NAME;this.m_ipcChannelKey=Protocal.IPC_CHANGE_RES_DIAG_WINDOW}reqToTunnel(s,t,r){assert(checker.isString(s),`The reqUrl must be a string type, but the actual value is ${s}`);assert(checker.isString(t),`The traceid must be a string type, but the actual value is ${t}`);var o=function(e,s,t,r){if(os.platform()===Common.SYS_MAC||os.platform()===Common.SYS_WIN32||os.platform()===Common.SYS_LINUX){return e.startResourceDiagnosisWithItemsPromise(s,t,r)}else{return e.startResourceDiagnosisPromise(s,t)}};let e=this.createRpcDiagnosisClient();Log.info(LOG_TAG,`resource diagnosis start, requrl:${s}, traceid:${t}`);return e.startPromise().then(e=>{return o(e,s,t,r)}).then(()=>{Log.info(LOG_TAG,`resource diagnosis success. requrl:${s}, traceid:${t}`)}).catch(e=>{Log.error(LOG_TAG,`resource diagnosis failure. requrl:${s}, traceid:${t}`,e);throw e}).finally(()=>{Log.info(LOG_TAG,`resource diagnosis finish. requrl:${s}, traceid:${t}`);e.destroy()})}isTcpAccessible(o,n){assert(typeof o=="number"&&typeof n=="string");let e=new Promise((e,s)=>{let t={accessFlag:false,message:""};let r=new net.Socket;r.connect(o,n,()=>{r.write("\n");t.accessFlag=true});r.on("error",e=>{t.accessFlag=false;t.message=e.message});setTimeout(()=>{r.destroy();if(t.accessFlag){e(Language.Config.get(Language.Lib.RESDIAG_DETECT_OK))}else{s(t.message)}},TCP_CONNECT_TIMEOUT)});return e}isHttpAccessible(e,o){assert(typeof e=="object"&&typeof o=="string");let s=new Promise((s,t)=>{const{net:e}=require("electron");const r=e.request(o);r.on("response",e=>{Log.info(LOG_TAG,`http accessible success. stautsCode:${e.statusCode} ${http.STATUS_CODES[e.statusCode]}`);s(Language.Config.get(Language.Lib.RESDIAG_DETECT_OK))});r.on("error",e=>{Log.warn(LOG_TAG,"http accessible failed!",e.toString());t(e.toString())});r.end()});return s}isAccessible(o){assert(typeof o=="string");let e=new Promise((s,t)=>{let e,r=null;try{r=new URL(o)}catch(e){Log.error(LOG_TAG,`The parsing url appears abnormal, the url is ${o} and error is ${e}`);t(Language.Config.get(Language.Lib.RESDIAG_ERR_URL));return}if(r.protocol=="http:"){e=http}else if(r.protocol=="https:"){e=https}else{let e=o.split(":");if(!e||e.length<2){Log.warn(LOG_TAG,`tcp resdiag failed! can not get host and port from ${o}`);t(Language.Config.get(Language.Lib.RESDIAG_ERR_URL));return}this.isTcpAccessible(Number(e[1]),e[0]).then(e=>{s(e)}).catch(e=>{Log.warn(LOG_TAG,`tcp resdiag failed! ${e.message}`);t(this.getDiagErrReasonMsg(o))});return}this.isHttpAccessible(e,o).then(()=>{s(Language.Config.get(Language.Lib.RESDIAG_DETECT_OK))}).catch(e=>{Log.warn(LOG_TAG,"http(s) resdiag failed!",e.toString());t(this.getDiagErrReasonMsg(o))})});return e}saveTunnelErrLogs(e){if(!(checker.isObject(e)&&checker.isObject(e.result)&&checker.isObject(e.result.data))){Log.warn(LOG_TAG,"The format of the data(%s) to be cached is invalid",e);return}if(this.m_tunnelErrLogs.length>=100){this.m_tunnelErrLogs.shift()}this.m_tunnelErrLogs.push(e)}getDiagErrReasonMsg(e){let s=Common.getHostPort(e);if(this.resConnErrLog!=null&&this.resConnErrLog.result.data.destAddr===s){var t=this.resConnErrLog.result.data.proxys.length;var r=Language.Config.get(Language.Lib.RESDIAG_DETECT_RES_ERR);if(t>0){for(var o=0;o<t;o++){var n=this.resConnErrLog.result.data.proxys[o]+" ";r+=n}}else{r+=" "}r=r+Language.Config.get(Language.Lib.RESDIAG_DETECT_RES_REASON)+this.resConnErrLog.result.data.reason;return r}return Language.Config.get(Language.Lib.RESDIAG_CANNOT_ACCESS)}getDiagErrHowtoMsg(e){let s=Common.getHostPort(e);if(this.resConnErrLog!=null&&this.resConnErrLog.result.data.destAddr===s){return this.resConnErrLog.result.data.howTo}return Language.Config.get(Language.Lib.RESDIAG_HOWTO_COM)}tunnelErrMsgTransport(e){let s={};let t={code:0,message:"",isVisible:this.m_isShowFailedLog,result:{event:"unknown_error",data:{message:"unknown_error",reason:"",time:"",desAddr:""}}};try{s=JSON.parse(e);t.result=s}catch(e){t.code=1;t.message=e.toString();t.result.data.reason=e.toString();Log.warn(LOG_TAG,"tunnel error message transport to web failed.",e)}if(this.resConnErrLog==null&&this.m_isShowFailedLog){this.resConnErrLog=t}this.saveTunnelErrLogs(t);var r=[];r.push(t);this.sendWebContents(Protocal.IPC_CHANGE_RES_DIAG_TUNNEL,JSON.stringify(r))}loadHistory(){this.sendWebContents(Protocal.IPC_CHANGE_RES_DIAG_TUNNEL,JSON.stringify(this.m_tunnelErrLogs))}}module.exports=new ResDiagnosis;