const os=require("os");const path=require("path");const util=require("util");const app=require("electron").app;const Log=require("./logger");const Util=require("../util/util");const Common=require("../common");const ErrorCode=require("../../common/errorcode");const TrayEventEmitter=require("./event_emitter");const CommonEvent=require("./../protocal.js");const childProcess=require("child_process");const to=require("await-to-js").default;const LOG_TAG="[ServRepairTool]";class ServRepairTool{constructor(){this.winCCPlugin=Util.requireCCPlugin();this.repairToolPath=path.join(path.dirname(app.getPath("exe")),"../aTrustAgent","aTrustServRepair.exe");this.aTrustAgentPath=path.join(path.dirname(app.getPath("exe")),"../aTrustAgent","aTrustAgent.exe")}isServiceRunning(e){if(os.platform()===Common.SYS_WIN32){if(!Util.winCCPlugin.CheckSangforSign(this.aTrustAgentPath)){Log.warn(LOG_TAG,"CheckSangforSign Falied","aTrustService no Sangfor Sign.");return 0}if(Util.winCCPlugin.isServiceRunning(e)==false){Log.info(LOG_TAG,"aTrustService Stopped");return false}else{Log.info(LOG_TAG,"aTrustService Running");return true}}else if(os.platform()===Common.SYS_MAC){if(Util.macCCPlugin.isServiceRunning()==false){Log.info(LOG_TAG,"aTrustAgent Service Stopped");return false}else{Log.info(LOG_TAG,"aTrustAgent Service Running");return true}}}isUserAdminPrivilege(){if(os.platform()===Common.SYS_WIN32){if(Util.winCCPlugin.isUserAdminPrivilege()==false){Log.warn(LOG_TAG,"is Not UserAdmin Privilege");return false}else{Log.warn(LOG_TAG,"is UserAdmin Privilege");return true}}else{return true}}startServicePlugin(e){if(os.platform()===Common.SYS_WIN32){if(!Util.winCCPlugin.CheckSangforSign(this.aTrustAgentPath)){Log.warn(LOG_TAG,"CheckSangforSign Falied","aTrustService no Sangfor Sign.");return 0}if(!Util.winCCPlugin.startService(e)){Log.warn(LOG_TAG,"startServicePlugin failed");return false}else{Log.warn(LOG_TAG,"startServicePlugin Success");return true}}else if(os.platform()===Common.SYS_MAC){return false}else{return true}}exitClientCompletelyPlugin(){if(os.platform()===Common.SYS_WIN32){if(!Util.winCCPlugin.CheckSangforSign(this.aTrustAgentPath)){Log.warn(LOG_TAG,"Before exiting the client completely, atrustAgent.exe fails to check the signature and does not contain sangfor signature information");return false}if(!Util.winCCPlugin.exitClientCompletely(Common.ATRUSTSERVNAME,Common.AGENTPROCESSNAME,Common.ATRUSTXTUNNEL)){Log.warn(LOG_TAG,"exitClientCompletelyPlugin failed");return false}else{Log.info(LOG_TAG,"exitClientCompletelyPlugin Success");return true}}else if(os.platform()===Common.SYS_MAC){return false}else{return true}}startService(e,t){if(os.platform()===Common.SYS_WIN32){if(!Util.winCCPlugin.CheckSangforSign(this.aTrustAgentPath)){Log.warn(LOG_TAG,"startService Falied","aTrustService no Sangfor Sign.");return false}if(!Util.winCCPlugin.CheckSangforSign(this.repairToolPath)){Log.warn(LOG_TAG,"startService Falied","aTrustServRepair no Sangfor Sign.");return false}var r=util.format('"%s" --start-%s',this.repairToolPath,e);Util.winCCPlugin.ExecCreateTask(r,r=>{Log.info(LOG_TAG,"ExecCreateTask result:%s",r);try{let e=JSON.parse(r);if(e.code==0||e.code==1){Log.info(LOG_TAG,"startService Success");if(t)t(ErrorCode.ERROR_SUCCESS)}else{if(t)t(ErrorCode.ERROR_FAILED);Log.warn(LOG_TAG,"startService Failed",e.code)}}catch(e){Log.warn(LOG_TAG,"process ExecCreateTask result failed, reason:",e);if(t)t(ErrorCode.ERROR_FAILED)}});return true}else if(os.platform()===Common.SYS_MAC){Log.info(LOG_TAG,"open daemon job bless.");let e=null;if(!Util.macCCPlugin.startService()){e={code:-1};Log.warn(LOG_TAG,"open daemon job bless failed.")}else{Log.info(LOG_TAG,"startService Success");TrayEventEmitter.emit(CommonEvent.AGENT_SERVICE_RECOVERED)}t&&t(e);return true}else{return true}}async openSystemLoginItems(t){let i={code:0,data:{},message:""};if(os.platform()===Common.SYS_MAC){try{let e=util.format('"%s" %s',"/Library/Application Support/aTrust/aTrustDaemon","openLoginItems");let[r]=await to(childProcess.execPromises(e));if(r){Log.warn(LOG_TAG,"failed to exec /Library/Application Support/aTrust/aTrustDaemon",r);i.code=ErrorCode.ERROR_FAILED;t&&t()}else{Log.info(LOG_TAG,"/Library/Application Support/aTrust/aTrustDaemon","exec ok.");i.code=ErrorCode.ERROR_SUCCESS;t&&t(r)}}catch(e){Log.warn(LOG_TAG,"openSystemLoginItems catch error",e)}}return true}exitClientCompletely(t){if(os.platform()===Common.SYS_WIN32){let e="";if(!Util.winCCPlugin.CheckSangforSign(this.aTrustAgentPath)){e="Before exiting the client completely, atrustAgent.exe fails to check the signature and does not contain sangfor signature information";if(t)t(e);return}if(!Util.winCCPlugin.CheckSangforSign(this.repairToolPath)){e="Before exiting the client completely, aTrustServRepair.exe fails to check the signature and does not contain sangfor signature information";if(t)t(e);return}var r=util.format('"%s" --exit-client',this.repairToolPath);Util.winCCPlugin.ExecCreateTask(r,r=>{Log.info(LOG_TAG,"ExecCreateTask result:%s",r);try{let e=JSON.parse(r);if(e.code==0){if(t)t("")}else{if(t)t(e)}}catch(e){Log.warn(LOG_TAG,"process ExecCreateTask result failed, reason:",e);if(t)t({code:ErrorCode.ERROR_FAILED,message:e})}})}else if(os.platform()===Common.SYS_MAC){Log.info(LOG_TAG,"begin open daemon job bless for full exit.");let e="";if(!Util.macCCPlugin.exitService()){e="Before exiting the client completely, open daemon job bless failed.";Log.warn(LOG_TAG,"%s",e)}Log.info(LOG_TAG,"end open daemon job bless for full exit.");if(t)t(e);return}}killAgentProcess(t){if(os.platform()===Common.SYS_WIN32){if(!Util.winCCPlugin.CheckSangforSign(this.aTrustAgentPath)){Log.warn(LOG_TAG,"killAgentProcess Falied","aTrustService no Sangfor Sign.");return false}Log.warn(LOG_TAG,"CheckSangforSign path");Log.warn(LOG_TAG,this.repairToolPath);if(!Util.winCCPlugin.CheckSangforSign(this.repairToolPath)){Log.warn(LOG_TAG,"killAgentProcess Falied","aTrustServRepair no Sangfor Sign.");return false}var e=util.format('"%s" --kill-aTrustAgent.exe',this.repairToolPath);Util.winCCPlugin.ExecCreateTask(e,r=>{Log.info(LOG_TAG,"ExecCreateTask result:%s",r);try{let e=JSON.parse(r);if(e.code==0){Log.info(LOG_TAG,"killAgentProcess Success");if(t)t(e)}else{Log.warn(LOG_TAG,"killAgentProcess Failed",r);if(t)t(e)}}catch(e){Log.warn(LOG_TAG,"process ExecCreateTask result failed, reason:",e);if(t)t({code:ErrorCode.ERROR_FAILED,message:e})}});return true}else if(os.platform()===Common.SYS_MAC){const r=Util.macCCPlugin.killService();return r}else{return}}}module.exports=new ServRepairTool;