const Checker=require("./checker");const Log=require("./logger");const EventSchame=require("./event.schema.json");const LOG_TAG="[event_bus]";class EventBus{constructor(){this.eventFilter=null;this.delegate=null;this.isRunning=false;this.pullChannel={channelID:"",eventID:0};const e=require("uuid");this.pushChannel={channelID:e.v4(),eventID:0};this.immediateChannel={channelID:e.v4(),eventID:0};this.pusherTimerID=null;const t=require("./circle_queue");this.circleQueue=new t(64);this.circleQueue.onDiscard=function(e){let t=e;try{if(Checker.isObject(e)){t=JSON.stringify(e)}else{t=e.toString()}}catch(e){Log.error(LOG_TAG,`Convert discard data to a string type error, the type of discard data will be printed`,e)}Log.warn(LOG_TAG,`Due to the full cycle buffer, the event will be lost, the event is ${t}`)};this.pushing=false;this.schamaValidate=null}setDelegate(e){this.delegate=e}setEventFilter(e){this.eventFilter=e}start(){if(this.isRunning){return false}this.isRunning=true;this._puller();return true}stop(){if(!this.isRunning){return}this.isRunning=false}broadcast(e,t,n){this._jsonSchemaChecker(e,t);var{error:i,topic:e,content:t}=this._checkAndRedressEvent(e,t);if(i){setImmediate(()=>{this._applyWithoutException(n)(i)});return}setImmediate(()=>{Log.info(LOG_TAG,`Event priority execution local dispatch, the topic is ${e}, content is ${t}`);this._handleEvent(e,t)});const s=require("../thrift/SdpBroadcast_types");let r=new s.BroadcastPushEvent;r.origin=new s.BroadcastIdentify;r.body=new s.BroadcastBody;r.origin.eventID=this.pushChannel.eventID++;r.origin.channelID=this.pushChannel.channelID;r.body.topic=e;r.body.content=t;this.circleQueue.enqueue({rawEvent:r,timestamp:this.steadyClockCount(),callback:n});if(!Checker.isNull(this.pusherTimerID)){clearTimeout(this.pusherTimerID)}this._pusher()}broadcastPromise(e,t){return new Promise((n,i)=>{this.broadcast(e,t,(e,t)=>{if(e){i(e)}else{n(t)}})})}boradcastImmediately(e,t,n){this._jsonSchemaChecker(e,t);var{error:i,topic:e,content:t}=this._checkAndRedressEvent(e,t);if(i){setImmediate(()=>{this._applyWithoutException(n)(i)});return}const s=require("../thrift/SdpBroadcast_types");let r=new s.BroadcastPushEvent;r.origin=new s.BroadcastIdentify;r.body=new s.BroadcastBody;r.origin.eventID=this.immediateChannel.eventID++;r.origin.channelID=this.immediateChannel.channelID;r.body.topic=e;r.body.content=t;let h=JSON.stringify(r);const l=require("./rpc_client");let a=new l.RpcClient(l.SdpBroadcastService);return a.startPromise().then(e=>{return e.pushPromise(r)}).then(e=>{if(n)this._applyWithoutException(n)(null,e);Log.info(LOG_TAG,`Immediately event delivery, service response ${e}, the event is ${h}`)}).catch(e=>{if(n)this._applyWithoutException(n)(e);Log.error(LOG_TAG,`Immediately event delivery error, the event is ${h}`,e)}).finally(()=>{a.destroy();Log.info(LOG_TAG,`Immediately event delivery finish, event is ${h}`)})}boradcastImmediatelyPromise(e,t){return new Promise((n,i)=>{this.boradcastImmediately(e,t,(e,t)=>{if(e){i(e)}else{n(t)}})})}_jsonSchemaChecker(t,n){if(!Checker.isObject(n)){try{n=JSON.parse(n)}catch(e){Log.warn(LOG_TAG,`JsonSchemaCheck cann't parse content(${n}) as json, the error is `+e)}}if(this.schamaValidate===null){const i=require("ajv");const s=new i;this.schamaValidate=s.compile(EventSchame)}let e=this.schamaValidate(n);if(!e){let e=JSON.stringify(this.schamaValidate.errors);Log.warn(LOG_TAG,`The event(${t}) format is not defined by the specification, the actual content is '${n}', the error is ${e}`)}return e}_checkAndRedressEvent(e,t){if(!Checker.isString(e)){return{error:new Error("The topic must be a string type")}}if(Checker.isNull(t)||Checker.isUndefined(t)){t=""}if(Checker.isObject(t)){t=JSON.stringify(t)}t=t.toString();return{topic:e,content:t}}_pusher(){if(this.pushing){return}if(this.circleQueue.empty()){this.pusherTimerID=setTimeout(()=>{this._pusher()},1e3);return}const n=60*1e3;let i=null;let e=this.steadyClockCount();while(!this.circleQueue.empty()){let t=this.circleQueue.front();if(e-t.timestamp>n){this.circleQueue.dequeue();let e=JSON.stringify(t.rawEvent);Log.warn(LOG_TAG,`Events will be discarded for more than 1 minute, the event is ${e}`);setImmediate(this._applyWithoutException(t.callback),new Error(`overdue event, the expiration time is ${n} milliseconds`));continue}i=t;break}if(Checker.isNull(i)){return}this.pushing=true;const t=require("./rpc_client");let s=new t.RpcClient(t.SdpBroadcastService);let r=JSON.stringify(i.rawEvent);s.startPromise().then(e=>{return e.pushPromise(i.rawEvent)}).then(e=>{if(!e){Log.warn(LOG_TAG,`The sender of the sending event is rejected by the client, and the client thinks it has been sent, the event is ${r}`)}else{Log.info(LOG_TAG,`Push events to service success, the event is ${r}`)}this._applyWithoutException(i.callback)(null,e);this.circleQueue.dequeue();this.pushing=false;this.pusherTimerID=setTimeout(()=>{this._pusher()})}).catch(e=>{Log.error(LOG_TAG,`Error of sending events, retry after 1s, the event is ${r}`,e);this.pushing=false;this.pusherTimerID=setTimeout(()=>{this._pusher()},1e3)}).finally(()=>{s.destroy()})}_puller(){const t=5e3;const n=1e3;const e=require("./rpc_client");const i=require("../thrift/SdpBroadcast_types");let s=new e.RpcClient(e.SdpBroadcastService);let r=new i.BroadcastIdentify;r.channelID=this.pullChannel.channelID;r.eventID=this.pullChannel.eventID;s.startPromise().then(e=>{return e.pullPromise(r,t)}).then(e=>{this._dispatch(e)}).then(()=>{this._delayPull()}).catch(e=>{this._delayPull(n);Log.error(LOG_TAG,`Failure to pull event from the service, and will retry after ${n} ms`,e)}).finally(()=>{s.destroy()})}_dispatch(e){if(!this.isRunning){Log.info(LOG_TAG,"Event service has been stopped");return}if(this.pullChannel.channelID!=e.identify.channelID){Log.info(LOG_TAG,`event channed has changed, from ${this.pullChannel.channelID} to ${e.identify.channelID}`);this.pullChannel.channelID=e.identify.channelID;this.pullChannel.eventID=e.identify.eventID}if(this.pullChannel.eventID>e.identify.eventID){Log.warn(LOG_TAG,`server's eventid(${e.identify.eventID}) is less than the client's eventid(${this.pullChannel.eventID})`);this.pullChannel.eventID=e.identify.eventID}else{this.pullChannel.eventID=e.identify.eventID}e.data.forEach(e=>{let t=JSON.stringify(e);Log.debug(LOG_TAG,`Received event ${t}`);if(e.origin.channelID==this.pushChannel.channelID){Log.info(LOG_TAG,`The event will be filtered because he comes from the current process, topic is ${e.body.topic}, content is ${e.body.content}`);return}this._handleEvent(e.body.topic,e.body.content)})}_delayPull(e){e=e||0;setTimeout(()=>{if(!this.isRunning){Log.info(LOG_TAG,"Event service has been stopped");return}this._puller()},e)}_handleEvent(t,n){try{if(t.indexOf("selectLineResult")==-1&&t.indexOf("tunnelFlow")==-1&&t.indexOf("uploadFileChanged")==-1&&t.indexOf("downloadFileChanged")==-1){Log.info(LOG_TAG,`dispatch event, ${t}, ${n}`)}if(this.delegate){if(null==this.eventFilter||this.eventFilter.eventTypeFilter(t.toString(),n.toString())){this.delegate.dispatchEventMsg(t.toString(),n.toString())}}else{Log.warn(LOG_TAG,`Events will be lost because the delegate is not defined, the topic is ${t}, the content is ${n}`)}}catch(e){Log.error(LOG_TAG,`event(${t}) may not be processed, there is an exception when handle it(content:${n})`,e)}}_applyWithoutException(n){return function(e,t){try{if(n)n(e,t)}catch(e){Log.error(LOG_TAG,`The call callback function is abnormal`,e)}}}steadyClockCount(){return Math.floor(process.uptime()*1e3)}}module.exports=new EventBus;