const os=require("os");const fs=require("fs");const path=require("path");const assert=require("assert");const util=require("util");const app=require("electron").app;const Log=require("./logger");const ErrorCode=require("../../common/errorcode");const Util=require("../util/util");const Language=require("../language");const EnvPath=require("../util/environmentpath");const LOG_TAG="[LogCollect]";const Common=require("../common");const to=require("await-to-js").default;class LogCollect{constructor(){this.lastLogFile="";this.logFiles=[];this.logFileMax=5;this.logFileName="";if(os.platform()===Common.SYS_WIN32){this.logToolPath=path.join(path.dirname(app.getPath("exe")),"../aTrustAgent","LogCollectionTool.exe");this.logPackPath=path.join(EnvPath.getAppDataPath(),"Sangfor/aTrust/LogCollect")}else if(os.platform()===Common.SYS_MAC){this.logToolPath="/Applications/aTrust.app/Contents/Resources/bin/LogCollectionTool";this.logPackPath="/tmp/aTrustLog"}else if(os.platform()===Common.SYS_LINUX){this.logToolPath="/usr/share/sangfor/aTrust/resources/bin/LogCollectionTool";this.logPackPath="/tmp/aTrustLog"}}async start(){let e={code:ErrorCode.ERROR_SUCCESS,message:"",data:{}};let[o]=await to(fs.promises.access(this.logToolPath));if(o){Log.warn(LOG_TAG,"access failed, reason:",o);e.code=ErrorCode.ERROR_LOGCOLLECT_TOOL_NOT_EXIST;e.message=Language.Config.get(Language.Lib.NO_LOGCOLLECTION_TOOL);return e}var t=util.format('--dir "%s" --quiet',this.logPackPath);let[s,a]=await to(Util.checkSignExec(this.logToolPath,t,180));if(s||a.code){if(s){Log.warn(LOG_TAG,"exec failed, reason:",s)}else{Log.warn(LOG_TAG,"exec fail, path {%s}, code {%d}",this.logToolPath,a.code)}e.code=ErrorCode.ERROR_LOGCOLLECT_TOOL_START_ERROR;if(a.code==ErrorCode.ERROR_LOGCOLLECT_TOOL_LOG_DIR_DIST_FULL){var i=path.parse(this.logPackPath);e.message=util.format(Language.Config.get(Language.Lib.LOGCOLLECTION_DIR_SPACE_FULL),i.root)}else{e.message=Language.Config.get(Language.Lib.LOGCOLLECTION_TOOL_START_FAILED)}return e}this.logFiles.splice(0,this.logFiles.length);this.logFiles=await this.getLogFiles(this.logPackPath);if(this.logFiles.length){this.lastLogFile=this.logFiles[this.logFiles.length-1];this.logFileName=path.basename(this.lastLogFile)}else{this.lastLogFile="";this.logFileName=""}[o]=await to(this.logFilesClean());if(o){Log.warn(LOG_TAG,"[start] process checkSignExec result failed, reason:",o)}e.data.logFilePath=this.lastLogFile;e.data.logFileName=this.logFileName;return e}async openDir(){let[e]=await to(fs.promises.access(this.lastLogFile));if(e){Log.warn(LOG_TAG,"can not open log file, reason:",e);return{code:ErrorCode.ERROR_LOGFILE_NOT_EXIST,message:Language.Config.get(Language.Lib.OPEN_LOGDIR_FAILED),data:{}}}var o="",t="";if(os.platform()===Common.SYS_WIN32){o=path.join(process.env["SystemRoot"],"explorer.exe");t=`/select,"${this.lastLogFile}"`}else if(os.platform()===Common.SYS_MAC){o="/usr/bin/open";t=`-R "${this.lastLogFile}"`}else if(os.platform()===Common.SYS_LINUX){o="/usr/bin/xdg-open";let e=this.lastLogFile.substring(0,this.lastLogFile.lastIndexOf("/"));t=`${e}`}let[s,a]=await to(Util.checkSignExec(o,t));if(s||a.code){if(s){Log.warn(LOG_TAG,"exec failed, reason:",s)}else{Log.warn(LOG_TAG,"exec fail, path {%s}, code {%d}",o,a.code)}return{code:ErrorCode.ERROR_CMD_FAILED,message:a.message,data:{}}}return{code:ErrorCode.ERROR_SUCCESS,message:"",data:{}}}async getLogFiles(t){assert(typeof t=="string","logPath parameter type error");let s=[];let[a,e]=await to(fs.promises.stat(t));if(a){Log.warn(LOG_TAG,"[getLogFiles] stat failed","reason:",a)}else if(e.isDirectory()){let[e,o]=await to(fs.promises.readdir(t));if(e){Log.warn(LOG_TAG,"read log files failed, reason:",a);return s}o.forEach(e=>{if(e.match(/^aTrustLog_.*\.zip/)){s.push(path.join(t,e))}})}else{Log.debug(LOG_TAG,`[getLogFiles] ${t} is not directory`)}return s}async logFilesClean(){if(this.logFileMax+1>this.logFiles.length){return}let[e]=await to(fs.promises.unlink(this.logFiles[0]));if(e){Log.warn(LOG_TAG,"log files clean failed!");return}this.logFiles.splice(0,1);await this.logFilesClean()}}module.exports=new LogCollect;