"use strict";const Tracer=require("tracer");const Path=require("path");const Util=require("util");const{app}=require("electron");const fs=require("fs");const os=require("os");const LOG_TAG="[Logger]";const EnvPath=require("./environmentpath");const sensitive=require("./sensitive.js");var CommonLog={};CommonLog.LOG_TAG="Log";CommonLog.LOG_FILE_NAME="aTrustTray";if(os.platform()==="win32"){try{CommonLog.LOG_DIR=Path.join(EnvPath.getAppDataPath(),"Sangfor/aTrust/logs")}catch(error){try{CommonLog.LOG_DIR=Path.join(app.getPath("home"),"Sangfor/aTrust/logs")}catch(error){CommonLog.LOG_DIR=Path.join("C:/Windows/Temp/","Sangfor/aTrust/logs")}}}else if(os.platform()==="darwin"){CommonLog.LOG_DIR=Path.join(app.getPath("appData"),"aTrust/logs")}else if(os.platform()==="linux"){CommonLog.LOG_DIR=Path.join(process.env["HOME"],".aTrust/logs")}CommonLog.MAX_LOG_FILE_SIZE=1024*1024*20;CommonLog.LOG_MAX_MESSAGE_LEN=200;CommonLog.LOG_MAX_FILE_NUM=7;CommonLog.LOG_FILE_OVERRIDE_MODE="w+";CommonLog.LOG_FILE_APPEND_MODE="a+";CommonLog.LOG_DEBUG_LEVEL=0;CommonLog.LOG_DEBUG="debug";CommonLog.LOG_INFO_LEVEL=1;CommonLog.LOG_INFO="info";CommonLog.LOG_WARNING_LEVEL=2;CommonLog.LOG_WARNING="warning";CommonLog.LOG_ERROR_LEVEL=3;CommonLog.LOG_ERROR="error";const sensitive_regex=/(?<="(?:seed|password|psswd|pswd|pwd|pw)"\s*:\s*)("(?:[^"\\]|\\.)*")/gi;function desensitization(e){try{if(typeof e!=="string")return e;if(e==="")return e;return e.replace(sensitive_regex,(o,e)=>{return sensitive.mask(e,sensitive.MEDIUM)})}catch(o){console.error(o);return e}}var logConf={root:CommonLog.LOG_DIR,maxLogFiles:CommonLog.LOG_MAX_FILE_NUM,format:[`[{{timestamp}}] [pid:${process.pid}] <{{title}}> {{message}}`,{error:`[{{timestamp}}] [pid:${process.pid}] <{{title}}> {{message}} \nCall Stack:\n{{stack}}`}],dateformat:"HH:MM:ss.L",allLogsFileName:CommonLog.LOG_FILE_NAME,transport:function(o){if(Tracer.getLevel()===CommonLog.LOG_DEBUG_LEVEL){console.log(o.output)}o.output=o.rawoutput},level:CommonLog.LOG_DEBUG_LEVEL,methods:["debug","info","warn","error"],inspectOpt:{showHidden:false,depth:null}};try{mkdirsSync(CommonLog.LOG_DIR);var logger=Tracer.dailyfile(logConf);Tracer.setLevel(CommonLog.LOG_INFO_LEVEL);fs.watch(logConf.root,function(o){try{if(o!="rename")return;let e=[];if(fs.existsSync(logConf.root)&&fs.statSync(logConf.root).isDirectory()){fs.readdirSync(logConf.root).forEach(o=>{if(o.match(/(^aTrustTray\..*\.log$)|(^aTrustTray\..*\.log.back$)/)){e.push(Path.join(logConf.root,o))}});e.sort(function(r,t){let n=-1;try{let o=fs.statSync(r).ctime;let e=fs.statSync(t).ctime;n=o<e?-1:1}catch(o){n=-1;warn(LOG_TAG,"Failed to sort log files",o)}return n})}if(logConf.maxLogFiles>0&&e.length>logConf.maxLogFiles){fs.unlink(e[0],function(o){if(o){logger.error("[Logger]",o)}else{logger.info("[Logger]","Clear history log file, file name is "+e[0])}})}}catch(o){console.error(`Initialization log configuration abnormal, the error is ${o}`)}})}catch(error){console.error(`Logging file monitoring function abnormal , the error is ${error}`)}Date.prototype.Format=function(o){var e={"M+":this.getMonth()+1,"d+":this.getDate()};if(/(y+)/.test(o))o=o.replace(RegExp.$1,(this.getFullYear()+"").substr(4-RegExp.$1.length));for(var r in e)if(new RegExp("("+r+")").test(o))o=o.replace(RegExp.$1,RegExp.$1.length==1?e[r]:("00"+e[r]).substr((""+e[r]).length));return o};function checkFileSize(){let o=(new Date).Format("yyyyMMdd");let t=Path.join(CommonLog.LOG_DIR,CommonLog.LOG_FILE_NAME+"."+o+".log");let e=new Promise((e,r)=>{if(!fs.existsSync(t)){warn(LOG_TAG,"fail to check file size, %s is not exist!",t);r();return}let o=fs.statSync(t);if(o.size<CommonLog.MAX_LOG_FILE_SIZE){r();return}fs.promises.copyFile(t,t+".back").then(()=>{fs.promises.open(t,"w").then(o=>{o.close();e()}).catch(o=>{warn(LOG_TAG,"fail to clean log file %s",t,o);r()})}).catch(o=>{warn(LOG_TAG,"fail to back log file %s",t,o);r()})});return e}setInterval(async()=>{try{await checkFileSize();info(LOG_TAG,"Check log file size periodically.")}catch(o){console.log(`check file size fialed, the error is ${o}`)}},10*6e4);function destroy(){try{Tracer.close()}catch(o){console.error(`The destruction of the log object is abnormal, the error is ${o}`)}}function reasonLog(o,e){let r=Array.prototype.slice.call(arguments);let t=null;if(e instanceof Error){t=Util.format(`${o}, reason: ${e.stack}`)}else{t=Util.format(`${o}, reason: ${e}`)}let n=[t];if(r.length>2){n=n.concat(r.slice(2))}return Util.format.apply(null,n)}function debug(o,e){try{var r=Array.prototype.slice.call(arguments);r.shift();e=Util.format.apply(null,r);logger.debug(o,desensitization(e))}catch(o){console.error(`Abnormal output debug log, the error is ${o}`)}}function info(o,e){try{var r=Array.prototype.slice.call(arguments);r.shift();e=Util.format.apply(null,r);logger.info(o,desensitization(e))}catch(o){console.error(`Abnormal output info log, the error is ${o}`)}}function warn(o,e){try{var r=Array.prototype.slice.call(arguments);r.shift();e=reasonLog.apply(null,r);logger.warn(o,desensitization(e))}catch(o){console.error(`Abnormal output warn log, the error is ${o}`)}}function error(o){try{var e=Array.prototype.slice.call(arguments);e.shift();var r=reasonLog.apply(null,e);logger.error(o,desensitization(r))}catch(o){console.error(`Abnormal output error log, the error is ${o}`)}}function mkdirsSync(o){try{if(fs.existsSync(o)){return true}else{if(mkdirsSync(Path.dirname(o))){fs.mkdirSync(o);return true}}}catch(o){console.error(`An exception occurs when the log directory is created, the error is ${o}`)}}module.exports={debug:debug,info:info,warn:warn,error:error,destroy:destroy,LOG_DEBUG_LEVEL:0,LOG_INFO_LEVEL:1,LOG_WARING_LEVEL:2,LOG_ERROR_LEVEL:3};