const os=require("os");const path=require("path");const fs=require("fs");const httpClient=require("./http_client");const Log=require("./logger");const Common=require("../common");const to=require("await-to-js").default;const ErrorCode=require("../../common/errorcode");const Util=require("../util/util");const EnvPath=require("../util/environmentpath");const Language=require("../language");const{StreamError,SignatureError,CancelError}=require("../../errors/errors");const LOG_TAG="[RepairTool]";class RepairTool{constructor(){this.repairToolPath=this.getRepairToolPath();this.requestResult=null;this.forceStopDownload=false;this.downloadDir=path.join(EnvPath.getAppDataPath(),"Sangfor/aTrust/download");this.downloader=null}getRepairToolPath(){let e=os.platform();if(e===Common.SYS_WIN32){var o=[path.join(process.env["SystemDrive"],"Program Files/aTrustHelperTool/aTrustHelperTool.exe"),path.join(process.env["SystemDrive"],"Program Files (x86)/aTrustHelperTool/aTrustHelperTool.exe"),"\\Program Files\\aTrustHelperTool\\aTrustHelperTool.exe","\\Program Files (x86)\\aTrustHelperTool\\aTrustHelperTool.exe",path.join(process.cwd(),"../../../aTrustHelperTool/aTrustHelperTool.exe")];for(let e=0;e<o.length;e++){if(fs.existsSync(o[e]))return o[e]}Log.warn(LOG_TAG,"failed to find repaire tool path from %s",o.toString())}else{Log.warn(LOG_TAG,`repaire tool of ${e} is not support`)}return""}isExist(){if(os.platform()===Common.SYS_WIN32){var e=this.getRepairToolPath();if(typeof e=="undefined"||e==null||e==""){return false}this.repairToolPath=e;Log.info(LOG_TAG,"repair tool is installed in %s",this.repairToolPath);return true}}async open(){if(!this.isExist()){return{code:ErrorCode.ERROR_REPAIR_TOOL_NOT_EXIST,message:Language.Config.get(Language.Lib.NEED_REPAIR_TOOL),data:{}}}if(os.platform()!=Common.SYS_WIN32){return{code:ErrorCode.ERROR_SUCCESS,message:"ok",data:{}}}let[e,o]=await to(Util.checkSignExec(this.repairToolPath,""));if(e||o.code&&o.code!=ErrorCode.ERROR_CMD_SHELLFAILED){if(e){Log.warn(LOG_TAG,"open failed, reason:",e)}else{Log.warn(LOG_TAG,`log file path open fail, path:${this.repairToolPath}`,o.message)}return{code:ErrorCode.ERROR_CMD_FAILED,message:o.message,data:{}}}return{code:ErrorCode.ERROR_SUCCESS,message:"ok",data:{}}}async download(e,o,r,t){t=t||30*1e3;let a=e;this.downloader=new httpClient.HttpsDownloader;let[i,l]=await to(this.downloader.download(a,r,t));if(i&&!(i instanceof StreamError)&&o&&o!=e){Log.error(LOG_TAG,`From the service ${JSON.stringify(a)} download file to the local ${r} failure`,i);a=o;[i,l]=await to(this.downloader.download(a,r,t))}if(this.downloader.isCancel()){throw new CancelError("user cancel operator",{masterDownloadUrl:e,slaveDownloadUrl:o,saveDir:r})}if(i)throw i;return l}async checkSignature(e){if(!Util.winCCPlugin.CheckSangforSign(e)){throw new SignatureError("Check file signature failure",{path:e})}if(!Util.winCCPlugin.CheckFileOriginName(e)){await to(fs.promises.unlink(e));throw new SignatureError("Verify that the original file name failure",{path:e})}}stopDownload(){if(this.downloader){this.downloader.cancel()}}async install(e){let[o,r]=await to(Util.checkSignExec(e,""));if(o||r.code){if(o){Log.warn(LOG_TAG,"install failed, reason:",o)}else{Log.warn(LOG_TAG,"install fail, path {%s}, code {%d}",this.repairToolPath,r.code)}}Log.info(LOG_TAG,"repair tool install successful.",r)}}module.exports={repairTool:new RepairTool};