const Log=require("./logger");const assert=require("assert");const checker=require("./checker");const path=require("path");const LOG_TAG="[RpcClient]";class RpcClient{constructor(e){assert(checker.isString(e.servicename),"Options.servicename must be a string");assert(checker.isObject(e.service),"Options.service must be a object");assert(checker.isArray(e.methods),"Options.methods must be a array");assert(checker.isString(e.pipename),"Options.pipename must be a string");assert(checker.isFunction(e.port),"Options.port must be a function");e._methods={};for(var t in e.methods){e._methods[e.methods[t]]=true}this._options=e;this._connection=null}start(r,e){var t=new ThriftRpcClient(this._options);e=e||{};e.service=this._options.service;e.servicename=this._options.servicename;t.start(this,this._options.port(),this._options.pipename,(e,t)=>{if(e){r(e)}else{this._connection=t.sdp_connection;r(null,this)}},e)}startPromise(e){return new Promise((r,n)=>{this.start(function(e,t){if(e){n(e)}else{r(t)}},e)})}destroy(){if(!checker.isNull(this._connection)&&!checker.isUndefined(this._connection)){this._connection.destroy();this._connection=null}}_encapsulation(o,i){for(var e in o){if(!this._options._methods[e]){continue}if(!checker.isFunction(o[e])){Log.warn(LOG_TAG,`The ${e} is not a function of the "${this._options.servicename}", but is defined as encapsulated`);continue}if(!checker.isNull(this[e])&&!checker.isUndefined(this[e])){Log.debug(LOG_TAG,`The ${e} is a function of the "RcpClient", and will be redefined`)}var c=o[e];this[e]=function(n){return function(){var t=arguments[arguments.length-1];if(!checker.isFunction(t)){t=null;c.apply(o,arguments);return}if(!i.connected){setTimeout(function(){if(t){var e=new Error(`The connection has been closed`);e.code="ECLOSED";e.errno="ECLOSED";t.call(o,e);t=null}},0);return}var e=i.connection.timeout;e=e==0?6e4:e+3e3;var r=setTimeout(function(){if(t){var e=new Error(`The connection to the target has been timeout`);e.code="ETIMEOUT";e.errno="ETIMEOUT";t.call(o,e);t=null}},e);i.once("timeout",function(){if(t){var e=new Error(`The connection to the target has been timeout`);e.code="ETIMEOUT";e.errno="ETIMEOUT";t.call(o,e);t=null}});i.once("error",function(e){if(t&&e){clearTimeout(r);t.call(o,e);t=null}});i.once("close",function(){if(t){clearTimeout(r);var e=new Error(`The connection to the target has been closed`);e.code="ECLOSE";e.errno="ECLOSE";t.call(o,e);t=null}});arguments[arguments.length-1]=function(){if(t){clearTimeout(r);t.apply(o,arguments);t=null}};o[n].apply(o,arguments)}}(e);var s=this;this[`${e}Promise`]=function(o){return function(){var e=[];for(var t=0;t<arguments.length;++t){e.push(arguments[t])}return new Promise((r,n)=>{e.push(function(e,t){if(e){n(e)}else{r(t)}});s[o].apply(s,e)})}}(e)}return o}}class ThriftRpcClient{constructor(e){assert(checker.isObject(e),"Options must be objects ");this._options=e;if(!checker.isNull(e.transport)&&!checker.isUndefined(e.transport)){return}const t=require("./debug_options");if(t.thrift.transport!="all"&&t.thrift.transport!="tcp"){e.transport=t.thrift.transport}else{e.transport="tcp"}e.successfulConnection=false}start(r,n,o,i,c){assert(checker.range(n,1,65536),"The port number must be the bigint type and the port number is greater than 1 is less than 65535 ");assert(checker.isString(o)||checker.isUndefined(o)||checker.isNull(o),"The pipeline name must be a string type or null or undefined ");var s={tcp:function(e,t){return ThriftClient.connectToTcpServer(e,r,n,t)},pipe:function(e,t){return ThriftClient.connectToPipeServer(e,r,o,t)}};var a=[this._options.transport];a[1]=this._options.transport=="tcp"?"pipe":"tcp";var u=this;assert(checker.isFunction(s[a[0]]),`No ${a[0]} connection function in the connector`);s[a[0]](function(e,t){if(!e){if(!u._options.successfulConnection){Log.info(LOG_TAG,`Using ${a[0]} model, Connect to server successful, the server port: ${n}, pipename: ${o}`);u._options.successfulConnection=true}i(e,t);return}else{if(u._options.successfulConnection){Log.info(LOG_TAG,`Using ${a[0]} model, Connect to server failure, the server port: ${n}, pipename: ${o}`)}}const r=require("./debug_options");if(r.thrift.transport=="all"&&checker.isFunction(s[a[1]])){s[a[1]](function(e,t){if(!e){if(!u._options.successfulConnection){Log.info(LOG_TAG,`Using ${a[1]} model, Connect to server successful, the server port: ${n}, pipename: ${o}`);u._options.successfulConnection=true}u._options.transport=a[1]}else{if(u._options.successfulConnection){Log.info(LOG_TAG,`Using ${a[1]} model, Connect to server failure, the server port: ${n}, pipename: ${o}`);u._options.successfulConnection=false}}i(e,t)},c)}else{i(e,t);return}},c)}}class ThriftClient{static connectToTcpServer(r,n,o,i){assert(checker.range(o,1,65536),"The port number must be the bigint type and the port number is greater than 1 is less than 65535");i=i||{};i.timeout=i.timeout||1e4;i.connect_timeout=i.connect_timeout||3e3;i.retry_max_delay=i.retry_max_delay||0;return ThriftClient._connect(function(e,t){ThriftClient._connectionProbe(function(e,t){if(e){Log.error(LOG_TAG,`Using tcp mode failure`,e)}else{Log.debug(LOG_TAG,`Using tcp mode, and the server port is ${o}`)}r(e,t)},n,i,e,t)},ThriftClient._tcpConnect,o,i)}static connectToPipeServer(r,n,o,i){assert(checker.isString(o),"The pipeline name must have a value");i=i||{};i.timeout=i.timeout||1e4;i.connect_timeout=i.connect_timeout||3e3;i.retry_max_delay=i.retry_max_delay||0;return ThriftClient._connect(function(e,t){ThriftClient._connectionProbe(function(e,t){if(e){Log.error(LOG_TAG,`Using pipeline mode failure`,e)}else{Log.debug(LOG_TAG,`Using Pipeline mode, and the pipename is ${o}`)}r(e,t)},n,i,e,t)},ThriftClient._pipeConnect,o,i)}static _connectionProbe(r,e,t,n,o){assert(checker.isFunction(r),"Must specify the callback function number");if(n){r(n,null);return}const i=require("thrift");var c=new i.Multiplexer;var s=c.createClient(t.servicename,t.service,o);s.sdp_connection=o;e._encapsulation(s,o);if(!checker.isFunction(e.IsRpcStatusNormal)){r(n,s);return}e.IsRpcStatusNormal(function(e,t){checker.ignore_unuse(t);if(e){if(checker.isString(o.path)){Log.error(LOG_TAG,`Error detection of RPC service: ${o.path}`,e)}else if(checker.isNumber(o.port)){Log.error(LOG_TAG,`Error detection of RPC service: ${o.port}`,e)}o.destroy();r(e,null)}else{r(e,s)}})}static _pipename(e){assert(checker.isString(e),"The pipeline name must be a string type ");if(process.platform==="win32"){return"\\\\.\\pipe\\"+e}else{return path.join(Common.DEFAULT_AGENT_DIR,e)}}static _tcpConnect(e,t){assert(checker.range(e,1,65535),"The port number must be the bigint type and the port number is greater than 1 is less than 65535 ");const r=require("thrift");t.transport=r.TBufferedTransport;t.protocol=r.TBinaryProtocol;return r.createConnection("127.0.0.1",e,t)}static _pipeConnect(e,t){assert(checker.isString(e),"The pipeline name must be a string type ");const r=require("thrift");t.transport=r.TBufferedTransport;t.protocol=r.TBinaryProtocol;return r.createUDSConnection(ThriftClient._pipename(e),t)}static _connect(t,e,r,n){var o=e(r,n);var i=setTimeout(function(){Log.error(LOG_TAG,`Thrift is connected to the service  ${n.servicename} end timeout and does not capture the return of the thrift connecter`,"Deadline is triggered");if(checker.isFunction(t)){var e=new Error(`Connect to the target(${r}) timeout and the connect timeout is ${n.connect_timeout} ms `);e.code="ETIMEDOUT";e.errno="ETIMEDOUT";t(e);o=null;t=null}},n.timeout+1e3);o.on("connect",function(){Log.debug(LOG_TAG,`rpc client connect to service ${n.servicename} of target(${r}) success`);clearTimeout(i);if(checker.isFunction(t)){t(null,o);o=null;t=null}});o.on("error",function(e){Log.warn(LOG_TAG,`an error occurred on the RPC client connected to the service ${n.servicename} of target(${r})`,e);clearTimeout(i);if(checker.isFunction(t)){t(e);t=null}if(o){o.end();o.destroy();o=null}});o.on("timeout",function(){Log.warn(LOG_TAG,`rpc client connect to service ${n.servicename} of target(${r}) timeout`);clearTimeout(i);if(checker.isFunction(t)){var e=new Error(`Connect to the target(${r}) timeout and the connect timeout is ${n.connect_timeout} ms `);e.code="ETIMEDOUT";e.errno="ETIMEDOUT";t(e);t=null}});o.on("close",function(){Log.debug(LOG_TAG,`rpc client connect to service ${n.servicename} of target(${r}) has closed`);clearTimeout(i);if(checker.isFunction(t)){var e=new Error(`The connection to the target(${r}) has been closed`);e.code="ECLOSE";e.errno="ECLOSE";t(e);o=null;t=null}})}}const Common=require("../common");const Util=require("./util");const SdpCoreService=require("../thrift/SdpCoreService.js");const SdpDaemonService=require("../thrift/SdpDaemonService.js");const sdpDiagService=require("../thrift/SdpDiagnosisService");const SdpQtTrayService=require("../thrift/SdpQtTrayService");const SdpBroadcast=require("../thrift/SdpBroadcast");const SdpTrustTunnelService=require("../thrift/SdpTrustTunnelService");const SdpCSApplication=require("../thrift/SdpCSApplication");const SdpPromoteService=require("../thrift/SdpPromoteService");module.exports={RpcClient:RpcClient,aTrustCoerService:{servicename:"SdpCoreService",service:SdpCoreService,methods:["GetArgument","GetStatus","GetAllStatus","Broadcast","Logout","QuerySpaSeedExist","SetSpaSeed","IsRpcStatusNormal"],pipename:"aTrustCore-fcd60898-3ef4-423f-acc9-3b28dc0e9e22",port:function(){var e=Util.getServicePort(Common.RPC_CORE_NAME,Common.RPC_CORE_DEFAULT_PORT);if(!checker.isNumber(e)){e=parseInt(e)}return e}},aTrustCSApplication:{servicename:"SdpCSApplication",service:SdpCSApplication,methods:["saveLocalAppInfo","fetchLocalAppInfo","openLocalApplication","removeLocalApplication"],pipename:"aTrustCore-fcd60898-3ef4-423f-acc9-3b28dc0e9e22",port:function(){var e=Util.getServicePort(Common.RPC_CORE_NAME,Common.RPC_CORE_DEFAULT_PORT);if(!checker.isNumber(e)){e=parseInt(e)}return e}},aTrustDaemonService:{servicename:"SdpDaemonService",service:SdpDaemonService,methods:["RegisterMonitor","UnRegisterMonitor","UnRegisterMonitorAll","GetMonitorList"],pipename:"aTrustDaemon-8ec18c00-3768-4a5c-b2d7-da2a0f1b2167",port:function(){var e=Util.getServicePort(Common.RPC_NAME,Common.RPC_DAEMON_DEFAULT_PORT);if(!checker.isNumber(e)){e=parseInt(e)}return e}},SdpDiagnosisService:{servicename:"SdpDiagnosisService",service:sdpDiagService,methods:["startNetworkDiagnosis","startResourceDiagnosis","startResourceDiagnosisWithItems","IsRpcStatusNormal"],pipename:"aTrustTunnel-c46a26c5-2cd4-4c20-9352-8efbb6358ea0",port:function(){var e=Util.getServicePort(Common.RPC_TUNNEL_NAME,Common.RPC_TUNNEL_DEFAULT_PORT);if(!checker.isNumber(e)){e=parseInt(e)}return e}},aTrustTunnelService:{servicename:"SdpTrustTunnelService",service:SdpTrustTunnelService,methods:["getTunnelStatus","IsRpcStatusNormal","getBsodCheckResult","forceStartNetfltDriver"],pipename:"aTrustTunnel-c46a26c5-2cd4-4c20-9352-8efbb6358ea0",port:function(){var e=Util.getServicePort(Common.RPC_TUNNEL_NAME,Common.RPC_TUNNEL_DEFAULT_PORT);if(!checker.isNumber(e)){e=parseInt(e)}return e}},SdpBroadcastService:{servicename:"SdpBroadcastService",service:SdpBroadcast,methods:["identify","pull","push"],pipename:"aTrustCore-fcd60898-3ef4-423f-acc9-3b28dc0e9e22",port:function(){var e=Util.getServicePort(Common.RPC_CORE_NAME,Common.RPC_CORE_DEFAULT_PORT);if(!checker.isNumber(e)){e=parseInt(e)}return e}},SdpQtTrayService:{servicename:"SdpQtTrayService",service:SdpQtTrayService,methods:["syncWorkSpaceToQtTray","IsRpcStatusNormal"],pipename:"aTrustQtTray-8c34c862-7858-4775-b3d4-071a26b77bfe",port:function(){return Common.RPC_QTTRAY_DEFAULT_PORT}},SdpPromoteService:{servicename:"SdpPromoteService",service:SdpPromoteService,methods:["updatePortal","copyPortalDir","delPortalDir"],pipename:"aTrustDaemon-8ec18c00-3768-4a5c-b2d7-da2a0f1b2167",port:function(){var e=Util.getServicePort(Common.RPC_NAME,Common.RPC_DAEMON_DEFAULT_PORT);if(!checker.isNumber(e)){e=parseInt(e)}return e}}};