var log=require("./log");var binary=require("./binary");var Int64=require("node-int64");var Thrift=require("./thrift");var Type=Thrift.Type;module.exports=TBinaryProtocol;var VERSION_MASK=-65536,VERSION_1=-2147418112,TYPE_MASK=255;function TBinaryProtocol(t,r,e){this.trans=t;this.strictRead=r!==undefined?r:false;this.strictWrite=e!==undefined?e:true}TBinaryProtocol.prototype.flush=function(){return this.trans.flush()};TBinaryProtocol.prototype.writeMessageBegin=function(t,r,e){if(this.strictWrite){this.writeI32(VERSION_1|r);this.writeString(t);this.writeI32(e)}else{this.writeString(t);this.writeByte(r);this.writeI32(e)}if(this._seqid){log.warning("SeqId already set",{name:t})}else{this._seqid=e;this.trans.setCurrSeqId(e)}};TBinaryProtocol.prototype.writeMessageEnd=function(){if(this._seqid){this._seqid=null}else{log.warning("No seqid to unset")}};TBinaryProtocol.prototype.writeStructBegin=function(t){};TBinaryProtocol.prototype.writeStructEnd=function(){};TBinaryProtocol.prototype.writeFieldBegin=function(t,r,e){this.writeByte(r);this.writeI16(e)};TBinaryProtocol.prototype.writeFieldEnd=function(){};TBinaryProtocol.prototype.writeFieldStop=function(){this.writeByte(Type.STOP)};TBinaryProtocol.prototype.writeMapBegin=function(t,r,e){this.writeByte(t);this.writeByte(r);this.writeI32(e)};TBinaryProtocol.prototype.writeMapEnd=function(){};TBinaryProtocol.prototype.writeListBegin=function(t,r){this.writeByte(t);this.writeI32(r)};TBinaryProtocol.prototype.writeListEnd=function(){};TBinaryProtocol.prototype.writeSetBegin=function(t,r){this.writeByte(t);this.writeI32(r)};TBinaryProtocol.prototype.writeSetEnd=function(){};TBinaryProtocol.prototype.writeBool=function(t){if(t){this.writeByte(1)}else{this.writeByte(0)}};TBinaryProtocol.prototype.writeByte=function(t){this.trans.write(new Buffer([t]))};TBinaryProtocol.prototype.writeI16=function(t){this.trans.write(binary.writeI16(new Buffer(2),t))};TBinaryProtocol.prototype.writeI32=function(t){this.trans.write(binary.writeI32(new Buffer(4),t))};TBinaryProtocol.prototype.writeI64=function(t){if(t.buffer){this.trans.write(t.buffer)}else{this.trans.write(new Int64(t).buffer)}};TBinaryProtocol.prototype.writeDouble=function(t){this.trans.write(binary.writeDouble(new Buffer(8),t))};TBinaryProtocol.prototype.writeStringOrBinary=function(t,r,e){if(typeof e==="string"){this.writeI32(Buffer.byteLength(e,r));this.trans.write(new Buffer(e,r))}else if(e instanceof Buffer||Object.prototype.toString.call(e)=="[object Uint8Array]"){this.writeI32(e.length);this.trans.write(e)}else{throw new Error(t+" called without a string/Buffer argument: "+e)}};TBinaryProtocol.prototype.writeString=function(t){this.writeStringOrBinary("writeString","utf8",t)};TBinaryProtocol.prototype.writeBinary=function(t){this.writeStringOrBinary("writeBinary","binary",t)};TBinaryProtocol.prototype.readMessageBegin=function(){var t=this.readI32();var r,e,i;if(t<0){var o=t&VERSION_MASK;if(o!=VERSION_1){throw new Thrift.TProtocolException(Thrift.TProtocolExceptionType.BAD_VERSION,"Bad version in readMessageBegin: "+t)}r=t&TYPE_MASK;e=this.readString();i=this.readI32()}else{if(this.strictRead){throw new Thrift.TProtocolException(Thrift.TProtocolExceptionType.BAD_VERSION,"No protocol version header")}e=this.trans.read(t);r=this.readByte();i=this.readI32()}return{fname:e,mtype:r,rseqid:i}};TBinaryProtocol.prototype.readMessageEnd=function(){};TBinaryProtocol.prototype.readStructBegin=function(){return{fname:""}};TBinaryProtocol.prototype.readStructEnd=function(){};TBinaryProtocol.prototype.readFieldBegin=function(){var t=this.readByte();if(t==Type.STOP){return{fname:null,ftype:t,fid:0}}var r=this.readI16();return{fname:null,ftype:t,fid:r}};TBinaryProtocol.prototype.readFieldEnd=function(){};TBinaryProtocol.prototype.readMapBegin=function(){var t=this.readByte();var r=this.readByte();var e=this.readI32();return{ktype:t,vtype:r,size:e}};TBinaryProtocol.prototype.readMapEnd=function(){};TBinaryProtocol.prototype.readListBegin=function(){var t=this.readByte();var r=this.readI32();return{etype:t,size:r}};TBinaryProtocol.prototype.readListEnd=function(){};TBinaryProtocol.prototype.readSetBegin=function(){var t=this.readByte();var r=this.readI32();return{etype:t,size:r}};TBinaryProtocol.prototype.readSetEnd=function(){};TBinaryProtocol.prototype.readBool=function(){var t=this.readByte();if(t===0){return false}return true};TBinaryProtocol.prototype.readByte=function(){return this.trans.readByte()};TBinaryProtocol.prototype.readI16=function(){return this.trans.readI16()};TBinaryProtocol.prototype.readI32=function(){return this.trans.readI32()};TBinaryProtocol.prototype.readI64=function(){var t=this.trans.read(8);return new Int64(t)};TBinaryProtocol.prototype.readDouble=function(){return this.trans.readDouble()};TBinaryProtocol.prototype.readBinary=function(){var t=this.readI32();if(t===0){return new Buffer(0)}if(t<0){throw new Thrift.TProtocolException(Thrift.TProtocolExceptionType.NEGATIVE_SIZE,"Negative binary size")}return this.trans.read(t)};TBinaryProtocol.prototype.readString=function(){var t=this.readI32();if(t===0){return""}if(t<0){throw new Thrift.TProtocolException(Thrift.TProtocolExceptionType.NEGATIVE_SIZE,"Negative string size")}return this.trans.readString(t)};TBinaryProtocol.prototype.getTransport=function(){return this.trans};TBinaryProtocol.prototype.skip=function(t){switch(t){case Type.STOP:return;case Type.BOOL:this.readBool();break;case Type.BYTE:this.readByte();break;case Type.I16:this.readI16();break;case Type.I32:this.readI32();break;case Type.I64:this.readI64();break;case Type.DOUBLE:this.readDouble();break;case Type.STRING:this.readString();break;case Type.STRUCT:this.readStructBegin();while(true){var r=this.readFieldBegin();if(r.ftype===Type.STOP){break}this.skip(r.ftype);this.readFieldEnd()}this.readStructEnd();break;case Type.MAP:var e=this.readMapBegin();for(var i=0;i<e.size;++i){this.skip(e.ktype);this.skip(e.vtype)}this.readMapEnd();break;case Type.SET:var o=this.readSetBegin();for(var n=0;n<o.size;++n){this.skip(o.etype)}this.readSetEnd();break;case Type.LIST:var a=this.readListBegin();for(var s=0;s<a.size;++s){this.skip(a.etype)}this.readListEnd();break;default:throw new Error("Invalid type: "+t)}};