var log=require("./log");var Int64=require("node-int64");var Thrift=require("./thrift");var Type=Thrift.Type;module.exports=TCompactProtocol;var POW_8=Math.pow(2,8);var POW_24=Math.pow(2,24);var POW_32=Math.pow(2,32);var POW_40=Math.pow(2,40);var POW_48=Math.pow(2,48);var POW_52=Math.pow(2,52);var POW_1022=Math.pow(2,1022);function TCompactProtocol(t){this.trans=t;this.lastField_=[];this.lastFieldId_=0;this.string_limit_=0;this.string_buf_=null;this.string_buf_size_=0;this.container_limit_=0;this.booleanField_={name:null,hasBoolValue:false};this.boolValue_={hasBoolValue:false,boolValue:false}}TCompactProtocol.PROTOCOL_ID=-126;TCompactProtocol.VERSION_N=1;TCompactProtocol.VERSION_MASK=31;TCompactProtocol.TYPE_MASK=-32;TCompactProtocol.TYPE_BITS=7;TCompactProtocol.TYPE_SHIFT_AMOUNT=5;TCompactProtocol.Types={CT_STOP:0,CT_BOOLEAN_TRUE:1,CT_BOOLEAN_FALSE:2,CT_BYTE:3,CT_I16:4,CT_I32:5,CT_I64:6,CT_DOUBLE:7,CT_BINARY:8,CT_LIST:9,CT_SET:10,CT_MAP:11,CT_STRUCT:12};TCompactProtocol.TTypeToCType=[TCompactProtocol.Types.CT_STOP,0,TCompactProtocol.Types.CT_BOOLEAN_TRUE,TCompactProtocol.Types.CT_BYTE,TCompactProtocol.Types.CT_DOUBLE,0,TCompactProtocol.Types.CT_I16,0,TCompactProtocol.Types.CT_I32,0,TCompactProtocol.Types.CT_I64,TCompactProtocol.Types.CT_BINARY,TCompactProtocol.Types.CT_STRUCT,TCompactProtocol.Types.CT_MAP,TCompactProtocol.Types.CT_SET,TCompactProtocol.Types.CT_LIST];TCompactProtocol.prototype.getTransport=function(){return this.trans};TCompactProtocol.prototype.getCompactType=function(t){return TCompactProtocol.TTypeToCType[t]};TCompactProtocol.prototype.getTType=function(t){switch(t){case Type.STOP:return Type.STOP;case TCompactProtocol.Types.CT_BOOLEAN_FALSE:case TCompactProtocol.Types.CT_BOOLEAN_TRUE:return Type.BOOL;case TCompactProtocol.Types.CT_BYTE:return Type.BYTE;case TCompactProtocol.Types.CT_I16:return Type.I16;case TCompactProtocol.Types.CT_I32:return Type.I32;case TCompactProtocol.Types.CT_I64:return Type.I64;case TCompactProtocol.Types.CT_DOUBLE:return Type.DOUBLE;case TCompactProtocol.Types.CT_BINARY:return Type.STRING;case TCompactProtocol.Types.CT_LIST:return Type.LIST;case TCompactProtocol.Types.CT_SET:return Type.SET;case TCompactProtocol.Types.CT_MAP:return Type.MAP;case TCompactProtocol.Types.CT_STRUCT:return Type.STRUCT;default:throw new Thrift.TProtocolException(Thrift.TProtocolExceptionType.INVALID_DATA,"Unknown type: "+t)}return Type.STOP};TCompactProtocol.prototype.flush=function(){return this.trans.flush()};TCompactProtocol.prototype.writeMessageBegin=function(t,o,e){this.writeByte(TCompactProtocol.PROTOCOL_ID);this.writeByte(TCompactProtocol.VERSION_N&TCompactProtocol.VERSION_MASK|o<<TCompactProtocol.TYPE_SHIFT_AMOUNT&TCompactProtocol.TYPE_MASK);this.writeVarint32(e);this.writeString(t);if(this._seqid){log.warning("SeqId already set",{name:t})}else{this._seqid=e;this.trans.setCurrSeqId(e)}};TCompactProtocol.prototype.writeMessageEnd=function(){};TCompactProtocol.prototype.writeStructBegin=function(t){this.lastField_.push(this.lastFieldId_);this.lastFieldId_=0};TCompactProtocol.prototype.writeStructEnd=function(){this.lastFieldId_=this.lastField_.pop()};TCompactProtocol.prototype.writeFieldBegin=function(t,o,e){if(o!=Type.BOOL){return this.writeFieldBeginInternal(t,o,e,-1)}this.booleanField_.name=t;this.booleanField_.fieldType=o;this.booleanField_.fieldId=e};TCompactProtocol.prototype.writeFieldEnd=function(){};TCompactProtocol.prototype.writeFieldStop=function(){this.writeByte(TCompactProtocol.Types.CT_STOP)};TCompactProtocol.prototype.writeMapBegin=function(t,o,e){if(e===0){this.writeByte(0)}else{this.writeVarint32(e);this.writeByte(this.getCompactType(t)<<4|this.getCompactType(o))}};TCompactProtocol.prototype.writeMapEnd=function(){};TCompactProtocol.prototype.writeListBegin=function(t,o){this.writeCollectionBegin(t,o)};TCompactProtocol.prototype.writeListEnd=function(){};TCompactProtocol.prototype.writeSetBegin=function(t,o){this.writeCollectionBegin(t,o)};TCompactProtocol.prototype.writeSetEnd=function(){};TCompactProtocol.prototype.writeBool=function(t){if(this.booleanField_.name!==null){this.writeFieldBeginInternal(this.booleanField_.name,this.booleanField_.fieldType,this.booleanField_.fieldId,t?TCompactProtocol.Types.CT_BOOLEAN_TRUE:TCompactProtocol.Types.CT_BOOLEAN_FALSE);this.booleanField_.name=null}else{this.writeByte(t?TCompactProtocol.Types.CT_BOOLEAN_TRUE:TCompactProtocol.Types.CT_BOOLEAN_FALSE)}};TCompactProtocol.prototype.writeByte=function(t){this.trans.write(new Buffer([t]))};TCompactProtocol.prototype.writeI16=function(t){this.writeVarint32(this.i32ToZigzag(t))};TCompactProtocol.prototype.writeI32=function(t){this.writeVarint32(this.i32ToZigzag(t))};TCompactProtocol.prototype.writeI64=function(t){this.writeVarint64(this.i64ToZigzag(t))};TCompactProtocol.prototype.writeDouble=function(t){var o=new Buffer(8);var e,r,i;o[7]=t<0?128:0;t=Math.abs(t);if(t!==t){e=0x8000000000000;r=2047}else if(t===Infinity){e=0;r=2047}else{r=Math.floor(Math.log(t)/Math.LN2);i=Math.pow(2,-r);if(t*i<1){r--;i*=2}if(r+1023>=2047){e=0;r=2047}else if(r+1023>=1){e=(t*i-1)*POW_52;r+=1023}else{e=t*POW_1022*POW_52;r=0}}o[6]=r<<4&240;o[7]|=r>>4&127;o[0]=e&255;e=Math.floor(e/POW_8);o[1]=e&255;e=Math.floor(e/POW_8);o[2]=e&255;e=Math.floor(e/POW_8);o[3]=e&255;e>>=8;o[4]=e&255;e>>=8;o[5]=e&255;e>>=8;o[6]|=e&15;this.trans.write(o)};TCompactProtocol.prototype.writeStringOrBinary=function(t,o,e){if(typeof e==="string"){this.writeVarint32(Buffer.byteLength(e,o));this.trans.write(new Buffer(e,o))}else if(e instanceof Buffer||Object.prototype.toString.call(e)=="[object Uint8Array]"){this.writeVarint32(e.length);this.trans.write(e)}else{throw new Error(t+" called without a string/Buffer argument: "+e)}};TCompactProtocol.prototype.writeString=function(t){this.writeStringOrBinary("writeString","utf8",t)};TCompactProtocol.prototype.writeBinary=function(t){this.writeStringOrBinary("writeBinary","binary",t)};TCompactProtocol.prototype.writeFieldBeginInternal=function(t,o,e,r){var i=r==-1?this.getCompactType(o):r;if(e>this.lastFieldId_&&e-this.lastFieldId_<=15){this.writeByte(e-this.lastFieldId_<<4|i)}else{this.writeByte(i);this.writeI16(e)}this.lastFieldId_=e};TCompactProtocol.prototype.writeCollectionBegin=function(t,o){if(o<=14){this.writeByte(o<<4|this.getCompactType(t))}else{this.writeByte(240|this.getCompactType(t));this.writeVarint32(o)}};TCompactProtocol.prototype.writeVarint32=function(t){var o=new Buffer(5);var e=0;while(true){if((t&~127)===0){o[e++]=t;break}else{o[e++]=t&127|128;t=t>>>7}}var r=new Buffer(e);o.copy(r,0,0,e);this.trans.write(r)};TCompactProtocol.prototype.writeVarint64=function(t){if(typeof t==="number"){t=new Int64(t)}if(!(t instanceof Int64)){throw new Thrift.TProtocolException(Thrift.TProtocolExceptionType.INVALID_DATA,"Expected Int64 or Number, found: "+t)}var o=new Buffer(10);var e=0;var r=t.buffer.readUInt32BE(0,true);var i=t.buffer.readUInt32BE(4,true);var a=0;while(true){if((i&~127)===0&&r===0){o[e++]=i;break}else{o[e++]=i&127|128;a=r<<25;i=i>>>7;r=r>>>7;i=i|a}}var p=new Buffer(e);o.copy(p,0,0,e);this.trans.write(p)};TCompactProtocol.prototype.i64ToZigzag=function(t){if(typeof t==="string"){t=new Int64(parseInt(t,10))}else if(typeof t==="number"){t=new Int64(t)}if(!(t instanceof Int64)){throw new Thrift.TProtocolException(Thrift.TProtocolExceptionType.INVALID_DATA,"Expected Int64 or Number, found: "+t)}var o=t.buffer.readUInt32BE(0,true);var e=t.buffer.readUInt32BE(4,true);var r=o>>>31;o=(o<<1|e>>>31)^(!!r?4294967295:0);e=e<<1^(!!r?4294967295:0);return new Int64(o,e)};TCompactProtocol.prototype.i32ToZigzag=function(t){return t<<1^(t&2147483648?4294967295:0)};TCompactProtocol.prototype.readMessageBegin=function(){var t=this.trans.readByte();if(t!=TCompactProtocol.PROTOCOL_ID){throw new Thrift.TProtocolException(Thrift.TProtocolExceptionType.BAD_VERSION,"Bad protocol identifier "+t)}var o=this.trans.readByte();var e=o&TCompactProtocol.VERSION_MASK;if(e!=TCompactProtocol.VERSION_N){throw new Thrift.TProtocolException(Thrift.TProtocolExceptionType.BAD_VERSION,"Bad protocol version "+e)}var r=o>>TCompactProtocol.TYPE_SHIFT_AMOUNT&TCompactProtocol.TYPE_BITS;var i=this.readVarint32();var a=this.readString();return{fname:a,mtype:r,rseqid:i}};TCompactProtocol.prototype.readMessageEnd=function(){};TCompactProtocol.prototype.readStructBegin=function(){this.lastField_.push(this.lastFieldId_);this.lastFieldId_=0;return{fname:""}};TCompactProtocol.prototype.readStructEnd=function(){this.lastFieldId_=this.lastField_.pop()};TCompactProtocol.prototype.readFieldBegin=function(){var t=0;var o=this.trans.readByte(o);var e=o&15;if(e==TCompactProtocol.Types.CT_STOP){return{fname:null,ftype:Thrift.Type.STOP,fid:0}}var r=(o&240)>>>4;if(r===0){t=this.readI16()}else{t=this.lastFieldId_+r}var i=this.getTType(e);if(e==TCompactProtocol.Types.CT_BOOLEAN_TRUE||e==TCompactProtocol.Types.CT_BOOLEAN_FALSE){this.boolValue_.hasBoolValue=true;this.boolValue_.boolValue=e==TCompactProtocol.Types.CT_BOOLEAN_TRUE?true:false}this.lastFieldId_=t;return{fname:null,ftype:i,fid:t}};TCompactProtocol.prototype.readFieldEnd=function(){};TCompactProtocol.prototype.readMapBegin=function(){var t=this.readVarint32();if(t<0){throw new Thrift.TProtocolException(Thrift.TProtocolExceptionType.NEGATIVE_SIZE,"Negative map size")}var o=0;if(t!==0){o=this.trans.readByte()}var e=this.getTType((o&240)>>>4);var r=this.getTType(o&15);return{ktype:e,vtype:r,size:t}};TCompactProtocol.prototype.readMapEnd=function(){};TCompactProtocol.prototype.readListBegin=function(){var t=this.trans.readByte();var o=t>>>4&15;if(o==15){o=this.readVarint32()}if(o<0){throw new Thrift.TProtocolException(Thrift.TProtocolExceptionType.NEGATIVE_SIZE,"Negative list size")}var e=this.getTType(t&15);return{etype:e,size:o}};TCompactProtocol.prototype.readListEnd=function(){};TCompactProtocol.prototype.readSetBegin=function(){return this.readListBegin()};TCompactProtocol.prototype.readSetEnd=function(){};TCompactProtocol.prototype.readBool=function(){var t=false;var o=0;if(this.boolValue_.hasBoolValue===true){t=this.boolValue_.boolValue;this.boolValue_.hasBoolValue=false}else{var e=this.trans.readByte();o=e.rsize;t=e.value==TCompactProtocol.Types.CT_BOOLEAN_TRUE}return t};TCompactProtocol.prototype.readByte=function(){return this.trans.readByte()};TCompactProtocol.prototype.readI16=function(){return this.readI32()};TCompactProtocol.prototype.readI32=function(){return this.zigzagToI32(this.readVarint32())};TCompactProtocol.prototype.readI64=function(){return this.zigzagToI64(this.readVarint64())};TCompactProtocol.prototype.readDouble=function(){var t=this.trans.read(8);var o=0;var e=t[o+7]&128;var r=(t[o+6]&240)>>4;r+=(t[o+7]&127)<<4;var i=t[o];i+=t[o+1]<<8;i+=t[o+2]<<16;i+=t[o+3]*POW_24;i+=t[o+4]*POW_32;i+=t[o+5]*POW_40;i+=(t[o+6]&15)*POW_48;switch(r){case 0:r=-1022;break;case 2047:return i?NaN:e?-Infinity:Infinity;default:i+=POW_52;r-=1023}if(e){i*=-1}return i*Math.pow(2,r-52)};TCompactProtocol.prototype.readBinary=function(){var t=this.readVarint32();if(t===0){return new Buffer(0)}if(t<0){throw new Thrift.TProtocolException(Thrift.TProtocolExceptionType.NEGATIVE_SIZE,"Negative binary size")}return this.trans.read(t)};TCompactProtocol.prototype.readString=function(){var t=this.readVarint32();if(t===0){return""}if(t<0){throw new Thrift.TProtocolException(Thrift.TProtocolExceptionType.NEGATIVE_SIZE,"Negative string size")}return this.trans.readString(t)};TCompactProtocol.prototype.readVarint32=function(){return this.readVarint64().toNumber()};TCompactProtocol.prototype.readVarint64=function(){var t=0;var o=0;var e=0;var r=0;while(true){var i=this.trans.readByte();t++;if(r<=25){o=o|(i&127)<<r}else if(25<r&&r<32){o=o|(i&127)<<r;e=e|(i&127)>>>32-r}else{e=e|(i&127)<<r-32}r+=7;if(!(i&128)){break}if(t>=10){throw new Thrift.TProtocolException(Thrift.TProtocolExceptionType.INVALID_DATA,"Variable-length int over 10 bytes.")}}return new Int64(e,o)};TCompactProtocol.prototype.zigzagToI32=function(t){return t>>>1^-1*(t&1)};TCompactProtocol.prototype.zigzagToI64=function(t){var o=t.buffer.readUInt32BE(0,true);var e=t.buffer.readUInt32BE(4,true);var r=new Int64(o&0,e&1);r._2scomp();var i=r.buffer.readUInt32BE(0,true);var a=r.buffer.readUInt32BE(4,true);var p=o<<31;o=o>>>1^i;e=(e>>>1|p)^a;return new Int64(o,e)};TCompactProtocol.prototype.skip=function(t){switch(t){case Type.STOP:return;case Type.BOOL:this.readBool();break;case Type.BYTE:this.readByte();break;case Type.I16:this.readI16();break;case Type.I32:this.readI32();break;case Type.I64:this.readI64();break;case Type.DOUBLE:this.readDouble();break;case Type.STRING:this.readString();break;case Type.STRUCT:this.readStructBegin();while(true){var o=this.readFieldBegin();if(o.ftype===Type.STOP){break}this.skip(o.ftype);this.readFieldEnd()}this.readStructEnd();break;case Type.MAP:var e=this.readMapBegin();for(var r=0;r<e.size;++r){this.skip(e.ktype);this.skip(e.vtype)}this.readMapEnd();break;case Type.SET:var i=this.readSetBegin();for(var a=0;a<i.size;++a){this.skip(i.etype)}this.readSetEnd();break;case Type.LIST:var p=this.readListBegin();for(var n=0;n<p.size;++n){this.skip(p.etype)}this.readListEnd();break;default:throw new Error("Invalid type: "+t)}};