var util=require("util");var EventEmitter=require("events").EventEmitter;var constants=require("constants");var net=require("net");var tls=require("tls");var thrift=require("./thrift");var log=require("./log");var TBufferedTransport=require("./buffered_transport");var TBinaryProtocol=require("./binary_protocol");var InputBufferUnderrunError=require("./input_buffer_underrun_error");var createClient=require("./create_client");var binary=require("./binary");var Connection=exports.Connection=function(t,e){var c=this;EventEmitter.call(this);this.seqId2Service={};this.connection=t;this.ssl=t.encrypted;this.options=e||{};this.transport=this.options.transport||TBufferedTransport;this.protocol=this.options.protocol||TBinaryProtocol;this.offline_queue=[];this.connected=false;this.initialize_retry_vars();this._debug=this.options.debug||false;if(this.options.max_attempts&&!isNaN(this.options.max_attempts)&&this.options.max_attempts>0){this.max_attempts=+this.options.max_attempts}this.retry_max_delay=null;if(this.options.retry_max_delay!==undefined&&!isNaN(this.options.retry_max_delay)&&this.options.retry_max_delay>0){this.retry_max_delay=this.options.retry_max_delay}this.connect_timeout=false;if(this.options.connect_timeout&&!isNaN(this.options.connect_timeout)&&this.options.connect_timeout>0){this.connect_timeout=+this.options.connect_timeout}this.connection.addListener(this.ssl?"secureConnect":"connect",function(){c.connected=true;this.setTimeout(c.options.timeout||0);this.setNoDelay();this.frameLeft=0;this.framePos=0;this.frame=null;c.initialize_retry_vars();c.offline_queue.forEach(function(t){c.connection.write(t)});c.emit("connect")});this.connection.addListener("error",function(t){if(c.connection.listeners("error").length===1||c.listeners("error").length>0){c.emit("error",t)}});this.connection.addListener("close",function(){c.connection_gone()});this.connection.addListener("timeout",function(){c.emit("timeout")});this.connection.addListener("data",c.transport.receiver(function(i){var t=new c.protocol(i);try{while(true){var r=t.readMessageBegin();var e=r.rseqid*-1;var o=c.client;var s=c.seqId2Service[r.rseqid];if(s){o=c.client[s]}o._reqs[e]=function(t,e){i.commitPosition();var n=o._reqs[r.rseqid];delete o._reqs[r.rseqid];if(s){delete c.seqId2Service[r.rseqid]}if(n){n(t,e)}};if(o["recv_"+r.fname]){o["recv_"+r.fname](t,r.mtype,e)}else{delete o._reqs[e];c.emit("error",new thrift.TApplicationException(thrift.TApplicationExceptionType.WRONG_METHOD_NAME,"Received a response to an unknown RPC function"))}}}catch(t){if(t instanceof InputBufferUnderrunError){i.rollbackPosition()}else{c.emit("error",t)}}}))};util.inherits(Connection,EventEmitter);Connection.prototype.end=function(){this.connection.end()};Connection.prototype.destroy=function(){this.connection.destroy()};Connection.prototype.initialize_retry_vars=function(){this.retry_timer=null;this.retry_totaltime=0;this.retry_delay=150;this.retry_backoff=1.7;this.attempts=0};Connection.prototype.write=function(t){if(!this.connected){this.offline_queue.push(t);return}this.connection.write(t)};Connection.prototype.connection_gone=function(){var t=this;this.connected=false;if(this.retry_timer){return}if(!this.max_attempts||this.ssl){t.emit("close");return}if(this.retry_max_delay!==null&&this.retry_delay>=this.retry_max_delay){this.retry_delay=this.retry_max_delay}else{this.retry_delay=Math.floor(this.retry_delay*this.retry_backoff)}log.debug("Retry connection in "+this.retry_delay+" ms");if(this.max_attempts&&this.attempts>=this.max_attempts){this.retry_timer=null;console.error("thrift: Couldn't get thrift connection after "+this.max_attempts+" attempts.");t.emit("close");return}this.attempts+=1;this.emit("reconnecting",{delay:t.retry_delay,attempt:t.attempts});this.retry_timer=setTimeout(function(){log.debug("Retrying connection...");t.retry_totaltime+=t.retry_delay;if(t.connect_timeout&&t.retry_totaltime>=t.connect_timeout){t.retry_timer=null;console.error("thrift: Couldn't get thrift connection after "+t.retry_totaltime+"ms.");t.emit("close");return}if(t.path){t.connection.connect(t.path)}else{t.connection.connect(t.port,t.host)}t.retry_timer=null},this.retry_delay)};exports.createConnection=function(t,e,n){var i=net.createConnection(e,t);var r=new Connection(i,n);r.host=t;r.port=e;return r};exports.createUnixConnection=function(t,e){var n=net.createConnection(t);var i=new Connection(n,e);i.path=t;return i};exports.createSSLConnection=function(t,e,n){if(!("secureProtocol"in n)&&!("secureOptions"in n)){n.secureProtocol="SSLv23_method";n.secureOptions=constants.SSL_OP_NO_SSLv2|constants.SSL_OP_NO_SSLv3}var i=tls.connect(e,t,n);var r=new Connection(i,n);r.host=t;r.port=e;return r};exports.createClient=createClient;var child_process=require("child_process");var StdIOConnection=exports.StdIOConnection=function(t,e){var n=t.split(" ");t=n[0];var i=n.splice(1,n.length-1);var r=this.child=child_process.spawn(t,i);var s=this;EventEmitter.call(this);this.connection=r.stdin;this.options=e||{};this.transport=this.options.transport||TBufferedTransport;this.protocol=this.options.protocol||TBinaryProtocol;this.offline_queue=[];if(log.getLogLevel()==="debug"){this.child.stderr.on("data",function(t){log.debug(t.toString(),"CHILD ERROR")});this.child.on("exit",function(t,e){log.debug(t+":"+e,"CHILD EXITED")})}this.frameLeft=0;this.framePos=0;this.frame=null;this.connected=true;s.offline_queue.forEach(function(t){s.connection.write(t)});this.connection.addListener("error",function(t){s.emit("error",t)});this.connection.addListener("close",function(){s.emit("close")});r.stdout.addListener("data",s.transport.receiver(function(i){var t=new s.protocol(i);try{var r=t.readMessageBegin();var e=r.rseqid*-1;var o=s.client;o._reqs[e]=function(t,e){i.commitPosition();var n=o._reqs[r.rseqid];delete o._reqs[r.rseqid];if(n){n(t,e)}};o["recv_"+r.fname](t,r.mtype,e)}catch(t){if(t instanceof InputBufferUnderrunError){i.rollbackPosition()}else{throw t}}}))};util.inherits(StdIOConnection,EventEmitter);StdIOConnection.prototype.end=function(){this.connection.end()};StdIOConnection.prototype.write=function(t){if(!this.connected){this.offline_queue.push(t);return}this.connection.write(t)};exports.createStdIOConnection=function(t,e){return new StdIOConnection(t,e)};exports.createStdIOClient=createClient;