var http=require("http");var https=require("https");var url=require("url");var path=require("path");var fs=require("fs");var crypto=require("crypto");var log=require("./log");var MultiplexedProcessor=require("./multiplexed_processor").MultiplexedProcessor;var TBufferedTransport=require("./buffered_transport");var TBinaryProtocol=require("./binary_protocol");var InputBufferUnderrunError=require("./input_buffer_underrun_error");var wsFrame={encode:function(e,r,a){var t=new Buffer(wsFrame.frameSizeFromData(e,r));t[0]=wsFrame.fin.FIN+(a?wsFrame.frameOpCodes.BIN:wsFrame.frameOpCodes.TEXT);var n=2;if(e.length<126){t[1]=e.length+(r?wsFrame.mask.TO_SERVER:wsFrame.mask.TO_CLIENT)}else if(e.length<65535){t[1]=126+(r?wsFrame.mask.TO_SERVER:wsFrame.mask.TO_CLIENT);t.writeUInt16BE(e.length,2,true);n=4}else{t[1]=127+(r?wsFrame.mask.TO_SERVER:wsFrame.mask.TO_CLIENT);t.writeUInt32BE(0,2,true);t.writeUInt32BE(e.length,6,true);n=10}if(r){r.copy(t,n,0,4);n+=4}e.copy(t,n);if(r){wsFrame.applyMask(t.slice(n),t.slice(n-4,n))}return t},decode:function(e){var r={data:null,mask:null,binEncoding:false,nextFrame:null,FIN:true};if(wsFrame.fin.FIN!=(e[0]&wsFrame.fin.FIN)){r.FIN=false}r.binEncoding=wsFrame.frameOpCodes.BIN==(e[0]&wsFrame.frameOpCodes.BIN);var a=e[1]&127;var t=a;var n=2;if(a==126){t=e.readUInt16BE(2);n=4}else if(a==127){t=e.readUInt32BE(6);n=10}if(wsFrame.mask.TO_SERVER==(e[1]&wsFrame.mask.TO_SERVER)){r.mask=new Buffer(4);e.copy(r.mask,0,n,n+4);n+=4}r.data=new Buffer(t);e.copy(r.data,0,n,n+t);if(r.mask){wsFrame.applyMask(r.data,r.mask)}if(e.length>n+t){r.nextFrame=new Buffer(e.length-(n+t));e.copy(r.nextFrame,0,n+t,e.length)}if(e[0]&wsFrame.frameOpCodes.FINCTRL){r.data=null}return r},applyMask:function(e,r){var a=e.length;var t=r.length;for(var n=0;n<a;n++){e[n]=e[n]^r[n%t]}},frameSizeFromData:function(e,r){var a=10;if(e.length<126){a=2}else if(e.length<65535){a=4}return a+e.length+(r?4:0)},frameOpCodes:{CONT:0,TEXT:1,BIN:2,CTRL:128},mask:{TO_SERVER:128,TO_CLIENT:0},fin:{CONT:0,FIN:128}};exports.createWebServer=function(i){var a=i.files;var c={".txt":"text/plain",".html":"text/html",".css":"text/css",".xml":"application/xml",".json":"application/json",".js":"application/javascript",".jpg":"image/jpeg",".jpeg":"image/jpeg",".gif":"image/gif",".png":"image/png",".svg":"image/svg+xml"};var s=i.services;for(var e in s){var r=s[e];if(r.processor instanceof MultiplexedProcessor){r.processor=r.processor}else{var t=r.processor?r.processor.Processor||r.processor:r.cls.Processor||r.cls;if(r.handler){r.processor=new t(r.handler)}else{r.processor=t}}r.transport=r.transport?r.transport:TBufferedTransport;r.protocol=r.protocol?r.protocol:TBinaryProtocol}function l(e,r){if(e.headers.origin&&i.cors){if(i.cors["*"]||i.cors[e.headers.origin]){r.setHeader("access-control-allow-origin",e.headers.origin);r.setHeader("access-control-allow-methods","GET, POST, OPTIONS");r.setHeader("access-control-allow-headers","content-type, accept");r.setHeader("access-control-max-age","60");return true}else{return false}}return true}function n(e,r){if(l(e,r)){r.writeHead("204","No Content",{"content-length":0})}else{r.writeHead("403","Origin "+e.headers.origin+" not allowed",{})}r.end()}function o(e,t){var r=url.parse(e.url).pathname;var n=s[r];if(!n){t.writeHead("403","No Apache Thrift Service at "+r,{});t.end();return}if(!l(e,t)){t.writeHead("403","Origin "+e.headers.origin+" not allowed",{});t.end();return}e.on("data",n.transport.receiver(function(r){var e=new n.protocol(r);var a=new n.protocol(new n.transport(undefined,function(e){try{t.writeHead(200);t.end(e)}catch(e){t.writeHead(500);t.end()}}));try{n.processor.process(e,a);r.commitPosition()}catch(e){if(e instanceof InputBufferUnderrunError){r.rollbackPosition()}else{t.writeHead(500);t.end()}}}))}function f(e,o){if(!a||""===a){o.writeHead(404);o.end();return}if(!l(e,o)){o.writeHead("403","Origin "+e.headers.origin+" not allowed",{});o.end();return}var r=url.parse(e.url).pathname;var s=path.join(a,r);fs.exists(s,function(e){if(!e){o.writeHead(404);o.end();return}if(fs.statSync(s).isDirectory()){s+="/index.html"}fs.readFile(s,"binary",function(e,r){if(e){o.writeHead(500);o.end(e+"\n");return}var a={};var t=c[path.extname(s)];if(t){a["Content-Type"]=t}for(var n in i.headers){a[n]=i.headers[n]}o.writeHead(200,a);o.write(r,"binary");o.end()})})}function d(e,t,n,o){n.transport.receiver(function(r){var e=new n.protocol(r);var a=new n.protocol(new n.transport(undefined,function(e){try{var r=wsFrame.encode(e,null,o);t.write(r)}catch(e){}}));try{n.processor.process(e,a);r.commitPosition()}catch(e){if(e instanceof InputBufferUnderrunError){r.rollbackPosition()}else{}}})(e)}var p=null;if(i.tls){p=https.createServer(i.tls)}else{p=http.createServer()}p.on("request",function(e,r){if(e.method==="POST"){o(e,r)}else if(e.method==="GET"){f(e,r)}else if(e.method==="OPTIONS"){n(e,r)}else{r.writeHead(500);r.end()}}).on("upgrade",function(e,t,r){var n;try{n=s[Object.keys(s)[0]]}catch(e){t.write("HTTP/1.1 403 No Apache Thrift Service available\r\n\r\n");return}var a=crypto.createHash("sha1");a.update(e.headers["sec-websocket-key"]+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");t.write("HTTP/1.1 101 Switching Protocols\r\n"+"Upgrade: websocket\r\n"+"Connection: Upgrade\r\n"+"Sec-WebSocket-Accept: "+a.digest("base64")+"\r\n"+"Sec-WebSocket-Origin: "+e.headers.origin+"\r\n"+"Sec-WebSocket-Location: ws://"+e.headers.host+e.url+"\r\n"+"\r\n");var o=null;t.on("data",function(e){try{while(e){var r=wsFrame.decode(e);if(o){if(r.data){var a=new Buffer(o.length+r.data.length);o.copy(a);r.data.copy(a,o.length);r.data=a}else{r.data=o}o=null}if(r.FIN){d(r.data,t,n,r.binEncoding)}else{o=r.data}e=r.nextFrame}}catch(e){log.error("TWebSocketTransport Exception: "+e);t.destroy()}})});return p};