var util=require("util");var WebSocket=require("ws");var EventEmitter=require("events").EventEmitter;var thrift=require("./thrift");var ttransport=require("./transport");var tprotocol=require("./protocol");var TBufferedTransport=require("./buffered_transport");var TJSONProtocol=require("./json_protocol");var InputBufferUnderrunError=require("./input_buffer_underrun_error");var createClient=require("./create_client");exports.WSConnection=WSConnection;function WSConnection(t,e,o){EventEmitter.call(this);var i=this;this.options=o||{};this.host=t;this.port=e;this.secure=this.options.secure||false;this.transport=this.options.transport||TBufferedTransport;this.protocol=this.options.protocol||TJSONProtocol;this.path=this.options.path;this.send_pending=[];this.seqId2Service={};this.wsOptions={host:this.host,port:this.port||80,path:this.options.path||"/",headers:this.options.headers||{}};for(var n in this.options.wsOptions){this.wsOptions[n]=this.options.wsOptions[n]}}util.inherits(WSConnection,EventEmitter);WSConnection.prototype.__reset=function(){this.socket=null;this.send_pending=[]};WSConnection.prototype.__onOpen=function(){var e=this;this.emit("open");if(this.send_pending.length>0){this.send_pending.forEach(function(t){e.socket.send(t)});this.send_pending=[]}};WSConnection.prototype.__onClose=function(t){this.emit("close");this.__reset()};WSConnection.prototype.__decodeCallback=function(i){var t=new this.protocol(i);try{while(true){var n=t.readMessageBegin();var e=n.rseqid*-1;var r=this.client;var o=this.seqId2Service[n.rseqid];if(o){r=this.client[o];delete this.seqId2Service[n.rseqid]}r._reqs[e]=function(t,e){i.commitPosition();var o=r._reqs[n.rseqid];delete r._reqs[n.rseqid];if(o){o(t,e)}};if(r["recv_"+n.fname]){r["recv_"+n.fname](t,n.mtype,e)}else{delete r._reqs[e];this.emit("error",new thrift.TApplicationException(thrift.TApplicationExceptionType.WRONG_METHOD_NAME,"Received a response to an unknown RPC function"))}}}catch(t){if(t instanceof InputBufferUnderrunError){i.rollbackPosition()}else{throw t}}};WSConnection.prototype.__onData=function(t){if(Object.prototype.toString.call(t)=="[object ArrayBuffer]"){t=new Uint8Array(t)}var e=new Buffer(t);this.transport.receiver(this.__decodeCallback.bind(this))(e)};WSConnection.prototype.__onMessage=function(t){this.__onData(t.data)};WSConnection.prototype.__onError=function(t){this.emit("error",t);this.socket.close()};WSConnection.prototype.isOpen=function(){return this.socket&&this.socket.readyState==this.socket.OPEN};WSConnection.prototype.open=function(){if(this.socket&&this.socket.readyState!=this.socket.CLOSED){return}this.socket=new WebSocket(this.uri(),"",this.wsOptions);this.socket.binaryType="arraybuffer";this.socket.onopen=this.__onOpen.bind(this);this.socket.onmessage=this.__onMessage.bind(this);this.socket.onerror=this.__onError.bind(this);this.socket.onclose=this.__onClose.bind(this)};WSConnection.prototype.close=function(){this.socket.close()};WSConnection.prototype.uri=function(){var t=this.secure?"wss":"ws";var e="";var o=this.path||"/";var i=this.host;if(this.port&&("wss"==t&&this.port!=443||"ws"==t&&this.port!=80)){e=":"+this.port}return t+"://"+i+e+o};WSConnection.prototype.write=function(t){if(this.isOpen()){this.socket.send(t)}else{this.send_pending.push(t)}};exports.createWSConnection=function(t,e,o){return new WSConnection(t,e,o)};exports.createWSClient=createClient;