const Assert=require("assert");const Log=require("../service/util/logger");const BaseWindow=require("./window");const Util=require("../service/util/util");const Common=require("../service/common");const CommonEvent=require("../service/protocal");const Path=require("path");const Is=require("is");const os=require("os");const{app}=require("electron");const LOG_TAG="[MainWindow]";class MainWindow{constructor(e){this.window=null;this.url=e.addr;this.winName=Common.WIN_MAIN_NAME;this.winID=Common.WIN_MAIN_ID;this.delegate=e.delegate;this.showWindow=false;this.resolve=e.resolve;this.reject=e.reject;this.renderedTime=true;this.lastRunName="constructor";Object.defineProperty(this,"_isDestroyed",{enumerable:true,get(){return!this.window||!this.window.window||this.window.window.isDestroyed()}})}init(){Log.info(LOG_TAG,"[init]");var e=this.createWindow(this.url);Assert(e,"MainWindow createWindow fail");this.window=e;this.window.setDelegate(this);return this}createWindow(e){Assert(typeof e=="string","craeteWindow url param error");var i=Util.deepClone(Common.WIN_OPTION_TEMPLATE);Log.info(LOG_TAG,"[createWindow] main url[%s]",this.url);i.url=e;i.winID=this.winID;i.winName=this.winName;i.icon=Path.join(__dirname,"../../res/tray.png");i.skipTaskbar=false;i.center=true;i.alwaysOnTop=false;i.width=Common.WIN_MAIN_WIDTH_PLAT;i.height=Common.WIN_MAIN_HEIGHT_PLAT;i.closable=true;i.minimizable=true;i.maximizable=false;i.movable=true;i.webPreferences.webSecurity=false;i.webPreferences.allowRunningInsecureContent=true;i.hasShadow=true;i.transparent=false;i.show=true;i.resizable=true;let t=os.platform();Log.info(LOG_TAG,`[createWindow], paltform:${t}`);if(t===Common.SYS_MAC){i.hasShadow=true;i.maximizable=true;i.titleBarStyle="hidden";i.resizable=true;i.fullscreenable=true;i.transparent=false;i.frame=false;i.trafficLightPosition={x:Common.WIN_MAC_SYSBUTTON_X,y:Common.WIN_MAC_SYSBUTTON_Y}}var o=new BaseWindow(i).init();if(global.startWindowTime!=-1){const s=require("../controller/timerecord_controller");this.showTime=Date.now();let e=this.showTime-global.startWindowTime;s.logElapseTime("CreateWindowToShowWindow",e+"ms");global.startWindowTime=-1;Log.info(LOG_TAG,"[createWindow], start app to mainwindow show success, costtime:",this.showTime-global.appStartTime)}if(t===Common.SYS_MAC){o.window.setMinimumSize(Common.WIN_MAIN_WIDTH_PLAT,Common.WIN_MAIN_HEIGHT_PLAT)}Log.info(LOG_TAG,"[createWindow], success");return o}sendEventMsg(e){if(!this._isDestroyed){this.window.sendEventMsg(CommonEvent.IPC_CHANGE_MAIN_WINDOW,e)}}destroy(){if(!this._isDestroyed){Log.info(LOG_TAG,"[destroy] destroy main window");this.window.destroy()}}hide(){if(!this._isDestroyed){Log.info(LOG_TAG,"[hide] hide main window");this.window.hide()}}setSkipTaskbar(e){try{if(Common.isFieldValid(this.window)&&Common.isFieldValid(this.window.window)&&Is.function(this.window.window.setSkipTaskbar)){this.window.window.setSkipTaskbar(e)}}catch(e){Log.warn(LOG_TAG,"setSkipTaskbar failed",e)}}show(){if(this._isDestroyed){return}this.setSkipTaskbar(false);this.window.show()}focus(){if(!this._isDestroyed){this.window.focus()}}isDestroyed(){return this._isDestroyed}winWillCloseEvent(e,i){Assert(e,"winWillCloseEvent window is null");Log.info(LOG_TAG,"[winWillCloseEvent] winName[%s]",e.winName);Assert(this.delegate,"winWillCloseEvent delegate is null");if(os.platform()===Common.SYS_MAC){if(app.dock.isVisible()){Log.info(LOG_TAG,"Dock visibility, Hidden main window");if(e.window.isFullScreen()){Log.info(LOG_TAG,"%s isFullScreen, setFullScreen false",this.winName);e.window.setFullScreen(false);setTimeout(()=>{Log.info(LOG_TAG,"%s isFullScreen, close after 1000ms",this.winName);e.window.close()},1e3);i.preventDefault();return}else{e.hide();i.preventDefault();return}}}Log.info(LOG_TAG,"Close the main window");if(Is.object(this.delegate)&&Is.function(this.delegate.winWillCloseEvent)){this.delegate.winWillCloseEvent(e)}}windowIsValid(){if(!this._isDestroyed&&typeof this.window!="undefined"&&typeof this.window.window!="undefined"){return true}Log.warn(LOG_TAG,"The current window is invalid or destroyed.");return false}winWillNavigate(e,i){if(e.winID===Common.WIN_MAIN_ID){Log.info(LOG_TAG,"[winWillNavigate] main window url[%s]",i);this.url=Common.parseAddr(i)}}winReadytoShow(){if(this.showWindow){return}this.showWindow=true;this.show(0);if(this.resolve){this.resolve("success");this.resolve=null;this.reject=null}if(this.renderedTime){this.renderedTime=false;const i=require("../controller/timerecord_controller");let e=Date.now()-this.showTime;i.logElapseTime("ShowWindowToRendered",e+"ms")}}winWillBlurEvent(){Log.info(LOG_TAG,"mainWindow winWillBlurEvent")}winCrashed(e){Log.info(LOG_TAG,"[winCrashed] [%s] crashed",this.winName);if(Is.object(this.delegate)&&Is.function(this.delegate.winWillCloseEvent)){this.delegate.winWillCloseEvent(e)}if(this.reject){this.reject("win crashed");this.resolve=null;this.reject=null}}reCreateWindow(){Log.info(LOG_TAG,"[reCreateWindow] [%s]",this.winName);setTimeout(()=>{let e=this.window;this.init();this.window.allowedReCreateWnd=false;if(Is.object(this.delegate)&&Is.function(this.delegate.winSwitchHandle)){this.delegate.winSwitchHandle(this.window);e.destroy();e=null}},100)}addTimeFlagToUrl(e){let i="";let t=e.split("?");i=t[0]+"?t="+Date.now();for(let e=1;e<t.length;++e){if(1==e){i+="&"+t[e]}else{i+="?"+t[e]}}return i}loadNewUrl(e){Log.info(LOG_TAG,"[loadNewUrl] url[%s]",e);if(!this.windowIsValid()){Log.error(LOG_TAG,"[loadNewUrl] window has been invalide. mybe detroyed");return}if(typeof this.window.window.webContents!="undefined"&&this.window.window.webContents.isLoading()){this.window.window.webContents.stop()}this.url=this.addTimeFlagToUrl(e);Log.info(LOG_TAG,"[loadNewUrl] main window url[%s]",this.url);Util.loadWebURL(this.window.window,this.url,this.window);this.window.window.setAlwaysOnTop(true);this.window.window.setAlwaysOnTop(false)}}module.exports=MainWindow;