const Assert=require("assert");const Log=require("../service/util/logger");const BaseWindow=require("./window");const Util=require("../service/util/util");const Common=require("../service/common");const Is=require("is");const Path=require("path");const CommonEvent=require("../service/protocal");const os=require("os");const LOG_TAG="[MessageWindow]";const Timeout=1e3;class MessageWindow{constructor(e){this.window=null;this.url=Common.WIN_MESSAGE_URL;this.winName=Common.WIN_MESSAGE_NAME;this.winID=Common.WIN_MESSAGE_ID;this.delegate=e;this.controller=null;this.timer=null;this.messageArray=new Array;this.isReadytoShow=false;this.messageWindowShowData=null;Object.defineProperty(this,"_isDestroyed",{enumerable:true,get(){return!this.window||!this.window.window||this.window.window.isDestroyed()}})}init(){this.window=this.createWindow(Path.join(__dirname,this.url));Assert(this.window,"MessageWindow createWindow fail");this.window.setDelegate(this);return this}setController(e){Assert(e,"MessageWindow SetController invalid param");this.controller=e}createWindow(e){Assert(typeof e=="string","craeteWindow url param error");Log.info(LOG_TAG,"[createWindow] main url[%s], platform[%s]",this.url,os.platform());let s=Util.deepClone(Common.WIN_OPTION_TEMPLATE);s.url=e;s.winID=this.winID;s.winName=this.winName;s.show=false;s.alwaysOnTop=true;s.movable=true;let i=os.platform();s.transparent=true;if(i==Common.SYS_WIN32){s.hasShadow=false;s.frame=false}else if(i==Common.SYS_MAC){s.hasShadow=true;s.frame=true}else if(i==Common.SYS_LINUX){s.hasShadow=true;s.frame=false;s.transparent=false;s.backgroundColor="#FFF"}Log.info(LOG_TAG,"begin createWindow");let t=new BaseWindow(s).init();Log.info(LOG_TAG,"[createWindow], success");return t}destroy(){if(!this._isDestroyed){if(this.timer!=null){Log.info(LOG_TAG,"[destroy] clear timer");clearTimeout(this.timer);this.timer=null}Log.info(LOG_TAG,"[destroy]");this.window.destroy()}}isDestroyed(){return this._isDestroyed}hide(){if(!this._isDestroyed){Log.info(LOG_TAG,"[hide] hide window");this.window.hide()}}isHide(){if(!this._isDestroyed){return this.window.isHide()}return true}destroySelf(){this.destroy();if(Is.object(this.delegate)&&Is.function(this.delegate.winWillCloseEvent)){Log.info(LOG_TAG,"[winWillCloseEvent] delegate.winWillCloseEvent");this.delegate.winWillCloseEvent(this.window)}}sendNotifyMsg(e){if(this.timer){clearTimeout(this.timer);this.timer=null}var s=JSON.parse(e);var i=10;if(s["msgShowTime"]!=undefined){i=s["msgShowTime"]}if(!this._isDestroyed){this.window.sendEventMsg(CommonEvent.IPC_CHANGE_MESSAGE,e)}var t=this;this.timer=setTimeout(()=>{Log.info(LOG_TAG,"NotifyMsg timeout, destroy window");t.destroySelf()},i*Timeout)}winWillCloseEvent(e,s,i){Assert(e,"[winWillCloseEvent] window is null");Log.info(LOG_TAG,"[winWillCloseEvent] winName[%s], isApiCloseMode[%s]",e.winName,i);Assert(this.delegate,"[winWillCloseEvent] delegate is null");if(this.timer){clearTimeout(this.timer);this.timer=null}if(i||i===undefined){if(Is.object(this.delegate)&&Is.function(this.delegate.winWillCloseEvent)){Log.info(LOG_TAG,"[winWillCloseEvent] delegate.winWillCloseEvent");this.delegate.winWillCloseEvent(e)}}else{this.hide()}}winReadytoShow(e){Assert(e,"[winReadytoShow] window is null");this.isReadytoShow=true;var s=setInterval(()=>{Log.info(LOG_TAG,"[winReadytoShow] messageArray.length",this.messageArray.length);if(this.messageArray.length>0){Log.info(LOG_TAG,"[winReadytoShow] send message");this.sendMessage()}else{Log.info(LOG_TAG,"[winReadytoShow] message is null, clear interval");clearInterval(s);s=null}},Timeout)}addMessage(e,s){if(e=="tunnelAccess"){if(!this.dealEvTunnelAccess(s)){return}}this.messageArray.push(s);if(this.isReadytoShow){this.sendMessage()}}sendMessage(){var e=this.messageArray.shift();if(!e)return;this.messageWindowShowData=e;this.sendNotifyMsg(e)}dealEvTunnelAccess(e){var i=false;var t=JSON.parse(e);this.messageArray.some(function(e){var s=JSON.parse(e);if(s["event"]=="tunnelAccess"){if(s["data"]["reason"]==t["data"]["reason"]){i=true;Log.info(LOG_TAG,"[dealTunnelAccess] push message same ArrayMessage");return i}}});if(i){Log.info(LOG_TAG,"[dealTunnelAccess] push message Array has same message");return false}if(this.isHide())return true;Assert(this.messageWindowShowData!=null,"messageWindowShowData is null");Log.info(LOG_TAG,"dealTunnelAccess",this.messageWindowShowData);var s=JSON.parse(this.messageWindowShowData);if(s["event"]=="tunnelAccess"){if(s["data"]["reason"]==t["data"]["reason"]){Log.info(LOG_TAG,"dealTunnelAccess push message same showMessage");return false}Log.info(LOG_TAG,"dealTunnelAccess message.length:",this.messageArray.length)}return true}winCrashed(e){Log.info(LOG_TAG,"[winCrashed] [%s] crashed",this.winName);if(Is.object(this.delegate)&&Is.function(this.delegate.winWillCloseEvent)){this.delegate.winWillCloseEvent(e)}}reCreateWindow(){Log.info(LOG_TAG,"[reCreateWindow] [%s]",this.winName);setTimeout(()=>{let e=this.window;this.init();this.window.allowedReCreateWnd=false;if(Is.object(this.delegate)&&Is.function(this.delegate.winSwitchHandle)){this.delegate.winSwitchHandle(this.window);e.destroy();e=null}},100)}}module.exports=MessageWindow;