const Assert=require("assert");const AppConfig=require("../model/app_config");const Log=require("../service/util/logger");const HistoryAddr=require("../service/history_addr");const Common=require("../service/common");const CommonEvent=require("../service/protocal");const Rpc=require("../service/util/rpc_client");const QtTrayController=require("../controller/qttray_controller");const RPCEventBind=require("../service/util/rpc_event_bind");const ErrorCode=require("../common/errorcode");const checker=require("../service/util/checker");const LOG_TAG="[qttray_view]";class QTTrayView{constructor(){this.trayDelegate=null;this.mTray=null;this.trayTip=null;this.uemIsRunning=false;this.qtTrayController=null;this.rpcEventBind=null}setDelegate(e){Assert(e,"AdapterQTTray setDelegate:delegate is null");this.trayDelegate=e}launchTray(){Log.info(LOG_TAG,"Launch the QT Tray program");if(this.rpcEventBind==null){this.rpcEventBind=new RPCEventBind}this.rpcEventBind.bindEventhandler(this);if(this.qtTrayController==null){this.qtTrayController=new QtTrayController;this.qtTrayController.setDelegate(this.trayDelegate)}this.qtTrayController.launchTray()}setTrayStatus(e){if(e===Common.LOGOUT){this.uemIsRunning=false}this.notifyTrayStatusChange(e)}setTrayVirtualNetStatus(e,t){Log.info(LOG_TAG,`tray recv event topic: ${e}, message: ${t}`);let n=JSON.parse(t).data;Assert(checker.isObject(n),"ocketPath must be a object");if(e===Common.UEM_VIRTUAL_NET_INFO){this.notifyTrayVirtualNetInfo(JSON.stringify(n))}else if(e===Common.UEM_VIRTUAL_NET_CHANGE){this.notifyTrayVirtualNetChanged(JSON.stringify(n))}else if(e===Common.UEM_CONFIG_CHANGE){this.notifyTrayUemConfigChanged(JSON.stringify(n))}else if(e===Common.UEM_FLOAT_BALL_CHANGE){this.notifyTrayUemFloatBallStatusChanged(JSON.stringify(n))}else{Log.warn(LOG_TAG,`tray not handle topic: ${e}`)}}setOnlineTip(){}setTrayToolTipSafe(){}getBounds(){return{x:0,y:0}}getLabelText(){const e=AppConfig.getSdpcAddr();return{workbenchLabel:HistoryAddr.getWorkWriting(e),uemEnterLabel:this.uemIsRunning?HistoryAddr.getUemEnterWriting(e):""}}uemRunning(){this.uemIsRunning=true;this.notifyTrayCopywriterChange()}destroy(){if(this.qtTrayController!=null){Log.info(LOG_TAG,"Kill the Qt tray process");this.qtTrayController.killProcess();this.qtTrayController=null}}notifyTrayStatusChange(e){let t={status:e};this.sendDataToQtTray(CommonEvent.STATUS_CHANGED,JSON.stringify(t))}dealSetterChanged(t){try{const e=JSON.parse(t);if(e.data.key===Common.COPYWRITING_KEY){this.notifyTrayCopywriterChange()}}catch(e){Log.warn(LOG_TAG,"[dealSetterChanged] error message:%s",t)}}notifyTrayCopywriterChange(){let e=this.getLabelText();this.sendDataToQtTray(CommonEvent.TEXT_CHANGED,JSON.stringify(e))}notifyTrayVirtualNetInfo(e){this.sendDataToQtTray(CommonEvent.VIRTUAL_NET_INFO,e)}notifyTrayVirtualNetChanged(e){this.sendDataToQtTray(CommonEvent.VIRTUAL_NET_CHANGE,e)}notifyTrayUemConfigChanged(e){this.sendDataToQtTray(CommonEvent.UEM_CONFIG_CHANGE,e)}notifyTrayUemFloatBallStatusChanged(e){this.sendDataToQtTray(CommonEvent.UEM_FLOAT_BALL_CHANGE,e)}sendDataToQtTray(t,n){const e=new Rpc.RpcClient(Rpc.SdpQtTrayService);Log.info(LOG_TAG,"Synchronizes workbench information(event:%s data:%s) to QTTray",t,n);new Promise(e=>{Assert(Common.isFieldValid(t)&&Common.isFieldValid(n),"Parameter verification required to synchronize workbench information to QTTray failed");e()}).then(()=>{e.destroy();return e.startPromise()}).then(e=>{return e.syncWorkSpaceToQtTrayPromise(t,n)}).then(()=>{Log.info(LOG_TAG,"Synchronizing workbench information to the QTTray succeeds")}).catch(e=>{Log.error(LOG_TAG,"Failed to synchronize workbench information to the QTTray",e)}).finally(()=>{e.destroy();Log.info(LOG_TAG,"Synchronizing workbench information to the QTTray operation is complete")})}respondStatusAcqurie(){Log.info(LOG_TAG,"The QT tray initial state fetch event was received");let e=AppConfig.getLoginStatus();let t=this.getLabelText();let n={status:e,workbenchLabel:t.workbenchLabel,uemEnterLabel:t.uemEnterLabel};return{code:0,message:"success",data:JSON.stringify(n)}}respondMenuClick(e){Log.info(LOG_TAG,"Received QT tray menu click event with event content %s",e);let t=JSON.parse(e);let n={code:0,message:"success",data:""};if(t.menuEvent===""||t.menuData.moduleName===""||!checker.isString(t.menuEvent)||!checker.isString(t.menuData.moduleName)){n.code=ErrorCode.ERROR_QTTRAYCODE_PARAM_INVALID;n.message="The parameters are incorrect. The menuEvent and moduleName fields cannot be empty";return n}if(t.menuEvent==="virtualNet"){const{moduleData:a}=t.menuData;if(checker.isString(a)&&""!==a){const o=JSON.parse(a);this.trayDelegate.handleTrayEvent(t.menuData.moduleName,o)}else{this.trayDelegate.handleTrayEvent(t.menuData.moduleName,null)}return n}if(t.menuData.moduleName===CommonEvent.OPEN_WORKSPACE){this.trayDelegate.showLoginPagePreCheck("",true,false);return n}let r={event:"",data:{moduleName:"",windowName:""}};if(t.menuData.moduleName===CommonEvent.CLIENT_EXIT){r.event=CommonEvent.CLIENT_EXIT}else if(t.menuData.moduleName===CommonEvent.CLIENT_LOGOUT){r.event=CommonEvent.CLIENT_LOGOUT}else{r.event=t.menuEvent;r.data.moduleName=t.menuData.moduleName;r.data.windowName=t.menuData.windowName}this.trayDelegate.sendEventMsgTray(r,false);return n}dealRouterChanged(e){Log.info(LOG_TAG,`dealRouterChanged: ${JSON.stringify(e)}`);this.trayDelegate.dealRouterChanged(e);return{code:0,message:"success",data:""}}respondTrayClick(){Log.info(LOG_TAG,"Receive a left-click or double-click event for the QT tray");this.trayDelegate.showLoginPagePreCheck("",true,false);return{code:0,message:"success",data:""}}}module.exports=QTTrayView;