const Tray=require("electron").Tray;const Log=require(".././service/util/logger");const EventEmitter=require(".././service/util/event_emitter");const Protocal=require(".././service/protocal");const Common=require(".././service/common");const Path=require("path");const Assert=require("assert");const Is=require("is");const os=require("os");const AppConfig=require(".././model/app_config");const util=require("util");const Language=require("../service/language");const FlowMonitor=require("../service/flow_monitor");const App=require("electron").app;const screen=require("electron").screen;const LOG_TAG="[tray_view]";const Util=require(".././service/util/util");const DBCLICK_TIME_INTERVAL=200;const SHOW_NAME_MAX_LENGTH=10;const RETRY_NEW_TRAY_TIME=1e3;const RETRY_NEW_TRAY_TIMES=2;const TRAY_ONLINE_ICO=Path.join(__dirname,"../../res/online.png");const TRAY_OFFLINE_ICO=Path.join(__dirname,"../../res/offline.png");const TRAY_DISCON_ICO=Path.join(__dirname,"../../res/disconnect.png");const TRAY_NOTICE_ICO=Path.join(__dirname,"../../res/onlineNotice.png");class TrayView{constructor(){this.mTray=null;this.trayTip=new Array;this.mOnlineTip="";this.delegate=null;this.mTrayDoubleClickTime=0;this.mTrayClickTime=0;this.trayMenu=null;this.isSetOfflineMenu=false;this.isSetOnlineMenu=false;this.isSetUemMenu=false;this.trayPosition=null;this.isShowPanel=false;this.trayIcon=null;this.trayStauts=Common.OFFLINE;this.approvalNum=0;this.role=0;this.init(RETRY_NEW_TRAY_TIMES)}init(t){try{this.mTray=new Tray(TRAY_OFFLINE_ICO);Log.info(LOG_TAG,"[init] new Tray success")}catch(e){if(t===0){Log.warn(LOG_TAG,`[init] new tray failed, reason:${e.toString()}`);return}Log.warn(LOG_TAG,`[init] new tray failed, will try again after ${RETRY_NEW_TRAY_TIME}ms, reason:${e.toString()}`);setTimeout(()=>{this.init(t-1)},RETRY_NEW_TRAY_TIME);return}this.trayTip[0]=Language.Config.get(Language.Lib.LOGOUT);this.setTrayToolTipSafe(this.trayTip[0]);this.initEvent();this.initApprovalNum()}sendEventMsg(e){Log.info(LOG_TAG,"Linux Tray sendEventMsg event message: %s",e.event);this.delegate.sendEventMsgTray(e,false)}setOnlineTip(e){Assert(typeof e==="string","setOnlineTip can not be null");if(this.mOnlineTip!==e){Log.info(LOG_TAG,"onlineTip:",e)}this.mOnlineTip=e;if(this.mOnlineTip!==""){this.setTrayToolTipSafe(this.mOnlineTip);this.setTrayImageSafe(TRAY_DISCON_ICO)}else{this.setTrayToolTipSafe(this.trayTip.join(os.EOL));this.setTrayOnlineIco()}}setDelegate(e){Assert(e,"TrayView setDelegate:delegate is null");this.delegate=e}getCurrentBounds(e){var t=screen.getCursorScreenPoint();this.trayPosition=e;this.trayPosition.x=t.x;this.trayPosition.y=t.y}initEvent(){EventEmitter.on(Protocal.EVENT_TRAY_APP_EXIT,()=>{Log.info(LOG_TAG,"tray click to exit app");this.setTrayStatus(Common.TRAY_STATUS_EXIT);EventEmitter.emit(Protocal.EVENT_MAIN_APP_EXIT)});this.mTray.on("double-click",(e,t)=>{this.getCurrentBounds(t);this.mTrayDoubleClickTime=(new Date).getTime();Log.info(LOG_TAG,"tray double click time:",this.mTrayDoubleClickTime);if(Is.object(this.delegate)&&Is.function(this.delegate.showLoginPagePreCheck)){if(os.platform()==="darwin"&&!App.dock.isVisible()){App.dock.show()}if(os.platform()===Common.SYS_WIN32&&(this.trayStauts==Common.ONLINE||this.trayStauts==Common.DISCONNECT||this.trayStauts==Common.LOGIN)){Log.info(LOG_TAG,"double click open desktop");const i=require("../controller/uem_controller");i.openDesktop()}else{this.delegate.showLoginPagePreCheck("",false,true)}}});this.mTray.on("click",(e,t)=>{Log.info(LOG_TAG,"tray click");this.getCurrentBounds(t);var i=(new Date).getTime();this.mTrayClickTime=(new Date).getTime();setTimeout(()=>{if(this.mTrayDoubleClickTime-i>0&&this.mTrayDoubleClickTime-i<=DBCLICK_TIME_INTERVAL){Log.info(LOG_TAG,"doubleclick ingore click");return}if(os.platform()===Common.SYS_WIN32&&(this.trayStauts==Common.ONLINE||this.trayStauts==Common.DISCONNECT||this.trayStauts==Common.LOGIN)){Log.info(LOG_TAG,"single click open desktop");const e=require("../controller/uem_controller");e.openDesktop()}else{if(Is.object(this.delegate)&&Is.function(this.delegate.showLoginPagePreCheck)){if(os.platform()==="darwin"&&!App.dock.isVisible()){App.dock.show()}this.delegate.showLoginPagePreCheck("",true,false)}else{Log.warn(LOG_TAG,"Can not show panel.","Reason","delegate or onShowPanelWindows() is null.",JSON.stringify(this.delegate))}}},DBCLICK_TIME_INTERVAL)});this.mTray.on("right-click",(e,t)=>{this.getCurrentBounds(t);Log.info(LOG_TAG,"tray right-click");this.mTrayClickTime=(new Date).getTime;if(Is.object(this.delegate)&&Is.function(this.delegate.onShowPanelWindow)&&Is.function(this.delegate.setShouldShowPanel)){this.delegate.setShouldShowPanel(true);this.delegate.onShowPanelWindow()}});this.mTray.on("error",e=>{Log.warn(LOG_TAG,`catch error, reason:${e.toString()}`)})}destroy(){Log.info(LOG_TAG,"destroy");if(this.mTray!=null&&!this.mTray.isDestroyed()){this.mTray.destroy();this.mTray=null}}setTrayToolTipSafe(e){if(!this.mTray)return;try{this.mTray.setToolTip(e)}catch(e){Log.warn(LOG_TAG,"[setTrayToolTipSafe]",e)}}setTrayImageSafe(t,i){if(AppConfig.getExitFlag()){return}if(this.trayIcon!=null&&this.trayIcon==t){return}const e=2;if(typeof i==="undefined")i=e;if(i===0)return;try{this.mTray.setImage(t);this.trayIcon=t;Log.info(LOG_TAG,`[setTrayImageSafe] set image:${t} success`)}catch(e){Log.warn(LOG_TAG,"[setTrayImageSafe]",e);this.setTrayImageSafe(t,i-1)}}setTrayStatus(e){Log.info(LOG_TAG,"setTrayStatus, status:",e);this.trayStauts=e;let t=AppConfig.gitTipShowName();if(t.length>SHOW_NAME_MAX_LENGTH){const i="...";t=t.substring(0,SHOW_NAME_MAX_LENGTH)+i}if(!this.trayTip[1]){this.trayTip[1]=util.format("%s: [%s]0B/s [%s]0B/s",Language.Config.get(Language.Lib.TUNNELFLOW_TITLE),Language.Config.get(Language.Lib.TUNNELFLOW_UP),Language.Config.get(Language.Lib.TUNNELFLOW_DOWN))}switch(e){case Common.OFFLINE:{FlowMonitor.tunnel.clean();this.trayTip[0]=t+`(${Language.Config.get(Language.Lib.OFFLINE)})`;this.setTrayToolTipSafe(this.trayTip[0]);this.setTrayImageSafe(TRAY_OFFLINE_ICO);break}case Common.ONLINE:{if(this.mOnlineTip!==undefined&&this.mOnlineTip!==""){this.setTrayToolTipSafe(this.mOnlineTip);this.setTrayImageSafe(TRAY_DISCON_ICO)}else{this.trayTip[0]=t+`(${Language.Config.get(Language.Lib.ONLINE)})`;this.setTrayToolTipSafe(this.trayTip.join(os.EOL));this.setTrayOnlineIco()}break}case Common.DISCONNECT:{this.trayTip[0]=t+`(${Language.Config.get(Language.Lib.RECONNECTING)})`;this.setTrayToolTipSafe(this.trayTip[0]);this.setTrayImageSafe(TRAY_DISCON_ICO);break}case Common.CONNECT:{this.trayTip[0]=t+`(${Language.Config.get(Language.Lib.ONLINE)})`;this.setTrayToolTipSafe(this.trayTip.join(os.EOL));this.setTrayOnlineIco();break}case Common.LOGOUT:{FlowMonitor.tunnel.clean();this.trayTip[0]=`(${Language.Config.get(Language.Lib.LOGOUT)})`;this.setTrayToolTipSafe(this.trayTip[0]);this.setTrayImageSafe(TRAY_OFFLINE_ICO);this.approvalNum=0;this.role=0;break}case Common.NETWORK_UNAVAIABLE:{this.trayTip[0]=t+`(${Language.Config.get(Language.Lib.DISCONNECTED)})`;this.setTrayToolTipSafe(this.trayTip[0]);this.setTrayImageSafe(TRAY_OFFLINE_ICO);break}case Common.TRAY_STATUS_EXIT:{break}default:{Log.info(LOG_TAG,"setTrayStatus error");break}}}startTrayConnectingIco(){Assert(this.mTray,"this.mTray is null");if(!this.mTrayConnectingInterval){Log.info(LOG_TAG,"startTrayConnectingIco");var e=0;this.mTrayConnectingInterval=setInterval(()=>{switch(e%2){case 0:this.setTrayOnlineIco();break;case 1:this.setTrayImageSafe(TRAY_OFFLINE_ICO);break}e++},500)}}stopTrayConnectingIco(){Assert(this.mTray,"this.mTray is null");if(this.mTrayConnectingInterval){Log.info(LOG_TAG,"stopTrayConnectingIco");clearInterval(this.mTrayConnectingInterval);this.mTrayConnectingInterval=null}}getBounds(){if(os.platform()===Common.SYS_WIN32&&this.trayPosition!=null){return this.trayPosition}return this.mTray.getBounds()}refreshTrayOnlineStatus(){if(this.trayStauts===Common.ONLINE){if(this.mOnlineTip!==undefined&&this.mOnlineTip!==""){}else{this.setTrayOnlineIco()}}else if(this.trayStauts===Common.CONNECT){this.setTrayOnlineIco()}}isNoticeStatus(){return this.role&2&&this.approvalNum!==0}setTrayOnlineIco(){if(this.isNoticeStatus()){this.setTrayImageSafe(TRAY_NOTICE_ICO)}else{this.setTrayImageSafe(TRAY_ONLINE_ICO)}}updateApprovalNum(e){try{e=JSON.parse(e);this.approvalNum=e.data.total;this.refreshTrayOnlineStatus()}catch(e){Log.warn(LOG_TAG,"[updateApprovalNum]",e)}}updateApprovalRole(e){try{e=JSON.parse(e);this.role=e.data.role;this.refreshTrayOnlineStatus()}catch(e){Log.warn(LOG_TAG,"[updateApprovalRole]",e)}}initApprovalNum(){var e=AppConfig.initRequestData("");Util.requestAgent("/v1/aUem/queryApprovalInfo",e,e=>{try{if(e.code!==0){Log.warn(LOG_TAG,"initApprovalNum failed.");return}Log.info(LOG_TAG,"initApprovalNum success.");this.approvalNum=e.data.approvalNum;this.role=e.data.role;this.refreshTrayOnlineStatus()}catch(e){Log.warn(LOG_TAG,"[initApprovalNum]",e)}})}}module.exports=TrayView;