const Assert=require("assert");const Log=require("../service/util/logger");const BaseWindow=require("./window");const Util=require("../service/util/util");const Common=require("../service/common");const Is=require("is");const Path=require("path");const CommonEvent=require("../service/protocal");const os=require("os");const LOG_TAG="[VirtualNetMessageWindow]";const Timeout=1e3;class VirtualNetMessageWindow{constructor(e){this.window=null;this.url=Common.WIN_VIRTUALNET_MESSAGE_URL;this.winName=Common.WIN_VIRTUALNET_MESSAGE_NAME;this.winID=Common.WIN_VIRTUALNET_MESSAGE_ID;this.delegate=e;this.controller=null;this.timer=null;this.messageArray=new Array;this.isReadytoShow=false;this.messageWindowShowData=null;Object.defineProperty(this,"_isDestroyed",{enumerable:true,get(){return!this.window||!this.window.window||this.window.window.isDestroyed()}})}init(){this.window=this.createWindow(Path.join(__dirname,this.url));Assert(this.window,"VirtualNetMessageWindow createWindow fail");this.window.setDelegate(this);return this}setController(e){Assert(e,"VirtualNetMessageWindow SetController invalid param");this.controller=e}createWindow(e){Assert(typeof e=="string","craeteWindow url param error");Log.info(LOG_TAG,"[createWindow] main url[%s], platform[%s]",this.url,os.platform());var i=Util.deepClone(Common.WIN_OPTION_TEMPLATE);i.url=e;i.winID=this.winID;i.winName=this.winName;i.show=false;i.alwaysOnTop=true;i.movable=true;var t=os.platform();i.transparent=true;if(t==Common.SYS_WIN32){i.hasShadow=false;i.frame=false}else if(t==Common.SYS_MAC){i.hasShadow=true;i.frame=true}else if(t==Common.SYS_LINUX){i.hasShadow=true;i.frame=false;i.transparent=false;i.backgroundColor="#FFF"}Log.info(LOG_TAG,"begin createWindow");var s=new BaseWindow(i).init();Log.info(LOG_TAG,"[createWindow], success");return s}destroy(){if(!this._isDestroyed){if(this.timer!=null){Log.info(LOG_TAG,"[destroy] clear timer");clearTimeout(this.timer);this.timer=null}Log.info(LOG_TAG,"[destroy]");this.window.destroy()}}isDestroyed(){return this._isDestroyed}hide(){if(!this._isDestroyed){this.window.hide()}}isHide(){if(!this._isDestroyed){return this.window.isHide()}return true}sendNotifyMsg(e){if(this.timer){clearTimeout(this.timer);this.timer=null}var i=5;if(!this._isDestroyed){this.window.sendEventMsg(CommonEvent.IPC_CHANNEL_UEM_MESSAGE,e)}var t=this;this.timer=setTimeout(()=>{Log.info(LOG_TAG,"Virtual net message timeout");t.hide()},i*Timeout)}winWillCloseEvent(e,i,t){Assert(e,"winWillCloseEvent window is null");Log.info(LOG_TAG,"winWillCloseEvent winName:",e.winName);Assert(this.delegate,"winWillCloseEvent delegate is null");if(this.timer){Log.info(LOG_TAG,"clear timer");clearTimeout(this.timer);this.timer=null}if(t){if(Is.object(this.delegate)&&Is.function(this.delegate.winWillCloseEvent)){this.delegate.winWillCloseEvent(e)}}else{this.hide()}}winReadytoShow(e){Assert(e,"winReadytoShow window is null");this.isReadytoShow=true;var i=setInterval(()=>{Log.info(LOG_TAG,"notifyMsgManager messageArray.length",this.messageArray.length);if(this.messageArray.length>0){this.sendMessage()}else{clearInterval(i);i=null}},Timeout)}addMessage(e,i){this.messageArray.push(i);if(this.isReadytoShow){this.sendMessage()}}sendMessage(){var e=this.messageArray.shift();if(!e)return;this.messageWindowShowData=e;this.sendNotifyMsg(e)}winCrashed(e){Log.info(LOG_TAG,"[winCrashed] [%s] crashed",this.winName);if(Is.object(this.delegate)&&Is.function(this.delegate.winWillCloseEvent)){this.delegate.winWillCloseEvent(e)}}reCreateWindow(){Log.info(LOG_TAG,"[reCreateWindow] [%s]",this.winName);setTimeout(()=>{let e=this.window;this.init();this.window.allowedReCreateWnd=false;if(Is.object(this.delegate)&&Is.function(this.delegate.winSwitchHandle)){this.delegate.winSwitchHandle(this.window);e.destroy();e=null}},100)}}module.exports=VirtualNetMessageWindow;