require("./enhance");const{BrowserWindow,dialog}=require("electron");const Assert=require("assert");const Log=require("../service/util/logger");const Is=require("is");const os=require("os");const Util=require("../service/util/util");const Common=require("../service/common");const electron=require("electron");const fs=require("fs");const is=require("is");const Language=require("../service/language");const LOG_TAG="[BaseWindow]";const ABORTED_CONNECTS=-3;class BaseWindow{constructor(e){Assert(e,"BaseWindow constructor option null");if(e.winName!=Common.WIN_MAIN_NAME&&e.winName!=Common.WIN_APPROVAL_WINDOW_NAME&&e.winName!=Common.WIN_FILE_SHARE_LIST_WINDOW_NAME&&e.winName!=Common.WIN_INITIATE_FILE_SHARE_WINDOW_NAME){e.x=Common.WIN_INIT_X;e.y=Common.WIN_INIT_Y}if(e.winName==="MainWindow"){e.webPreferences.backgroundThrottling=false}e.webPreferences.additionalArguments=[`--curWindowName=${e.winName}`];if(os.platform()===Common.SYS_LINUX&&Common.getOsName()===Common.OS_KYLIN_V10&&!fs.existsSync(Common.PROXY_FLAG_FILE)){e.webPreferences.session=electron.session.defaultSession}this.window=new BrowserWindow(e);this.window=BrowserWindow.enhance(this.window);this.url=e.url;this.winName=e.winName;this.winID=e.winID;this.delegate=null;this.loadTimer=null;this.mainWindowFirstShow=true;this.responsible=true;this.inCreateStage=true;this.allowedReloadUrl=true;this.allowedReCreateWnd=true;this.allowedShowMsgBox=true;this.resetFocus=true;this.openDevFlagFile=Common.WINDOW_DEVTOOLS_FLAG_FILE+this.winName;this.openDevTimer=null;BaseWindow.enhance(this);Object.defineProperty(this,"_isDestroyed",{enumerable:true,get(){return!this.window||this.window.isDestroyed()}})}init(){this.initEvent();this.loadWebURL(this.url);this.openDevToolsBase();return this}setDelegate(e){this.delegate=e}loadWebURL(e){Assert(e.length>0,"LoadWebURL invalid url param");Log.info(LOG_TAG,"[loadWebURL] winName[%s], winID[%s], url[%s]",this.winName,this.winID,e);Util.loadWebURL(this.window,e,this)}initEvent(){this.window.on("ready-to-show",()=>{Log.info(LOG_TAG,"%s ready-to-show",this.winName);try{if(Is.object(this.delegate)&&Is.function(this.delegate.winReadytoShow)){this.delegate.winReadytoShow(this)}}catch(e){Log.error(LOG_TAG,'Abnormal occurrence when handling window event "ready-to-show"',e)}});this.window.on("close",e=>{try{Log.info(LOG_TAG,"%s close",this.winName);if(this.winName=="FloatTrayWindow"){e.preventDefault();return}if(this.winName===Common.WIN_MAIN_NAME&&os.platform()!=Common.SYS_MAC){e.preventDefault();setTimeout(()=>{this.window.hide();this.window.setSkipTaskbar(true)},50);return}if(Is.object(this.delegate)&&Is.function(this.delegate.winWillCloseEvent)){this.delegate.winWillCloseEvent(this,e,this.delegate.isApiCloseMode);this.isApiCloseMode=false}}catch(e){Log.error(LOG_TAG,'Abnormal occurrence when handling window event "close"',e)}});this.window.on("closed",()=>{Log.info(LOG_TAG,"%s closed",this.winName)});this.window.on("hide",e=>{try{Log.info(LOG_TAG,"%s hide",this.winName);if(Is.object(this.delegate)&&Is.function(this.delegate.winWillHideEvent)){this.delegate.winWillHideEvent(this,e)}}catch(e){Log.error(LOG_TAG,'Abnormal occurrence when handling window event "hide"',e)}});this.window.on("show",()=>{try{Log.info(LOG_TAG,"%s show",this.winName);this.inCreateStage=false;if(Is.object(this.delegate)&&Is.function(this.delegate.winWillShowEvent)){this.delegate.winWillShowEvent()}}catch(e){Log.error(LOG_TAG,'Abnormal occurrence when handling window event "show"',e)}});this.window.on("restore",e=>{try{Log.info(LOG_TAG,"%s restore",this.winName);if(Is.object(this.delegate)&&Is.function(this.delegate.winWillRestoreEvent)){this.delegate.winWillRestoreEvent(this,e)}}catch(e){Log.error(LOG_TAG,'Abnormal occurrence when handling window event "restore"',e)}});this.window.on("minimize",e=>{try{Log.info(LOG_TAG,"%s minimize",this.winName);if(Is.object(this.delegate)&&Is.function(this.delegate.winWillMinmizeEvent)){this.delegate.winWillMinmizeEvent(this,e)}}catch(e){Log.error(LOG_TAG,'Abnormal occurrence when handling window event "minimize"',e)}});this.window.on("maximize",()=>{try{Log.info(LOG_TAG,"%s maximize",this.winName);if(Is.object(this.delegate)&&Is.function(this.delegate.onSize)){this.delegate.onSize()}}catch(e){Log.error(LOG_TAG,'Abnormal occurrence when handling window event "maximize"',e)}});this.window.on("focus",()=>{try{this.window.moveTop()}catch(e){Log.error(LOG_TAG,'Abnormal occurrence when handling window event "focus"',e)}});this.window.on("blur",e=>{try{if(Is.object(this.delegate)&&Is.function(this.delegate.winWillBlurEvent)){this.delegate.winWillBlurEvent(this,e)}}catch(e){Log.error(LOG_TAG,'Abnormal occurrence when handling window event "blur"',e)}});this.window.webContents.on("crashed",async(i,n)=>{try{Log.info(LOG_TAG,`${this.winName} Renderer crashed, kill:${n}`);if(n){this.onWinCrashed();Log.info(LOG_TAG,"The window process is terminated externally");return}if(this.allowedReloadUrl){this.allowedReloadUrl=false;Log.info(LOG_TAG,"The window(%s) crashed, allowed reload the window",this.winName);this.reload();return}await this.showWindowMsgBox()}catch(e){this.onWinCrashed(i,n);Log.error(LOG_TAG,'Abnormal occurrence when handling window event "crashed"',e)}});this.window.webContents.on("render-process-gone",async(i,e)=>{try{Log.info(LOG_TAG,`${this.winName} Renderer render-process-gone, details:${JSON.stringify(e)}`)}catch(e){if(Is.object(this.delegate)&&Is.function(this.delegate.winCrashed)){this.delegate.winCrashed(this,i,false)}Log.error(LOG_TAG,'Abnormal occurrence when handling window event "render-process-gone"',e)}});this.window.on("will-resize",(e,i)=>{try{if(os.platform()===Common.SYS_MAC){if(i.width!=Common.WIN_MAIN_WIDTH_PLAT||i.height!=Common.WIN_MAIN_HEIGHT_PLAT){e.preventDefault()}}}catch(e){Log.error(LOG_TAG,'Abnormal occurrence when handling window event "will-resize"',e)}});this.window.webContents.on("did-fail-load",(e,i,n)=>{Log.info(LOG_TAG,"winName[%s] load url[%s] fail, errorcode[%s], errorDescription[%s]",this.winName,this.url,i,n);if(i===ABORTED_CONNECTS){return}if(Is.object(this.delegate)&&Is.function(this.delegate.handleWebLoadFailed)){this.delegate.handleWebLoadFailed(this,e)}});this.window.webContents.on("did-start-loading",()=>{Log.info(LOG_TAG,"%s start loading",this.winName)});this.window.webContents.on("did-finish-load",()=>{try{if(this.winID===Common.WIN_MAIN_ID&&this.resetFocus){this.window.blurWebView();this.window.focusOnWebView();this.resetFocus=false}if(Is.object(this.delegate)&&Is.function(this.delegate.winDidLoadFinish)){this.delegate.winDidLoadFinish(this)}if(Is.object(this.delegate)&&Is.function(this.delegate.winReadytoShow)&&os.platform()===Common.SYS_LINUX){this.delegate.winReadytoShow(this)}}catch(e){Log.error(LOG_TAG,'Abnormal occurrence when handling window event "ready-to-show"',e)}Log.info(LOG_TAG,"%s load finish",this.winName)});this.window.webContents.on("did-stop-loading",()=>{Log.info(LOG_TAG,this.winName,"stop loading")});this.window.webContents.on("will-navigate",(e,i)=>{try{Log.info(LOG_TAG,this.winName,"will navigate:",i);if(Is.object(this.delegate)&&Is.function(this.delegate.winWillNavigate)){this.delegate.winWillNavigate(this,i)}}catch(e){Log.error(LOG_TAG,'Abnormal occurrence when handling window event "will-navigate"',e)}});this.window.webContents.on("did-navigate-in-page",(e,i,n,o,t)=>{Log.info(LOG_TAG,this.winName,"did-navigate-in-page, url: ",i,"isMainFrame:",n,"frameProcessId:",o,"frameRoutingId:",t)});this.window.webContents.on("unresponsive",async()=>{try{Log.info(LOG_TAG,"window:%s unresponsive will Close",this.winName);if(this.allowedReloadUrl){this.allowedReloadUrl=false;Log.info(LOG_TAG,"The window(%s) unresponsive, allowed reload the window",this.winName);this.reload();return}if(!this.isShowMessageBox()){Log.info(LOG_TAG,"The window(%s) unresponsive, will destroy window",this.winName);this.onWinCrashed();return}this.responsible=false;if(this.allowedShowMsgBox===false){return}this.allowedShowMsgBox=false;let e=await dialog.showMessageBox(this.window,{type:"warning",title:Language.Config.get(Language.Lib.PAGE_UNRESPONSIVE_TITLE),message:Language.Config.get(Language.Lib.PAGE_UNRESPONSIVE_MSG),buttons:[Language.Config.get(Language.Lib.PAGET_UNRESPONSIVE_BTN_WAITING),Language.Config.get(Language.Lib.PAGET_UNRESPONSIVE_BTN_RELOAD)]});this.allowedShowMsgBox=true;switch(e.response){case 1:Log.info(LOG_TAG,"The window(%s) unresponsive, the user's choice to reload the process",this.winName);if(!this.responsible){this.reload();this.allowedReloadUrl=true}else{Log.info(LOG_TAG,"The window(%s) response has been restored and no reloading",this.winName)}this.responsible=true;break;case 0:Log.info(LOG_TAG,"The window(%s) unresponsive, and the user chooses to wait ",this.winName);default:Log.info(LOG_TAG,"The window(%s) unresponsive, keep waiting ",this.winName);break}}catch(e){Log.error(LOG_TAG,`Abnormal occurrence when handling window(${this.winName}) event "unresponsive"`,e)}});this.window.webContents.on("responsive",()=>{this.responsible=true;this.allowedReloadUrl=true;Log.info(LOG_TAG,"Window(%s) recover from unresponsive",this.winName)});this.window.webContents.on("destroyed",()=>{try{Log.info(LOG_TAG,"%s destroy",this.winName);if(this.winID===Common.WIN_UPDATE_ID&&Is.function(this.delegate.destroy)){this.delegate.destroy()}}catch(e){Log.error(LOG_TAG,'Abnormal occurrence when handling window event "destroyed"',e)}});this.window.webContents.on("cursor-changed",()=>{Log.info(LOG_TAG,"%s cursor changed",this.winName)});this.window.webContents.on("context-menu",()=>{Log.info(LOG_TAG,"%s menu",this.winName)});this.window.webContents.on("before-input-event",(e,i)=>{try{if(os.platform()===Common.SYS_WIN32){if(i.control===true&&i.shift===true&&i.key==="I"){this.window.webContents.setIgnoreMenuShortcuts(i.control&&i.shift)}}else if(os.platform()===Common.SYS_MAC){if(i.alt===true&&i.meta===true&&i.code==="KeyI"){this.window.webContents.setIgnoreMenuShortcuts(i.alt&&i.meta)}}}catch(e){Log.error(LOG_TAG,'Abnormal occurrence when handling window event "before-input-event"',e)}});this.window.webContents.session.webRequest.onHeadersReceived({urls:["*://*/*"]},(e,i)=>{if(e.responseHeaders["X-Frame-Options"]){delete e.responseHeaders["X-Frame-Options"]}else if(e.responseHeaders["x-frame-options"]){delete e.responseHeaders["x-frame-options"]}i({cancel:false,responseHeaders:e.responseHeaders})})}async showWindowMsgBox(){if(this.allowedReCreateWnd){Log.info(LOG_TAG,"The window(%s) crashed, allow recreate window",this.winName);this.onReCreateWindow();return}if(this.winID!=Common.WIN_MAIN_ID){Log.info(LOG_TAG,"The window(%s) crashed, will destroy window",this.winName);this.onWinCrashed();return}if(!this.isShowMessageBox()){Log.info(LOG_TAG,"The window(%s) crashed, not inCreateState and isVisible, will destroy window",this.winName);this.onWinCrashed();return}if(this.allowedShowMsgBox===false){return}this.allowedShowMsgBox=false;let e=await dialog.showMessageBox(this.window,{type:"warning",title:Language.Config.get(Language.Lib.PAGE_CRASHED_TITLE),message:Language.Config.get(Language.Lib.PAGE_CRASHED_MSG),buttons:[Language.Config.get(Language.Lib.PAGET_CRASHED_BTN_CLOSE),Language.Config.get(Language.Lib.PAGET_CRASHED_BTN_RELOAD)]});this.allowedShowMsgBox=true;switch(e.response){case 0:Log.info(LOG_TAG,"The window(%s) crashed, the user's choice to close the window",this.winName);this.onWinCrashed();break;case 1:Log.info(LOG_TAG,"The window(%s) crashed, the user's choice to reload the window",this.winName);default:Log.info(LOG_TAG,"The window(%s) crashed, will reload the window",this.winName);this.reload();this.allowedReloadUrl=true;break}}onReCreateWindow(){try{if(Is.object(this.delegate)&&Is.function(this.delegate.reCreateWindow)){this.delegate.reCreateWindow()}}catch(e){Log.error(LOG_TAG,"Abnormal occurrence when recreate window",e)}}onWinCrashed(e,i){try{if(Is.object(this.delegate)&&Is.function(this.delegate.winCrashed)){this.delegate.winCrashed(this,e,i)}}catch(e){Log.error(LOG_TAG,'Abnormal occurrence when handling window event "crashed"',e)}}isShowMessageBox(){if(this.inCreateStage){Log.info(LOG_TAG,"The window(%s) inCreateState, will showMessageBox",this.winName);return true}if(this.window.isMinimized()){Log.info(LOG_TAG,"The window(%s) isMinimized, will not showMessageBox",this.winName);return false}if(this.window.isVisible()){Log.info(LOG_TAG,"The window(%s) isVisible, will showMessageBox",this.winName);return true}Log.info(LOG_TAG,"The window(%s) will not showMessageBox",this.winName);return false}reszie(e,i){Log.info(LOG_TAG,"winName[%s] resize width:%d height:%d",this.winName,e,i);Assert(typeof e=="number"&&e>0,"resizeWindow width param error");Assert(typeof i=="number"&&i>0,"resizeWindow height param error");if(!this.window.isDestroyed()){this.window.setContentSize(Math.floor(e),Math.floor(i),false)}}getSize(){return this.window.getSize()}setPosition(e,i){Assert(typeof e=="number","setWinPosition x param error");Assert(typeof i=="number","setWinPosition y param error");if(!this.window.isDestroyed()){this.window.setPosition(e,i)}}getPosition(){return this.window.getPosition()}sendMessage(e,i){Assert(typeof e!="undefined","sendEvent, channel param error");Log.info(LOG_TAG,"winName[%s] send message channel[%s], arg[%s]",this.winName,e,i);if(this.window&&!this.window.isDestroyed()&&this.window.webContents!=null){this.window.webContents.send(e,i)}}openDevTools(){this.window.webContents.openDevTools()}hide(){if(this.window&&this.isWindowInvalid()){if(this.window.isFullScreen()){var e=this;this.window.once("leave-full-screen",function(){e.window.hide()});this.window.setFullScreen(false)}else{this.window.hide()}}}isHide(){if(this.window&&this.isWindowInvalid()){return!this.window.hasShadow()}return true}show(){if(this.window&&this.isWindowInvalid()){this.window.show();this.window.focus()}}focus(){if(this.window&&this.isWindowInvalid()){this.window.focus()}}close(){this.isApiCloseMode=true;if(this.window&&this.isWindowInvalid()){this.window.close()}}reload(){if(this.window&&this.isWindowInvalid()){this.window.reload()}}restore(){if(this.window&&this.isWindowInvalid()){this.window.restore()}}minimize(){if(this.window&&this.isWindowInvalid()){this.window.minimize()}}isMinimizable(){if(this.window&&this.isWindowInvalid()){this.window.isMinimizable()}}maximize(){if(this.window&&this.isWindowInvalid()){this.window.maximize()}}destroy(){if(this.loadTimer){clearTimeout(this.loadTimer);this.loadTimer=null}if(this.window&&this.isWindowInvalid()){this.window.destroy();this.window=null}}setIgnoreMouseEvents(){if(this.window&&this.isWindowInvalid()){this.window.setIgnoreMouseEvents(true)}}sendEventMsg(e,i){if(this.window&&!this.window.isDestroyed()&&this.window.webContents!=null){this.window.webContents.send(e,i);try{var n=JSON.parse(i);if(n.event!="tunnelFlow"&&n.event!="uploadFileChanged"&&n.event!="downloadFileChanged"){Log.info(LOG_TAG,"%s send event to webContents: %s message: %s",this.winName,e,i)}}catch(e){}}}isWindowInvalid(){if(this._isDestroyed){if(Is.object(this.delegate)&&Is.function(this.delegate.winWillCloseEvent)){this.delegate.winWillCloseEvent(this,"destroyed",true)}return false}else{return true}}openDevToolsBase(){if(fs.existsSync(this.openDevFlagFile)||fs.existsSync(Common.WINDOW_DEVTOOLS_FLAG_FILE)){this.window.webContents.openDevTools()}this.monitorOpenDevFlagFile(this.openDevFlagFile);this.monitorOpenDevFlagFile(Common.WINDOW_DEVTOOLS_FLAG_FILE)}monitorOpenDevFlagFile(i){let e={usePolling:false};if(os.platform()===Common.SYS_MAC){e.usePolling=true;e.invertal=3e3}const n=require("chokidar");let o=n.watch(i,e);o.on("all",(e,i)=>{if(e==="add"||e==="change"){Log.info(LOG_TAG,"%s file path[%s], will Open DevTools",e,i);this.window.webContents.openDevTools()}});o.on("error",e=>{Log.error(LOG_TAG,`file watcher failure, path[${i}] with error:`,e)})}static enhance(e){const i=["constructor","enhance","init","getSize","getPosition"];if(!(e instanceof BaseWindow)){Log.error(LOG_TAG,"The enhanced object is not browserwindow object, "+"returning to the original object");return e}for(const n of Reflect.ownKeys(e.__proto__)){if(i.indexOf(n)!=-1){Log.debug(LOG_TAG,`Not encapsulated by ${n} because it need a return value type`);continue}if(!is.function(e[n])){Log.debug(LOG_TAG,`The key(${n}) in the window object is not a `+`function, not a package`);continue}const o=e[n];e[n]=function(){if(e.window){return o.apply(e,arguments)}else{Log.warn(LOG_TAG,`Try to call the function(${n}) in the destroyed window`)}}}return e}}module.exports=BaseWindow;